      SUBROUTINE chd2AL(ISUM,LENX,ncol,nrow,LCchds,LcchdA,Nchds,
     +                  MXchd,IN,IOUT)
C
C-----VERSION  chd1AL
C     ******************************************************************
C     ALLOCATE ARRAY STORAGE FOR constant-head cells
C     ******************************************************************
C
C     SPECIFICATIONS:
C     ------------------------------------------------------------------
C     ------------------------------------------------------------------
C
C1------IDENTIFY PACKAGE AND INITIALIZE # OF GENERAL HEAD BOUNDS
      WRITE(IOUT,1)
    1 FORMAT(1H0,'chd2 -- chd PACKAGE, VERSION 1, 12/1/94')
      Nchds=0
C
C2------READ AND PRINT MXBND AND IchdCB (MAX # OF BOUNDS AND UNIT
C2------FOR CELL-BY-CELL FLOW TERMS FOR chd)
      READ(IN,2) MXchd
    2 FORMAT(2I10)
      WRITE(IOUT,3) MXchd
    3 FORMAT(1H ,'MAXIMUM OF',I5,' constant heads can be updated')
C
C3------SET LCBNDS EQUAL TO ADDRESS OF FIRST UNUSED SPACE IN X.
      LCchds=ISUM
C
C4------CALCULATE AMOUNT OF SPACE USED BY THE GENERAL HEAD LIST.
      ISP=5*MXchd
      LCchdA=ISUM+ISP
      ISP=ncol*nrow
      ISUM=ISUM+ISP
C
C5------PRINT AMOUNT OF SPACE USED BY THE chd PACKAGE
      WRITE(IOUT,4) ISP
    4 FORMAT(1X,I6,' ELEMENTS IN X ARRAY ARE USED FOR constant',
     1      '-head updates.')
      ISUM1=ISUM-1
      WRITE(IOUT,5) ISUM1,LENX
    5 FORMAT(1X,I6,' ELEMENTS OF X ARRAY USED OUT OF',I7)
      IF(ISUM1.GT.LENX) WRITE(IOUT,6)
    6 FORMAT(1X,'   ***X ARRAY MUST BE DIMENSIONED LARGER***')
C
C6------RETURN
      RETURN
      END
c_____________________________________________________________
c
      SUBROUTINE chd2RP(chds,nchds,mxchd,ibound,ncol,nrow,nlay,
     +                   in,iout, hnew,hold,buff)
C
C
C-----VERSION 1651 02FEB1983 chd1RP
C     ******************************************************************
C     READ DATA FOR chd
C     ******************************************************************
C
C     SPECIFICATIONS:
C     ------------------------------------------------------------------
      double precision hnew
      DIMENSION hnew(NCOL,NROW,NLAY),hold(NCOL,NROW,NLAY)
      DIMENSION chdS(5,MXchd), ibound(ncol,nrow,nlay)
      DIMENSION Buff(NCOL,NROW) 
	dimension rn(80)
      CHARACTER*24 ANAME
	CHARACTER*2048  txt, tx2
C
      DATA ANAME /'  Specified Head ARRAY2   '/
C     ------------------------------------------------------------------
C
C1------READ ITMP(# OF HEAD updates OR FLAG TO REUSE DATA.)
      READ(IN,'(a)')  txt
	call caps(txt,256)
C
c  Is this standard time-varying specified heads or pulse head changes? 
      kPULSE = index(txt,'STEPADD')
      kCHANGE = index(txt,'STEPCHANGE')
c
c  Check if head changes will be read by layer instead of list 
      kA1 = index(txt,'LAYERS:')
	if( kA1.gt.0 ) then
	  ITMP = nrow*ncol
        chdexp = 0.00
        tx2 = txt(kA1+7:2048)
        call qread(rn,2,tx2,ierr)
	  kA1 = ifrl( rn(1) )
	  kA2 = ifrl( rn(2) )
	  if( ierr.gt.0 ) kA2 = kA1    
	else
        read(txt,'(I10)') ITMP 
	endif
C2------TEST ITMP
      IF(ITMP.GE.0) GO TO 50
C
C2A-----IF ITMP<0 THEN REUSE DATA FROM LAST STRESS PERIOD
      WRITE(IOUT,7)
    7 FORMAT(1H0,'REUSING HEAD-updates FROM LAST STRESS',
     1      ' PERIOD')
      GO TO 260
C
C3------IF ITMP=>0 THEN IT IS THE # OF HEAD .
   50 Nchds = ITMP
C
C4------IF MAX NUMBER OF BOUNDS IS EXCEEDED THEN STOP
      if( nchds .gt. mxchd ) then
        WRITE(IOUT,99) nchds,MXchd
   99   FORMAT(1H0,'NCHD(',I4,') IS GREATER THAN MXchd(',I4,')')
C
C4A-----ABNORMAL STOP
        STOP'  Abnormal Stop!!!!!!!'
      endif
C
C5------PRINT # OF GENERAL HEAD BOUNDS THIS STRESS PERIOD
      WRITE(IOUT,1) nchds, kChange 
    1 FORMAT(1H0,//1X,I5,' HEAD-DEPENDENT BOUNDARY NODES', 
     +       i10,' >0 and absolute head replacement occurs') 
C
C6------IF THERE ARE NO HEADS THEN RETURN.
      IF(nchds.EQ.0) GO TO 260
C
C7------READ & PRINT DATA FOR EACH SPECIFIED HEAD BOUNDARY.
      WRITE(IOUT,3)
    3 FORMAT(1H0,15X,'LAYER',5X,'ROW',5X
     1,'COL   STRT HEAD   ENDING HEAD   BOUND NO.'/1X,15X,60('-'))
c
	if( kA1.gt.0 ) then
	  nchds = 0
	  do kk = kA1, kA2
          CALL U2DREL(Buff,ANAME,NROW,NCOL,kk,IN,IOUT)
          do jj = 1,nrow
            do ii = 1,ncol
	        nchds = nchds + 1
              chds(1,nchds) = kk
              chds(2,nchds) = jj
              chds(3,nchds) = ii
              chds(4,nchds) = buff(ii,jj)
              chds(5,nchds) = buff(ii,jj)
              if( ibound(ii,jj,kk).ne.0 ) then  
                if( kPULSE.gt.0 ) then
                  hnew(ii,jj,kk) = hnew(ii,jj,kk) + buff(ii,jj)
                elseif( kCHANGE.gt.0 ) then
                  hnew(ii,jj,kk) = buff(ii,jj)
                else
                  ibound(ii,jj,kk) = -iabs(ibound(ii,jj,kk))
                endif
              else
                nchds = nchds - 1
              endif
            enddo 
          enddo 
        enddo 
	else
        DO II = 1, nchds
          READ (IN,'(3I10,2F10.0)') K,I,J,chds(4,II),chds(5,II)
          chds(5,II) = chds(4,II)
          WRITE (IOUT,5) K,I,J,chdS(4,II),chdS(5,II),II
    5     FORMAT(1X,15X,I4,I9,I8,G13.4,G14.4,I8)
          chds(1,II)=K
          chds(2,II)=I
          chds(3,II)=J
          if( ibound(j,i,k).ne.0 ) then
            if( kPULSE.gt.0 ) then
              hnew(j,i,k) = hnew(j,i,k) + chdS(4,II)
            elseif( kCHANGE.gt.0 ) then
              hnew(j,i,k) = chdS(4,II)
            else
              ibound(j,i,k) = -iabs(ibound(j,i,k))
            endif
	    endif
        enddo 
	endif
c
C
c  Set NCHDS to 0 if these are  pulse head changes.  
      if( kPULSE.gt.0 .or. kCHANGE.gt.0 ) nchds = 0
C
C8------RETURN
  260 RETURN
      END
