      SUBROUTINE chd3AL(IN,IOUT)
C
C-----VERSION  chd1AL
C     ******************************************************************
C     ALLOCATE ARRAY STORAGE FOR constant-head cells
C     ******************************************************************
C
C     SPECIFICATIONS:
C     ------------------------------------------------------------------
C     ------------------------------------------------------------------
C
C1------IDENTIFY PACKAGE AND INITIALIZE # OF GENERAL HEAD BOUNDS
      WRITE(IOUT,1)
    1 FORMAT(1H0,'chd3 -- Boom adder PACKAGE, V1, 4/30/2004')
      Nchds=0
C
C2------READ AND PRINT MXBND AND IchdCB (MAX # OF BOUNDS AND UNIT
C2------FOR CELL-BY-CELL FLOW TERMS FOR chd)
      READ(IN,*) 
	MXchd = 200 
      WRITE(IOUT,3) MXchd
    3 FORMAT(1H ,'MAXIMUM OF',I5,' constant heads can be updated')
C
      WRITE(IOUT,4) 0
    4 FORMAT(1X,I6,' ELEMENTS IN X ARRAY ARE USED FOR constant',
     1      '-head updates.')
C
      RETURN
      END
c__________________________________________________________________
c
      SUBROUTINE chd3RP(ibound,ncol,nrow,nlay,in,iout, hnew,hold)
C
C
C-----VERSION 1651 02FEB1983 chd1RP
C     ******************************************************************
C     READ DATA FOR chd
C     ******************************************************************
C
C     SPECIFICATIONS:
C     ------------------------------------------------------------------
      include 'optim.h'
      common /mod1/ dxm(lx),xc(lx),xe(lx1),dym(ly),yc(ly),ye(ly1)
      common /mod2/ dzm(lxyz),zc(lxyz)
      common /mod3/ ix,iy,iz,ixyz,ixy,iper, izpls
      double precision hnew
      DIMENSION hnew(NCOL,NROW,NLAY),hold(NCOL,NROW,NLAY)
      DIMENSION ibound(ncol,nrow,nlay)
	dimension rn(80)
	CHARACTER*2048  txt, tx2
C
C     ------------------------------------------------------------------
C
C1------READ ITMP(# OF HEAD updates OR FLAG TO REUSE DATA.)
      READ(IN,'(i10,f10.0)') ITMP, Expon 
	if( abs(Expon).lt.0.001 ) Expon = 1.0000
C2------TEST ITMP
      IF(ITMP.GE.0) GO TO 50
C
C2A-----IF ITMP<0 THEN REUSE DATA FROM LAST STRESS PERIOD
      WRITE(IOUT,7)
    7 FORMAT(1H0,'REUSING HEAD-updates FROM LAST STRESS',
     1      ' PERIOD')
      GO TO 260
C
C3------IF ITMP=>0 THEN IT IS THE # OF HEAD .
   50 Nchds = ITMP
C
C5------PRINT # OF GENERAL HEAD BOUNDS THIS STRESS PERIOD
      kChange = -1
      WRITE(IOUT,1) nchds, Expon
    1 FORMAT(1H0,//1X,I5,' HEAD-DEPENDENT BOUNDARY NODES', 
     +       f10.4,' Exponent for Boom factor ') 
C
C6------IF THERE ARE NO HEADS THEN RETURN.
      IF(nchds.EQ.0) GO TO 260
C
C7------READ & PRINT DATA FOR EACH SPECIFIED HEAD BOUNDARY.
      WRITE(IOUT,3)
    3 FORMAT(1H0,15X,'LAYER',5X,'ROW',5X
     1,'COL   STRT HEAD   ENDING HEAD   BOUND NO.'/1X,15X,60('-'))
c
      DO LV = 1, nchds
        READ (IN,'(3I10,2F10.0)') K,J,I,Peak 
        WRITE (IOUT,'(10x,3i10,G13.4,I8)') K,J,I,Peak,LV
        nPeak = (k-1)*ncol*nrow + (j-1)*ncol + i	  
c   Compute Boom factor
        if( J+I .eq. 2 ) then
	    Slope = Peak
        else
          do kk = 1,nlay
            do jj = 1,nrow
	        dy = yc(jj) - yc(J)
              do ii = 1,ncol
                if( ibound(ii,jj,kk).ne.0 ) then
                  n = (kk-1)*ncol*nrow + (jj-1)*ncol + ii	  
                  dx = xc(ii) - xc(I)
                  dz = zc(n) - zc(nPeak)
                  R  = (dx**2 + dy**2 + dz**2)**0.5
                  Dhead = Peak * (1.00 - R*Slope/Peak)**Expon
                  if( Dhead/Slope .gt. 0.000 ) then
                    hnew(ii,jj,kk) = hnew(ii,jj,kk) + Dhead
                  endif
                endif
              enddo 
            enddo 
          enddo 
	  endif
	enddo
c
  260 RETURN
      END
