c_____________________________________________________________________
c
      integer function itxend( txt )
      character*256 txt
      k = 256
      do while( txt(k:k).eq.' ' .and. k.gt.1 )
        k = k - 1
      enddo
      itxend = k
c
      return
      end
c
c_____________________________________________________________________
c
      integer function ifrl( r )
      ip = abs(r) + 0.5
      if( r .lt. 0.000 )  ip = -ip
      ifrl = ip
      return
      end
c
c_____________________________________________________________________
c
c   NCREAD: reads lines of input and ignores lines that begin with a "#" sign.
c          All information after a ! is wiped from the input card.
      subroutine ncread(io,txt,ierr)
      character*128  afile
      character*256  txt,tx2
      data ioflip,ioalt /69,69/
c
      ierr = 0
    5 read(io,'(a)',end=10)  txt
      if( txt(1:1) .eq. '#' )  goto 5
c
      ki = index(txt,'!')
      if( ki.gt.0 ) then
        txt(ki:256) = '                                                '
      endif
c
      tx2 = txt
      call caps(tx2,256)
c
c    Test for switching control to an auxillary input file
c
      ki = index(txt,':')
      if( index(tx2,'REDIRECT').gt.0 .and. ki.gt.0 ) then
        afile = txt(ki+1:256)
        ki = index(afile,'  ') - 1
        iohold = io
        io = ioflip
        ioflip = iohold
        open(io,file=afile(1:ki),status='OLD',err=20)
        goto 5
      endif
c
c    Test for returning io control from auxillary input to master input file
c
      if( index(tx2,'RETURN')  .gt.0 .and.
     +    index(tx2,'CONTROL') .gt.0      ) goto 10
c
      ki = index(tx2,'<END>')
      if( ki .gt. 0 ) then
        ierr = 1
        txt(ki+5:256) = '                                           '
      endif
c
      if( index(tx2,'<STOP>') .gt. 0 ) ierr = 2
      return
c
c    Report error in opening auxillary input file and stop MODOPTIM
c
   20 write(*,*)
      write(*,*) '  ERROR opening auxillary input file  '
      write(*,*)
      write(*,'(2x,10h The file:,2x,a40,16h does not exist.)')  afile
      write(*,*)
      stop ' '
c
   10 txt(1:3) = 'EOF'
      if( io .eq. ioalt ) then
        close(io)
        iohold = io
        io = ioflip
        ioflip = iohold
        goto 5
        else
        ierr = -1
      endif
c
      return
      end
c
c_____________________________________________________________________
c
      subroutine shorten(txt,test,n,tx2)
      character*256 txt,tx2,test
c
      tx2 = '???????'
      ki = index(txt,test(1:n))
      if(ki.gt.0) then
        tx2 = txt(ki:256)
        kc = index(tx2,':')+1
        tx2 = tx2(kc:256)
        kc = index(tx2,':')+1
        if( kc .gt. 1 ) tx2 = tx2(1:kc-1)
      endif
      return
      end
c
c_____________________________________________________________________
c
      subroutine conden(txt,n)
      character*256 txt
      if(n.gt.64) n=64
      do  i=1,256-n
        txt(n+i:n+i)=' '
      enddo
c
      l=0
      do 10 k=1,n*2
      l=l+1
      if(txt(l:l).eq.' ')then
      do m=l,n
        txt(m:m)=txt(m+1:m+1)
      enddo
      l=l-1
      endif
   10 continue
      return
      end
c
c_____________________________________________________________________
c
      subroutine bakped(n,io)
c
      do i=1,n
        backspace(io)
      enddo
c
      return
      end
c
c_____________________________________________________________________
c
      subroutine qread(r,ni,ain,ierr)
      parameter (mrnv=25)
      dimension r(mrnv)
      character*1   tab
      character*16  form
      character*256 a256,ain
      tab = char(9)
      maxalp = 256 
c
c   r(ni+1) records the number of non-numeric entries that were attempted to be read as a number
c   r(ni+2) records the last column that was read from the card
c
      r(ni+1) = -1.0000
      a256 = ain
      do i = 1, maxalp - 1
        if( a256(i:i).eq.tab ) a256(i:i) = ' '
        if( a256(i:i).eq.',' ) a256(i:i) = ' '
        if( a256(i:i).eq.':' ) a256(i:i) = ' '
        if( a256(i:i).eq.'=' ) a256(i:i) = ' '
      enddo
      a256(maxalp:maxalp) = ' '
      n = 1
      i = 0
   11 r(ni+1) = r(ni+1) + 1
   10 i = i+1
      if( i.ge.maxalp) goto 15
      if( a256(i:i).eq.' ' ) then
        a256(i:i) = '?'
        goto 10
      endif
c
      ki = index(a256,' ')-1
      nd = ki - i + 1
      form ='(F??.0)              '
      write(form(3:4),'(i2.2)') nd
CERB  Fix for bug that caused i to be incremented by only 1 position
CERB  each time the read statement returns an error.  This bug also
CERB  incremented r(ni+1) unnecessarily.  With Lahey-compiled code, the
CERB  buggy version would read a final E in a word (without returning an
CERB  error) as a zero.
      READ (A256(I:KI),FORM,ERR=13,IOSTAT=ISTAT) R(N)
   13 CONTINUE
      i = ki
      IF (ISTAT.GT.0) GOTO 11  ! PART OF BUG FIX -- ERB
      n = n+1
      if( n.le.ni .and. i.lt.maxalp) goto 10
c
  15  n  = n-1
      ierr = ni - n
      r(ni+2) = i
      return
      end

