      program modoptim
      include 'optim.h'
      common /par1a/ npar,mxgb,cfi
      common /par7/ dermin,maxit,smin
      common /grad3/ dp(ma),rhs(ma),tm2(ma,ma),ipo,ipl
      common /grad4/ err,err0,rmse,errdiv,iter,errl,avg,sdev
c
      call optin (kutout,ioufh,cormin,isense,rotrad,aniso,kzint,q3dthk)
c
c    if MAXIT > 0 and isense > 0, compute error vs. parmater change tables.
c
      if( maxit.gt.0 .and. isense.gt.0 ) then
        write(*,*)
        write(*,*)' Computing sensitivity for U-plots. '
        write(*,*)
        call Uplot(maxit, dermin, isense,rotrad,aniso, kzint,q3dthk)
        write(*,*)
        write(*,*)
        stop'U-plot tables are in the master optimization & resid files'
      endif
c
c    if MAXIT < 0 then compute sensitivity maps
c
      if( maxit.lt.0 ) then
        write(*,*)
        write(*,*)' Computing sensitivity maps as per OC file specs.'
        write(*,*)
        call error(isense, rotrad,aniso,kzint,q3dthk)     
        call cpyufh(ioufh, ioufhb) 
        call spacen( ioufh, ioufhb )
        write(*,*)
        write(*,*)'   An unformatted head difference file exits '
        write(*,*)'   for each parameter.  '
        write(*,*)
        stop'   Sensitivity arrays in <(Ptag)(Pname).usn> files '
      endif
c
c   if MAXIT >= 0 and isense = 0, minimize objective function
c
      errl = 1.0e25     
      icnt = 0
c        
      do i = 0, maxit+2
        call error(isense, rotrad,aniso,kzint,q3dthk)           
        if( ipl.eq.ipo  .and. err.gt.errl .and. 
     +      icnstr.eq.0 .and. icnt.lt.2        ) then     
          icnt = icnt + 1
          call ovrshoot( icnt, kutout )  
        else  
          icnt = 0
          if( i.eq.0 ) then 
            iter = 0
            ipo = npar 
          endif
          ipl = ipo
          call output(cormin)
          call conver
c        
c   beginning of new iteration.
c        
          call jacob(1,npar,rotrad,aniso )  !Compute gradients for each parameter and Jacobian matrix
          call rank     
          call hessup
          call stpchk(kutout,icnstr)  
        endif  
      enddo      
      stop'  End of MODOPTIM '
      end
c
c_________________________________________________________________________
c
C UPLOT:       calculates RMS error for sensitivity plots
C
      subroutine Uplot(nUpts,halfrange,isense,rotrad,aniso,kzint,q3dthk)
      include 'optim.h'
c
      common /comp1/ xo(mop),yo(mop),zo(mop),TIMo(mop),nobs,kobsbk
      common /comp2/ obs(mop),calc(mop3),calcl(mop),wgt(mop*2),res(mop)
      common /unit1/ iu5,iu6,iu7,iu8,iu9,kikoff,iures, iuparm
      common /par1/ parb(ma,mgb),par(ma),ptype(ma),ptag(ma),pinfo(ma)
     +             ,palast(ma)
      common /par1a/ npar,mxgb,cfi
      common /par3/ up(ma),down(ma),smax,step(ma),stfrc
      common /grad1/ gr1(ma),gr1l(ma),grss(mop,ma),fir(ma,ma)
      common /grad2/ gr2(ma),secd(ma,ma),wk(ma,ma)
      common /grad3/ dp(ma),rhs(ma),tm2(ma,ma),ipo,ipl
      common /grad4/ err,err0,rmse,errdiv,iter,errl,avg,sdev
      common /choke1/ lab(ma)
      common /modvol1/ PDIFFV, PDIFFR  
      character*4  ptype, ptag, pinfo
c
c   Perturb model for each parameter to generate U-plots.
c
      write(iu8,'(/,26(3h<U>))' )
      alghlf = alog10(halfrange)
c
      dinc = 2*alghlf / (nUpts-1) 
c
      do jj = 1, npar
        pinfo(jj) = 'PNEN'
        if( lab(jj).lt.2  ) then
          write(*,*) 
          write(iu8,*) 
          do j = 1, nUpts
            dpp   = dinc*(j-1) - alghlf 
            par(jj)= par(jj) + dpp
            value = parval(down(jj),par(jj),up(jj),pinfo(jj))
            call error(isense,rotrad,aniso,kzint,q3dthk) 
c
            write(*,'(4x,2i4,2(2x,a4),3g12.5)') 
     +       jj,j, ptag(jj), ptype(jj), value, rmse, pdiffv
            write(iu8,'(4x,2i4,2(2x,a4),3g12.5)') 
     +       jj,j, ptag(jj), ptype(jj), value, rmse, pdiffv
            par(jj) = par(jj) - dpp
c
c    store rms, pdiffv, and parameter values in the grss matrix
c
            grss(j        ,jj) = rmse   
            grss(j+  nUpts,jj) = pdiffv  
            grss(j+2*nUpts,jj) = value  
c
          enddo
        endif
      enddo
c
c    Write  rms, pdiffv, and parameter values to the residual file
c
      do ii = 1, 3
        ko = (ii-1)*nUpts  
        write(iures,'(//201a12)') 'RATIO',( ptag(jj), jj=1,npar ) 
        write(iures,'(  201a12)') 'RATIO',(ptype(jj), jj=1,npar ) 
        do j = 1, nUpts
          dpp   = dinc*(j-1) - alghlf 
          rat = 10**dpp
          write(iures,'(  f12.5,200g12.5)') 
     +      rat, (grss(j+ko,jj), jj=1,npar) 
        enddo
      enddo
c
      return
      end
c
c_________________________________________________________________________
c
      subroutine cpyufh(ioufh, ioufhb) 
      include 'optim.h'
      common /mod3/ ix,iy,iz,ixyz,ixy,iper
      common /par5/ work(lxyz),izwrk(lxyz),ptime(msp)
      dimension text(4)
c
      ioufhb = 69
      open(ioufhb, status='scratch', form='unformatted', err=99)
      rewind(ioufh  )
c
  20  read(ioufh,end=30)  KSTP,KPER,PERTIM,TOTIM,TEXT,kx,ky,kz
      write(ioufhb)       KSTP,KPER,PERTIM,TOTIM,TEXT,kx,ky,kz
      ne = ix*iy
      nb = ne -ix*iy + 1
      read(ioufh)  (work(n), n=nb,ne)
      write(ioufhb)(work(n), n=nb,ne)
      goto 20
c
   30 return 
   99 stop ' Error in opening base run Unformatted head file. '
      end
c
c_________________________________________________________________________
c
      subroutine spacen( ioufh, ioufhb)
      include 'optim.h'
c
      common /comp2/ obs(mop),calc(mop3),calcl(mop),wgt(mop*2),res(mop)
      common /unit1/ iu5,iu6,iu7,iu8,iu9,kikoff,iures, iuparm
      common /par1/ parb(ma,mgb),par(ma),ptype(ma),ptag(ma),pinfo(ma)
     .             ,palast(ma)
      common /par1a/ npar,mxgb,cfi
      common /par2/ izone(mgb),igbact(ma,mgb),iglact(ma),ngbpa(ma),
     +              izcube(lxyz), igbsp(ma,msp)
      common /par3/ up(ma),down(ma),smax,step(ma),stfrc
      common /par4/ weight(mwgt),iwp(ma2)
      common /par5/ work(lxyz),izwrk(lxyz),ptime(msp)
      common /mod3/ ix,iy,iz,ixyz,ixy,iper
      common /mod4/ pname(nall),ixpnam(nall),iuo(nall),iuv(nall)
      common /choke1/ lab(ma)
      character*4  ptype, ptag, pinfo
      character*16 text 
c
c     numerical gradient computation
c
      do j = 1, npar
        dpp   = cfi
        value = parval(down(j),par(j),up(j),pinfo(j))
        par(j)= par(j) + dpp
c
        call update
c
        write(*,'(4x,i4,2x,21h- Calling MODFLOW for,
     +      12h parameter: ,a4,2h =,g12.5,2x,6hType: ,a4,i4)') 
     +       j, ptag(j), value, ptype(j),lab(j)
        call modflow( iu5, iu6, iuv, 0, 0 ) 
        par(j) = par(j) - dpp
c
c   Compute sensitivity array for the model domain .........
c
        rewind( ioufh  )
        rewind( ioufhb )
c  open file to write sensitivity array format ...............
        text = ptag(j)//ptype(j)//'.usn' 
        do ib = 1,8
          if(text(ib:ib).eq.' ' ) text(ib:ib) = '_'          
        enddo
        open(ioufhb-1, file=text, form='unformatted', status='unknown' ) 
c
        do while( n .lt. 2*ixyz )
          read(ioufh,end=30)  KSTP,KPER,PERTIM,TOTIM,TEXT,kx,ky,kz
          read(ioufhb,end=30) KSTP,KPER,PERTIM,TOTIM,TEXT,kx,ky,kz
          write(ioufhb-1)     KSTP,KPER,PERTIM,TOTIM,TEXT,kx,ky,kz
          read(ioufh)  (work(n),    n=1,ixy)
          read(ioufhb) (work(n+ixy),n=1,ixy)
c
          do n = 1, ixy
            work(n) = work(n) - work(n+ixy)
          enddo
          write(ioufhb-1) (work(n),n=1,ixy)
        enddo 
   30   close(ioufhb-1) 
c 
      enddo
c
      return
      end
c
c_________________________________________________________________________
c
C
C JACOB:       calculates GRSS, the partial derivative of calculated values
C      at all comparison points with respect to parameter change, which is
C      a NOBS x NPAR matrix.  (It is also known as a sensitivity or
C      covariance matrix.)  The first order component of the Hessian,
C                T                              T
C      FIR = GRSS GRSS, and gradient, GR1 = GRSS (RES*WGT), are computed
C      also.
C
C            The model is run NPAR times with one parameter perturbed each
C      time.  The difference between these runs and the base run provide
C      the basis for GRSS(i,j) = (CALC(i) -CALCL(i) ) / TST.
C                                        j         j
C
      subroutine jacob(nbeg,nend, rotrad, aniso)
      include 'optim.h'
c
      common /comp1/ xo(mop),yo(mop),zo(mop),TIMo(mop),nobs,kobsbk
      common /comp2/ obs(mop),calc(mop3),calcl(mop),wgt(mop*2),res(mop)
      common /unit1/ iu5,iu6,iu7,iu8,iu9,kikoff,iures, iuparm
      common /par1/ parb(ma,mgb),par(ma),ptype(ma),ptag(ma),pinfo(ma)
     +             ,palast(ma)
      common /par1a/ npar,mxgb,cfi
      common /par3/ up(ma),down(ma),smax,step(ma),stfrc
      common /grad1/ gr1(ma),gr1l(ma),grss(mop,ma),fir(ma,ma)
      common /grad2/ gr2(ma),secd(ma,ma),wk(ma,ma)
      common /grad3/ dp(ma),rhs(ma),tm2(ma,ma),ipo,ipl
      common /grad4/ err,err0,rmse,errdiv,iter,errl,avg,sdev
      common /mod4/ pname(nall),ixpnam(nall),iuo(nall),iuv(nall)
      common /choke1/ lab(ma)
      character*4  ptype, ptag, pinfo, pname
c
c   Move current change info to last vectors before estimating new gradients
c
      do j = 1, npar 
        gr1l(j) = gr1(j)
      enddo
c
c  If estimating angular rotation of model for lateral anisotropy,
c  identify pointer for parameter.    
c
      jrot  = 0
      if( rotrad.lt.1.0e9 ) jrot  = ifrl(rotrad)  
      j2rot = 0
      if( aniso .gt.0.000 ) j2rot = ifrl(aniso)  
c
c     numerical gradient computation
c
      do j=nbeg,nend
        if( lab(j).lt.2 .and. pinfo(j)(2:2).ne.'Z' ) then
          value = parval(down(j),par(j),up(j),pinfo(j))
          dpp   = cfi
          if( j.eq.jrot .or. j.eq.j2rot ) then
            if( j.eq.j2rot ) dpp = dpp * 10
            moff = 1
            if( j.eq.j2rot ) moff = 2
            do i=1,nobs
              calc(i) = calc( i + moff*mop) 
            enddo
c       Calculate differences between simulateed observations where requested  
            call pasdif  !!  Differenced observations are calculated by PASDIF
            write(*,'(4x,i4,2x,21h---------------------,
     +      12h parameter: ,a4,2h =,g12.5,2x,6hType: ,a4,i4)') 
     +       j, ptag(j), value, ptype(j),lab(j)
          else
            if(gr1(j).gt.0.0)  dpp = -cfi
            par(j)= par(j) + dpp
            call update
            write(*,'(4x,i4,2x,21h- Calling MODFLOW for,
     +      12h parameter: ,a4,2h =,g12.5,2x,6hType: ,a4,i4)') 
     +       j, ptag(j), value, ptype(j),lab(j)
            call modflow( iu5, iu6, iuv, 0, 0 ) 
            par(j) = par(j) - dpp
          endif
c         
          sum=0.00000000000000
          do i=1,nobs
            wt = wgt(i+nsign(res(i))*mop)  
            grss(i,j) = wt * (calc(i)-calcl(i)) / dpp
            sum = sum + grss(i,j)*res(i)*wt
          enddo
        else
          value = parval(down(j),par(j),up(j),pinfo(j))
          write(*,'(4x,23h         NOT ESTIMATING,i4,
     +      12h parameter: ,a4,2h =,g12.5,2x,6hType: ,a4)') 
     +       j, ptag(j), value, ptype(j)
          sum = 0.00000000000000
          do i=1,nobs
            grss(i,j) = 0.000
          enddo
        endif
c     computation of g  ie: j transpose x error vector
        gr1(j) = sum
        rhs(j) = -gr1(j)
        gr2(j) = gr1(j) - gr1l(j)
      enddo
c
c                T
c     calculate J J for first order information in g(x)
c
      do ir=1,nend
        do ic=1,nend
          sum=0.
          do j=1,nobs
            sum=sum+grss(j,ir)*grss(j,ic)
          enddo
          fir(ir,ic) = sum
        enddo
      enddo
c
      return
      end
c
c_________________________________________________________________________
c
C HESSUP:      updates the second order portion of the Hessian, SECD, and
C      forms the complete Hessian, Wk, used to solve for search direction
C      and length.
C                            Wk x dp = -gr1
C       where:
C
C                              1           T        1           T
C         SECD   = SECD  - -------- W dp dp W  + ------- gr2 gr2
C             k+1      k     T       k  k  k k      T       k   k
C                          dp W dp               gr2 dp
C                            k k  k                 k  k
C
C       Where,
C                      T
C             W  = GRSS   GRSS    + SECD
C              k       k+1    k+1       k
C             k = iteration index
C
      subroutine hessup
      include 'optim.h'
c
      common /unit1/ iu5,iu6,iu7,iu8,iu9,kikoff,iures, iuparm
      common /par1/ parb(ma,mgb),par(ma),ptype(ma),ptag(ma),pinfo(ma)
     +             ,palast(ma)
      common /par3/ up(ma),down(ma),smax,step(ma),stfrc
      common /par3a/ rkmin,frcsec
c
      common /grad1/ gr1(ma),gr1l(ma),grss(mop,ma),fir(ma,ma)
      common /grad2/ gr2(ma),secd(ma,ma),wk(ma,ma)
      common /grad3/ dp(ma),rhs(ma),tm2(ma,ma),ipo,ipl
      common /grad4/ err,err0,rmse,errdiv,iter,errl,avg,sdev
      common /grad5/ yts,stws,gtp,gtpl
      common /choke1/ lab(ma)
c
      zero = 1.e-4
      yts  = 0.
      gtp  = 0.
      stws = 0.    
c      
      do j=1,ipo
        ws=0.0000000000000000000
        yts = yts + dp(j)   * gr2(j)
        gtp = gtp + gr1l(j) * dp(j)
        do i=1,ipo
          tm2(j,i) = dp(i) * dp(j)
          wk(j,i)  = secd(j,i) + fir(j,i)
          ws       = ws + wk(j,i) * dp(i)       
        enddo  
        stws = stws + ws * dp(j)
      enddo
c
      call sqmat(wk,tm2,ipo)
      call sqmat(tm2,wk,ipo)
      do j=1,ipo
        do i=1,ipo
          t1 = secd(j,i)
          t2 = 0.
          if( stws.gt.zero ) t2 = -wk(j,i) / stws
          t3 = 0.0
          if( yts**2 .gt. zero ) t3 = gr2(j) * gr2(i) / yts
          secd(j,i) = t1 + t2 + t3
          if( stws.lt.zero .or. ipo.ne.ipl .or. err.gt.errl ) then
            secd(j,i) = 0.000000
            if( j.eq.i ) secd(j,i) = fir(1,1) * frcsec
          endif
          wk(j,i) = fir(j,i) + secd(j,i)
        enddo
      enddo
c          
      return
      end
c
c_________________________________________________________________________
c
C RANK:      determines rank of problem based on FIR and reorders all
C      parameters from most to least significant.
C
c
      subroutine rank
      include 'optim.h'
c
      common /comp1/ xo(mop),yo(mop),zo(mop),TIMo(mop),nobs,kobsbk
      common /unit1/ iu5,iu6,iu7,iu8,iu9,kikoff,iures, iuparm
      common /par1/ parb(ma,mgb),par(ma),ptype(ma),ptag(ma),pinfo(ma)
     +             ,palast(ma)
      common /par1a/ npar,mxgb,cfi
      common /par2/ izone(mgb),igbact(ma,mgb),iglact(ma),ngbpa(ma),
     +              izcube(lxyz), igbsp(ma,msp)
      common /par3/ up(ma),down(ma),smax,step(ma),stfrc
      common /par3a/ rkmin,frcsec
      common /grad1/ gr1(ma),gr1l(ma),grss(mop,ma),fir(ma,ma)
      common /grad2/ gr2(ma),secd(ma,ma),wk(ma,ma)
      common /grad3/ dp(ma),rhs(ma),tm2(ma,ma),ipo,ipl
      common /mod3/ ix,iy,iz,ixyz,ixy,iper
      common /choke1/ lab(ma)
      character*4  ptype,ptag,pinfo
      dimension iv(ma),dum(ma)
      zero = 1.e-3 * rkmin
c
      do i=1,npar
        dum(i) = fir(i,i)
        if(lab(i) .ge. 1 ) dum(i) = 0.0
        iv(i)=i
      enddo
      iswtch=0
c
c     rank parameter sensitivity from highest to lowest
c
      do i=1,npar-1
        do j=1,npar-1
          m=iv(j)
          m1=iv(j+1)
          if( dum(m) .lt. dum(m1) ) then
            iswtch=1
            iv(j)=m1
            iv(j+1)=m
          endif
        enddo
      enddo
c
      if(iswtch.ne.0) then 
        call order1(par,iv,npar)
        call order1(palast,iv,npar)
        call order1(up,iv,npar)
        call order1(down,iv,npar)
        call order1(gr1,iv,npar)
        call order1(gr1l,iv,npar)
        call order1(gr2,iv,npar)
        call order1(dp,iv,npar)
        call order1(rhs,iv,npar)
        call order1(dum,iv,npar)
        call order1(step,iv,npar)
        call ordei1(iglact,iv,npar)
        call ordei1(lab,iv,npar)
        call ordei1(ngbpa,iv,npar)
        call ordea1(ptype,iv,npar)
        call ordea1(ptag,iv,npar)
        call ordea1(pinfo,iv,npar)
        call order2(fir,iv,npar,npar)
        call order2(secd,iv,npar,npar)
        call order2(wk,iv,npar,npar)
        call ordgb2(parb,iv,npar,mxgb)
        call ordnb2(grss,iv,nobs,npar)
        call ordei2(igbact,iv,npar,mxgb)
        call ordii2(igbsp,iv,npar,iper)
      endif
c
      scale = fir(1,1)
      do j=1,npar
        if( dum(j) .gt. scale*rkmin) ipo = j 
      enddo 
c
      return
      end
c
c_________________________________________________________________________
c
C STPCHK:      solves optimization problem, checks step length and parameter
C      constraints, and increases magnitude of SECD if the step length
C      criteria is exceeded.
C
c
      subroutine stpchk(kutout,icnstr)
      include 'optim.h'
      common /unit1/ iu5,iu6,iu7,iu8,iu9,kikoff,iures, iuparm
      common /par1/ parb(ma,mgb),par(ma),ptype(ma),ptag(ma),pinfo(ma)
     +             ,palast(ma)
      common /par1a/ npar,mxgb,cfi
      common /par3/ up(ma),down(ma),smax,step(ma),stfrc
      common /par3a/ rkmin,frcsec
c
      common /grad1/ gr1(ma),gr1l(ma),grss(mop,ma),fir(ma,ma)
      common /grad2/ gr2(ma),secd(ma,ma),wk(ma,ma)
      common /grad3/ dp(ma),rhs(ma),tm2(ma,ma),ipo,ipl
      common /grad5/ yts,stws,gtp,gtpl
      common /choke1/ lab(ma)
      dimension rhso(ma)
      character*4  ptype,ptag,pinfo
      zero = 1.e-3
      newmax = npar
c
      do i=1,ipo
        rhso(i) = rhs(i)
      enddo
      ipass = 0
      newvec = 0
   10 ipass = ipass + 1
   15 continue 
c
c   calculate new search direction
c
      if( ipo.lt.1 ) stop '  Nothing to estimate '
      call gauss(wk,rhs,ipo)
c
c   see if limits are needed.
c
      alpha  = 1.0
      veclen = 0.0
c
      do i=1,ipo
        test = abs(rhs(i))
        test   = test * alpha
        veclen = veclen + rhs(i)**2
        if(test.gt.step(i)) alpha = alpha*step(i)/test
      enddo
      veclen = veclen**0.5
      if( wk(1,1) .lt. zero ) veclen = 10.*rkmin
c
c  If vector length is outrageously large, resolve with only first order matrix.
c
      if( veclen.gt. 1./rkmin .and. ipass.lt.2 ) then
        do i=1,ipo
          rhs(i) = rhso(i)
          do j=1,ipo
            wk(i,j) = fir(i,j)
          enddo
          wk(i,i) = wk(i,i) + fir(1,1)*frcsec
        enddo
        goto 10
      endif
c
      veclen = veclen*alpha
      frcmin = 1.00000000
      i0par  = 0
c
      do i = 1, ipo            !  Head of vector length test loop
        dp(i)  = alpha * rhs(i)
        plast  = par(i)
        par(i) = dp(i) + par(i)
c
c    Check if parameter limits have been exceeded and 
c    Check for reducing the vector length if limits are exceeded
c
        frc = veclim(i, plast) 
        if( frc.lt.0.000000 )  i0par = 1
c
        if( frc .lt. frcmin ) then
          frcmin = frc
          ipmin = i
        endif
c
c    Reset parameters that have re-entered solution domain 
c
        if( pinfo(i)(4:4) .eq. 'S' ) then
          top = 1.0000
          bot = 0.0000
        else
          top = up(i)
          bot = down(i)
        endif
c
        if(kutout.eq.1 .and. par(i).lt.top-zero .and. 
     +                       par(i).gt.bot+zero      ) lab(i)=0
c
        if(alpha .lt. (1.0-zero)) then
          do j=1,ipo
            secd(i,j) = secd(i,j) / alpha   
          enddo 
        endif
      enddo                    !  End of vector length test loop
c      
c    Shrink vector if hard bounds are exceeded
c
      if( frcmin.lt.1.0-zero .and. frcmin.gt.zero ) then
        icnstr = 1 
        lab(ipmin) = kutout
        do i=1,ipo
          par(i) = par(i) -  dp(i) 
          dp(i)  = frcmin * dp(i) 
          par(i) = dp(i) + par(i)
          do j=1,ipo
            secd(i,j) = secd(i,j) / frcmin    
          enddo 
        enddo
      elseif( frcmin.le.zero .and. newvec.le.newmax ) then 
        icnstr = 1 
c   cutout parameters against boundary, rank, and compute a new search vector
        if( i0par .eq. 1 )then
          lab(ipmin) = kutout
          pinfo(ipmin) = 'CZMN'
          par(ipmin) = 0.00000
          dp(ipmin)  = 0.00000
          up(ipmin)  = 0.00000
          down(ipmin)= 0.00000   
          fir(ipmin,ipmin) = rkmin * 0.1
        endif 
c
        do i=1,ipo
          rhs(i) = rhso(i)
          do j=1,ipo
            wk(i,j) = fir(i,j)
            secd(i,j) = 0.0000
          enddo
          secd(i,i)= fir(1,1)*frcsec
          wk(i,i)  = wk(i,i) + secd(i,i)
c   Reset parameters and estimate without variable that was cutout 
          par(i) = par(i) -  dp(i) 
        enddo
c
        do i = ipo+1,npar
          fir(i,i) = rkmin * 0.1
        enddo
        call rank
        do i=1,ipo
          rhso(i) = rhs(i)
        enddo
        newvec = newvec + 1
        goto 15
      else
        icnstr = 0 
      endif    
c      
      do i=1,ipo
        rhs(i) = rhso(i)
      enddo
c        
      return
      end
c
c_________________________________________________________________________
c
      function veclim(i, plast)
      include 'optim.h'
      common /par1/ parb(ma,mgb),par(ma),ptype(ma),ptag(ma),pinfo(ma)
     +             ,palast(ma)
      common /par3/ up(ma),down(ma),smax,step(ma),stfrc
      common /grad3/ dp(ma),rhs(ma),tm2(ma,ma),ipo,ipl
      common /choke1/ lab(ma)
      character*4  ptype,ptag,pinfo
c
c    Check if parameter limits have been exceeded and 
c    Check for reducing the vector length if limits are exceeded
c
        frc = 1.00000
        if( pinfo(i)(4:4) .eq. 'S' ) then
          top = 1.0000
          bot = 0.0000
        else
          top = up(i)
          bot = down(i)
        endif
c
        if( par(i) .ge. top ) then
          frc = ( top - plast ) / dp(i)
c   Check for zeroing a parameter that falls above the upper limit
          if(pinfo(i)(2:2).eq.'U'  )then
            frc    = -frc
          endif 
        endif
c
        if( par(i) .le. bot ) then
          frc = ( bot - plast ) / dp(i)
c   Check for zeroing a parameter that falls below the lower limit
          if(pinfo(i)(2:2).eq.'L' )then
            frc    = -frc
          endif 
        endif
c
      veclim = frc 
      return
      end
c
c_________________________________________________________________________
c
      subroutine ovrshoot(icnt,kutout) 
      include 'optim.h'
      common /unit1/ iu5,iu6,iu7,iu8,iu9,kikoff,iures, iuparm
      common /par1/ parb(ma,mgb),par(ma),ptype(ma),ptag(ma),pinfo(ma)
     +             ,palast(ma)
      common /par1a/ npar,mxgb,cfi
      common /par3/ up(ma),down(ma),smax,step(ma),stfrc
      common /par3a/ rkmin,frcsec
c
      common /grad1/ gr1(ma),gr1l(ma),grss(mop,ma),fir(ma,ma)
      common /grad2/ gr2(ma),secd(ma,ma),wk(ma,ma)
      common /grad3/ dp(ma),rhs(ma),tm2(ma,ma),ipo,ipl
      common /grad4/ err,err0,rmse,errdiv,iter,errl,avg,sdev
      common /choke1/ lab(ma)
      character*4  ptype,ptag,pinfo
       zero=1.e-4
c
c   Called if err is greater than errl.      
c
c     If icnt = 1, resolve with hessian reduced to Levenberg-Marquardt choke,
c
c     IF icnt = 2, use quadratic assumption and reduce step-length 
c                ___       ___     ___
c   by:  frc = \/ss1 / ( \/ss1 + \/ss2 ).
c
c     
c     Reset parameter position regardless of option. 
c
      do i=1,ipo
        par(i) = par(i) - dp(i)
      enddo                           
c
c  ICNT = 1 
c   reset Secd and wk matricies  and solve for new dp vector.  
c
      if( icnt.eq.1 ) then 
        do i=1,ipo
          do j=1,ipo     
            secd(i,j) = 0.0000
            wk(i,j) = fir(i,j)
          enddo
          secd(i,i) = fir(1,1)*frcsec
          wk(i,i) = wk(i,i) + fir(1,1)*frcsec
        enddo
c
c       calculate new search direction
c
        call gauss(wk,rhs,ipo)
c
c       see if limits are needed.
c
        alpha  = 1.0
        dismax = 0.0
        veclen = 0.0
        do i=1,ipo
          test = abs(rhs(i))
          if(test.gt.dismax) dismax = test
          test   = test * alpha
          veclen = veclen+rhs(i)**2
          if(test.gt.step(i)) alpha = alpha*step(i)/test
        enddo
        veclen = veclen**0.5
        if( wk(1,1) .lt. zero ) veclen = 10.*rkmin
c
        dismax = dismax*alpha
        veclen = veclen*alpha
        frcmin = 1.0000
        do i=1,ipo
          dp(i) = alpha*rhs(i)
          plast  = par(i)
          par(i) = dp(i) + par(i)
c
          frc = veclim(i, plast) 
          if( frc.lt.1.0-zero )  lab(i) = kutout
c
            if( abs(frc) .lt. abs(frcmin) ) then
              frcmin = frc
          endif
        enddo  
c
        if( frcmin.lt.1.0-zero .and. frcmin.gt.zero ) then
          do i=1,ipo
            par(i) = par(i) -  dp(i) 
            dp(i)  = abs(frcmin) * dp(i) 
            par(i) = dp(i) + par(i)
          enddo
        endif
      else  
c  ICNT = 2 
c   reduce veclen by quadratic assumption.   
c         
        ss1 = errl**0.5            
        ss2 = err**0.5            
        alpha = ss1 / (ss1+ss2)       
        veclen = veclen * alpha
        do i=1,ipo      
          dp(i)  = dp(i)*alpha
          par(i) = par(i) + dp(i)
        enddo                           
      endif
c      
      return
      end
c
c_________________________________________________________________________
c
C ERROR:      runs latest version of model and calculates the disparity
C      between the model and reality at iteration k.
c
c  >>>> IF estimating lateral anisotropy, compute sensitivity to rotation 
c          of observations about production well.
c
      subroutine error( isn, rotrad,aniso,kzint,q3dthk)    
      include 'optim.h'
c
      common /mod2a/obfrc(mop3,mobd),kfrc(mop3,mobd),kpotyp(mop)
      common /mod4/ pname(nall),ixpnam(nall),iuo(nall),iuv(nall)
      common /par1/ parb(ma,mgb),par(ma),ptype(ma),ptag(ma),pinfo(ma)
     +             ,palast(ma)
      common /par1a/ npar,mxgb,cfi
      common /par3/ up(ma),down(ma),smax,step(ma),stfrc
      common /par3a/ rkmin,frcsec
      common /par6/ nzones,nlines,nga
      common /comp1/ xo(mop),yo(mop),zo(mop),TIMo(mop),nobs,kobsbk
      common /comp2/ obs(mop),calc(mop3),calcl(mop),wgt(mop*2),res(mop)
      common /unit1/ iu5,iu6,iu7,iu8,iu9,kikoff,iures, iuparm
      common /grad4/ err,err0,rmse,errdiv,iter,errl,avg,sdev
      common /modvol1/ PDIFFV, PDIFFR  
      character*4 pname, ptype, ptag, pinfo 
      pi = 3.14159
      zero = 1.0E-24
c
      errdv2 = 0.000000
      istof1 = 0
      istof2 = 0
c
c   Update observation well positions if rotating ............
c
      if( rotrad.lt.1.0e9 ) then
        m = 1
        do while( 'SPIN' .ne. ptype(m) )
          m = m + 1
        enddo
        rotrad = parval(down(m),par(m),up(m),pinfo(m))*pi / 180.0
        istof1 = mop
c
        if( aniso .gt.zero ) then
          mm = 1
          do while( 'KYKX' .ne. ptype(mm) )
            mm = mm + 1
          enddo
          aniso = parval(down(mm),par(mm),up(mm),pinfo(mm)) 
        endif
c
        do i = 1, nobs
c     Rotate positions 
          call spinobs(xo(i),yo(i),xo(1),yo(1),rotrad,aniso, xot,yot)
          call frcass(kzint,xot,yot,zo(i),i,total,zero,q3dthk)
c     Rotate positions with a perturbation 
          radper = parval(down(m),par(m)+cfi,up(m),pinfo(m))*pi/180.
          call spinobs(xo(i),yo(i),xo(1),yo(1),radper,aniso, xot,yot)
          call frcass(kzint,xot,yot,zo(i),i+mop,total,zero,q3dthk)
        enddo
        rotrad = m
      endif
c
      if( aniso .gt.zero ) then
        m = 1
        do while( 'KYKX' .ne. ptype(m) )
          m = m + 1
        enddo
        aniso = parval(down(m),par(m),up(m),pinfo(m)) 
        istof2 = 2*mop
c
        do i = 1, nobs
c    Perturb Ky/Kx anisotropy if 2D, radial model  
          anispb = parval(down(m),par(m)+cfi,up(m),pinfo(m))
          call spinobs(xo(i),yo(i),xo(1),yo(1),rotrad,anispb, xot,yot)
          call frcass(kzint,xot,yot,zo(i),i+istof2,total,zero,q3dthk)
        enddo
        aniso = m
      endif
c
c  Simulate flow with current set of parameter estimates..
c
      call update
      if(isn.eq.0) write(*,*)
      if(isn.eq.0) write(*,*)'  Calling MODFLOW for base case. '
      call modflow( iu5, iu6, iuv, istof1, istof2) 
      if(isn.eq.0) 
     + write(*,'(24x,28hTotal mass balance error is:,f7.2,2h %)') pdiffv 
c
      sum=0.000000000000000000
      sav=0.000000000000000000
      do l = 1,nobs
        calcl(l)= calc(l)
        res(l)  = calc(l) - obs(l)
        wres    = res(l) * wgt(l+nsign(res(l))*mop)
        errdv2  = errdv2 + wgt(l+nsign(res(l))*mop)**2
        sav     = sav + wres
        sum     = sum + wres**2
      enddo        
      err = sum
      avg = sav / errdv2
      frc = errdv2 / nobs**2
      snum= sum*errdv2-sav**2
      if( snum .lt. zero ) snum = zero
      sdev= (snum/(errdv2*(errdv2-frc)))**0.5
      rmse=  err / errdv2 
      if( rmse .gt. zero ) rmse = sqrt( rmse )
      if(iter.eq.0) err0 = err
      return
      end
C
c.....................................................................
c
      integer function nsign(v)
      nsign = 0
      if( v .ge . 0.000 )  nsign = 1
      return
      end
c
c.....................................................................
c
C CONVER:      determines if optimization should cease based on error change,
C      parameter change, or iteration number.
c
      subroutine conver
      include 'optim.h'
c
      common /unit1/ iu5,iu6,iu7,iu8,iu9,kikoff,iures, iuparm
      common /mod4/ pname(nall),ixpnam(nall),iuo(nall),iuv(nall)
      common /par3/ up(ma),down(ma),smax,step(ma),stfrc
      common /par3a/ rkmin,frcsec
      common /par7/ dermin,maxit,smin
      common /grad3/ dp(ma),rhs(ma),tm2(ma,ma),ipo,ipl
      common /grad4/ err,err0,rmse,errdiv,iter,errl,avg,sdev
      common /grad5/ yts,stws,gtp,gtpl
      common /choke1/ lab(ma)
      zero=1.e-5
c
c Compute vector length
c
      if( iter.gt.0 ) then
        veclen = 0.000000
        do i=1,ipo
          veclen = veclen + dp(i)**2 
        enddo
        veclen = veclen**0.5
      else
        veclen = 1.E30
      endif
c
c     convergence and iteration tests
c
      derr = errl - err
      percent = 100 * derr / errl 
      write(*,*)
      write(*,*) '      Iteration:',iter
      write(*,'(4x,8hSS(k-1)=,g10.4,8h, SS(k)=,g10.4,
     +          10h, Delt-SS=,g10.4,8h Change=,f6.2,1h%)')
     +      errl, err, derr, percent 
      write(*,*)
c
c    Test if any parameters are left to estimate .............
c   
      ipunc = 0
      do i = 1, ipo 
        if( lab(i).eq.0 )  ipunc = ipunc + 1
      enddo
c        
      istop = 0
      if(iter.ge.maxit) then
        write(*,111)   iter, maxit
        write(iu8,111) iter, maxit
  111   format(4x,' Iteration ',i3,' is equal to the maximum ',i3)
        istop = 1
      elseif(derr.lt.dermin) then
        write(*,112)   derr, dermin
        write(iu8,112) derr, dermin
  112   format(4x,' The error change, ',f10.7,' is less than the ',
     +  'criteria,',f10.7)
        istop = 1
      elseif(veclen .lt. smin) then
        write(*,113)   veclen, smin
        write(iu8,113) veclen, smin
  113   format(4x,'The step size,',f8.4,' is less than the minimum of ',
     +   f8.4)      
        istop = 1
      elseif( ipunc .eq. 0 ) then
        write(*,114) 
        write(iu8,114) 
  114   format(/,4x,'All parameters are constrained.  There is nothing'
     +         ' left to estimate.',/) 
        istop = 1
      else
        errl  = err
        gtpl  = gtp
        stwsl = stws
        iter  = iter + 1
        ytsl  = yts
      endif
c
c   Stop if istop flag has been tripped ................      
c     
      if( istop .eq. 1 ) then  
        write (iu8,*) 'A proper termination occurred !'
        close(iu6)
        close(iu7)
        close(iu8)
        close(iures)             
c      
        do i=1,nall
          if(iuv(i).gt.0) close(iuv(i))
        enddo
        stop 'A proper termination occurred !'
      endif  
c      
      return
      end
c
c_________________________________________________________________________
c
      subroutine start
      include 'optim.h'
c
      common /par1/ parb(ma,mgb),par(ma),ptype(ma),ptag(ma),pinfo(ma)
     +             ,palast(ma)
      common /par1a/ npar,mxgb,cfi
      common /grad1/ gr1(ma),gr1l(ma),grss(mop,ma),fir(ma,ma)
      common /grad2/ gr2(ma),secd(ma,ma),wk(ma,ma)
      common /grad3/ dp(ma),rhs(ma),tm2(ma,ma),ipo,ipl
      ipo = npar 
c
      do i=1,npar
        gr1(i) = 0.00000
        gr1l(i)= 0.00000
        gr2(i) = 0.00000
        dp(i)  = 0.00000
        do j=1,npar
          fir(i,j) = 0.00000
          secd(i,j)= 0.00000
        enddo
        fir(i,i) = 1.0000
        secd(i,i)= 1.0000
      enddo
c
      return
      end
