c.....................................................................
c	   
      subroutine openfile
      include 'optim.h'
c
      common /unit1/ iu5,iu6,iu7,iu8,iu9,kikoff,iures, iuparm
      character*2048 txt(7),txp, tx2
      dimension io(7),r(60)
      data io/7,9,8,99,5,6,100/
      iu7 = io(1)
      txt(3) = 'OUTPUT_Default.MainOptimization.txt'
      txt(4) = 'OUTPUT_Default.Residual-Senstivity.txt'
      txt(5) = 'OUTPUT_Default.bas.txt'
      txt(6) = 'OUTPUT_Default.MODFLOW-list.txt'
      txt(7) = 'OUTPUT_Default.ParameterEstimates.txt'
c
    5 write(*,*) '  Enter main MODOPTIM optimization file ...... '
      read(*,'(A)') txt(1)
      open(iu7,file=txt(1),status='old',err=5)
c
c  read file until end of file specifications are found
c
      k = 1 
      do while ( k.lt.7 )
        k = k + 1
        call ncread(iu7,txp,ierr)
        if( ierr.ne.0 ) then
          if( k.eq.2 ) stop ' No master model file listed !'
          k = 7
	  else
          ki = index(txp,' ') - 1
          txt(k) = txp(1:ki)
          tx2  = txp(ki+1:2048)
          call qread(r,1,tx2,ierr)
          io(k) = ifrl( r(1) )
          call iotest( io(k), txt(k) )
	  endif
      enddo
c
c    open files ..................
c
      do k = 2,7
        open(io(k),file=txt(k))
      enddo
c
      iu5    = io(5)
      iu6    = io(6)
      iu8    = io(3)
      iu9    = io(2)
      iures  = io(4)
      iuParm = io(7)
c
c   report name and unit number of files opened in optimization output file.
c
      write(iu8,100)
      write(iu8,110)
      write(iu8,111) txt(1),io(1)
      write(iu8,112) txt(2),io(2)
      write(iu8,113) txt(3),io(3)
      write(iu8,114) txt(4),io(4)
      write(iu8,115) txt(5),io(5)
      write(iu8,116) txt(6),io(6)
      write(iu8,117) txt(7),io(7)
 100  format(///,16x,'FILES OPENED AND THEIR ASSOCIATED UNIT NUMBERS')
 110  format(/,40('-='),/)
 111  format(1x,/,6x,'Optimization input file is ',a20,'opened'
     + ,' on unit',i4,'.')
 112  format(1x,/,6x,'Master model input file is ',a20,'opened'
     + ,'  unit',i4,'.')
 113  format(1x,/,6x,'Optimization output file is ',a20,'opened'
     + ,' on unit',i4,'.')
 114  format(1x,/,6x,'Final residuals & sensitivities are in ',a20,
     +   'opened',' on unit',i4,'.')
 115  format(1x,/,6x,'Temporary model input file is ',a20,'opened'
     + ,' on unit',i4,'.')
 116  format(1x,/,6x,'Model output file is ',a20,'opened'
     + ,' on unit',i4,'.')
 117  format(1x,/,6x,'Final parameter estimates are in ',a20,
     +   'opened',' on unit',i4,'.')
c
      return
      end
c
c.....................................................................
c
      subroutine iotest(io,file)
      character*2048 file 
c       
	if( io.ge.40 .and. io.le.69 ) then 
	  write (*,*)
	  write(*,'(4x,7hUnit #:,i4,23h was assigned to file: ,a32)')
     +        io, file  
	  write (*,*)
	  write (*,'(4x,a60)' )
     +    '  Unit numbers 40 through 69 are reserved by MODOPTIM '
	  write (*,*)
	  stop '   MODOPTIM halted.   Error in unit number assignment.'
	endif
c
	return
	end
c
c.....................................................................
C
C OPTIN: is called once and reads in all optimization data.  All other
C      one-shot subroutines are called from this one.
C
      subroutine optin(kutout,ioufh,cormin,isense,
     +                 rotrad,aniso,kzint,q3dthk) 
      include 'optim.h'
c
      common /comp1/ xo(mop),yo(mop),zo(mop),TIMo(mop),nobs,kobsbk
      common /comp2/ obs(mop),calc(mop3),calcl(mop),wgt(mop*2),res(mop)
      common /comp3/ well(mop),otype(mop),flxcut(mop), qtest, nqtst
      common /comp4/ wbs(mop), hw(mop), hwl(mop)
      common /mod2a/obfrc(mop3,mobd),kfrc(mop3,mobd),kpotyp(mop)
      common /unit1/ iu5,iu6,iu7,iu8,iu9,kikoff,iures, iuparm
c
      common /par1/ parb(ma,mgb),par(ma),ptype(ma),ptag(ma),pinfo(ma)
     .             ,palast(ma)
      common /par1a/ npar,mxgb,cfi
      common /par2/ izone(mgb),igbact(ma,mgb),iglact(ma),ngbpa(ma),
     .              izcube(lxyz), igbsp(ma,msp)
      common /par3/ up(ma),down(ma),smax,step(ma),stfrc
      common /par3a/ rkmin,frcsec
      common /par6/ nzones,nlines,nga
      common /par7/ dermin,maxit,smin
      dimension rn(mrnv)
c
      character*4  otype,ptype,ptag,pinfo,wtag(ma), qtest
      character*64 well
      character*2048 txt
c
      call openfile
c
c  closure criteria for optimization  &  Test for optimization or sensitivity 
c
      call ncread(iu7,txt,ierr)
      call qread(rn,4,txt,ierr)
  	call caps(txt,2048)
c
      isense = 0
	if(index(txt,'SENS').gt.0 )                          isense = 1
	if(index(txt,'U').gt.0 .and. index(txt,'PLOT').gt.0) isense = 1
c
      if(ierr.gt.1 .and. isense.eq.0 ) 
     +   stop '  Closure criteria not defined.'
        maxit = ifrl( rn(1) )
        smin  = rn(2)
        dermin = rn(3)
        cormin = 0.50
        if(ierr.eq.0 .and. rn(4).gt.0 .and. rn(4).lt.1 ) cormin = rn(4)
      write(iu8,100)maxit,smin,dermin, cormin
 100  format(/,20x,'OPTIMIZATION CLOSURE CRITERIA',/,20x,29('-'),/
     +        ,20x,'Maximum Iteration:',i13,/
     +        ,20x,'Minimum Net Change:',f12.4,/
     +        ,20x,'Minimum Error Change:',g12.4,/,/
     +        ,10x,'CORRELATION COEFFICIENT (CC) INFORMATION',/
     +        ,10x,'Show all parameter pairs with a CC ',1h>,f8.2,/)
c
	if( isense.eq.1 ) then
        dermin = rn(2)
        smin  = 0.0000
	endif
c
c  optimization parameters
c
      call ncread(iu7,txt,ierr)
      call qread(rn,5,txt,ierr)
	call caps(txt,2048)
      if(ierr.gt.0) stop '  Iteration criteria not defined.'
        smax   = rn(1)
        stfrc  = rn(2)
        frcsec = rn(3)
        rkmin  = rn(4)**2
        cfi    = rn(5)
	  if( index(txt,'LIMIT').gt.0 .and. 
     +      index(txt,'LIMIT').lt.index(txt,'REM') ) then
          kutout = 2
  	    txt = ' NOT be estimated.'   
	  else
          kutout = 1
	    txt = ' be estimated.'   
	  endif
      write(iu8,110)smax,stfrc,frcsec,rkmin,cfi, txt
  110 format(/,20x,'OPTIMIZATION CONTROLS',/,20x,21('-'),/
     . ,14x,'Maximum Step Length                    :',f10.4,/
     . ,14x,'Maximum Fraction of Range              :',f10.4,/
     . ,14x,'Fraction of FIR(1,1) to initialize SECD:',f10.4,/
     . ,14x,'Rank determinant                       :',f10.4,/
     . ,14x,'Coefficient of influence               :',f10.4,/ 
     . ,14x,'Parameters at limits will',a30,/)
      write(iu8,'(40(2h-=))')
c
       iter=0
c
c...... this is a model specific routine. available routines are,
c        BOAST II: black oil applied simulation tool
c        MODFLOW: USGS modular groundwater model
c        VS2DT:  USGS 2D, variably saturated flow and transport model
c
      call modgin(ioufh,q3dthk) 
c
      call slpwgt(iu7,iu8,wtag)
c
c    read in parameters to be optimized and modified.
c
      call parain(iu7,iu8,wtag,rotrad,aniso)
c
c    read observation data ----- water levels, flow rates, conc, and lift.  
c
      call observ(iu7,iu8,q3dthk,rotrad,aniso,kzint)
c
c    initialize internal variables.
c
      call start
c
      return
      end
c
c.....................................................................
c
      subroutine observ(io,iout,q3dthk, rotrad,aniso,kzint)
      include 'optim.h'
	parameter ( mxfld = 12)
c
      common /mod1/ dxm(lx),xc(lx),xe(lx1),dym(ly),yc(ly),ye(ly1)
      common /mod2/ dzm(lxyz),zc(lxyz)
      common /mod2a/obfrc(mop3,mobd),kfrc(mop3,mobd),kpotyp(mop)
      common /mod3/ ix,iy,iz,ixyz,ixy,iper, izpls
      common /comp1/ xo(mop),yo(mop),zo(mop),TIMo(mop),nobs,kobsbk
      common /comp2/ obs(mop),calc(mop3),calcl(mop),wgt(mop*2),res(mop)
      common /comp3/ well(mop),otype(mop),flxcut(mop), qtest, nqtst
      common /comp4/ wbs(mop), hw(mop), hwl(mop)
      common /flow2/ iobflx(lxyz),iflxzn(mgb) 
      common /flow3/ iQplusMIN(mop) 
	common /oc1/ wminoc, iblank
	common /gwmgt1/  qwtst, liftst, nqwtst, nlftst, MNWtst, nMNWtst 
	common /sclout/ timref, timscl, wlmlt, wlref, 
     +                qmlt, qwmlt, cstmlt, idatim
c
      dimension rn(mrnv), iznt(mxfld), ifltp(mxfld), obstmp(mop),
     +          iflfld(mxfld)
      dimension wgtneg(mtp1),  wgtpos(mtp1)
      character*4  otype,ott, qtest, qwtst, liftst, flwtag(mxfld)
      character*4  MNWtst 
	character*8  frmt
      character*64 well, wellt, dwell
      character*2048 txt,tx2
c
      data flwtag/'STOR','WELL','DRAI','RIVE','ET  ','CHD ',
     x            'GHB ','RECH','SPEC','STRE','MNW ','IBS '/
	data iflfld/4,3,3, 3,2,3, 3,4,3, 4,3,3 / 
	data obfrc,kfrc,kpotyp/mopbd2*0.0,mopbd2*0,mop*0/
	data iQplusMIN/mop*0/
	data wgtneg, wgtpos/mtp1*1.00000, mtp1*1.00000/
c
      idatim = 0
      zero = 1.e-16
	pi = 3.14159
	betaoff = 0.0000000000
c
c     start section with opportunity to read in a time scaler and offset.
c   observed values are =
c
c    time(n) = (time_in - time_ref ) * time_scale
c
c   Set default info here 
      timref = 0.00000000
      timscl = 1.00000000
      wlmlt  = 1.00000000
      wlref  = 0.00000000
      qmlt   = 1.00000000 
      qwmlt  = 1.00000000 
      cstmlt = 1.00000000
      iblank = 0
      iwgtadj= 0
      kobsbk = 0
      wminoc = -zero
      nqtst  = 4
      qtest  = 'FLOW' 
      nqwtst = 4
	qwtst  = 'CONC'
      nlftst = 4
	liftst = 'LIFT'
      nMNWtst= 4
	MNWtst = 'MNWL'
	kzint = 0
c   sbtst  = 'SUB '     !! <<<<< Subsidence is hard-wired in the GETSUB extraction routine
c
c   Head of section to reset defaults until the first SITE identifier is read
      kisite = 0
      do while( kisite .eq. 0 )
        call ncread(io,txt,ierr)
        call caps(txt,2048)
c
c   Test for the SITE key
        kisite = index(txt,'SITE')
c   Time offset
        ki = index(txt,'START:') + 6
        if( ki .gt. 6 ) then
          call shorten(txt,'START',5,tx2)
          call datecheck(tx2,idatim)
          call qread(rn,1,tx2,ierr)
          timref = rn(1)
        endif
c  Time scale 
        ki = index(txt,'SCALE:') + 6
        if( ki .gt. 6 ) then
          call shorten(txt,'SCALE',5,tx2)
          call qread(rn,1,tx2,ierr)
          timscl = rn(1)
        endif       
c  Default (WL) scale
        if( index(txt,'MULT:') .gt. 0 ) then
          call shorten(txt,'MULT:',5,tx2)
c          call datecheck(tx2,idatim)
          call qread(rn,1,tx2,ierr)
          wlmlt = rn(1)
        endif
c  Default (WL) offset
        if( index(txt,'OFFSET:') .gt. 0 ) then
          call shorten(txt,'OFFSET:',7,tx2)
          call qread(rn,1,tx2,ierr)
          wlref = rn(1)
        endif       
c   Test if observations will NOT be interpolated in time
	  if(index(txt,'SS').gt.0 .or. index(txt,'NO TIM').gt.0) kobsbk=1
c
c  Adjust weights by Standard deviation of each measurement type   
        if( index(txt,'ADJUST-WEIGHT') .gt. 0 ) iwgtadj = 1
c
c  Will observations w/ a weight that fall below the wminoc threshold not be printed?
        if( index(txt,'OUTPUT') .gt. 0 ) then
          call shorten(txt,'OUTPUT',6,tx2)
          call qread(rn,1,tx2,ierr)
          wminoc = rn(1)
        endif       
c
c   Set default FLOW term tag
        if( index(txt,'FLOW') .gt. 0 ) then
          call shorten(txt,'FLOW',4,tx2)
          nqtst = index(tx2,' ') - 1
	    if( nqtst.gt.4 ) nqtst = 4
	    qtest = tx2(1:nqtst) 
        endif       
c
c   Set default FLOW OC multiplier 
        if( index(txt,'MULT-Q') .gt. 0 ) then
          call shorten(txt,'MULT-Q',6,tx2)
          call qread(rn,1,tx2,ierr)
	    if( ierr .eq. 0 ) qmlt = rn(1)
        endif       
c
c   Set default QW term tag
        if( index(txt,'QUALITY') .gt. 0 ) then
          call shorten(txt,'QUALITY',4,tx2)
          nqwtst = index(tx2,' ') - 1
	    if( nqwtst.gt.4 ) nqwtst = 4
	    qwtst = tx2(1:nqwtst) 
        endif       
c
c   Set default QW OC multiplier 
        if( index(txt,'MULT-QW') .gt. 0 ) then
          call shorten(txt,'MULT-QW',7,tx2)
          call qread(rn,1,tx2,ierr)
	    if( ierr .eq. 0 ) qwmlt = rn(1)
        endif       
c
c   Set default COST term tag
        if( index(txt,'COST') .gt. 0 ) then
          call shorten(txt,'COST',4,tx2)
          nlftst = index(tx2,' ') - 1
	    if( nlftst.gt.4 ) nlftst = 4
	    liftst = tx2(1:nlftst) 
        endif       
c
c   Set default MNW term tag
        if( index(txt,'MNW:') .gt. 0 ) then
          call shorten(txt,'MNW',3,tx2)
          nMNWtst = index(tx2,' ') - 1
	    if( nMNWtst.gt.4 ) nMNWtst = 4
	    MNWtst = tx2(1:nMNWtst) 
        endif       
c
c   Set default COST OC multiplier 
        if( index(txt,'MULT-LIFT') .gt. 0 ) then
          call shorten(txt,'MULT-LIFT',9,tx2)
          call qread(rn,1,tx2,ierr)
	    if( ierr .eq. 0 ) cstmlt = rn(1)
        endif       
c
c    Print blank lines between different sites 
        if( index(txt,'BLANK') .gt. 0 ) iblank = 1
c
c   Test for Z-interpolation switch ............
        if( index(txt,'Z-INTER').gt.0 ) kzint = index(txt,':YES') 
c
	enddo             !    end of initial do while loop to get fixed settings
c
      backspace(io)
c
c   Head of Loop to read in observation data ................
c
      n = 0
  10  continue
      call ncread(io,txt,ierr)
c
c   check for <end> or eof tag to terminate direct observations.
c
      if( ierr .ne. 0 ) goto 11
      tx2 = txt
      call caps(tx2,2048)
      call conden(tx2,2048)
      ott = tx2(1:4)
      IsumSIGN = 0    !!  DEFAULT flow accumulator term is 0 -- Sums + & - terms
c
c   Test for IOBFLX array............
c
      kflx = index(tx2,'FLUXZONE') 
	if( kflx.gt.0 ) call setiobflx(io,txt,nflxzn) 
c
c   Test for Z-interpolation switch ............
c
	if( index(tx2,'Z-INTER').gt.0 ) then
	  kzint = index(tx2,':YES') 
	endif
c
c   Set observation multiplier 
c
      obmult = wlmlt 
      obref  = wlref 
      if( ott(1:nqtst)  .eq. qtest(1:nqtst)   ) then
        obmult = qmlt
        obref  = 0.000
      endif 
      if( ott(1:nqwtst) .eq. qwtst(1:nqwtst)  ) then
	  obmult = qwmlt 
        obref  = 0.000
      endif 
      if( ott(1:nlftst) .eq. liftst(1:nlftst) ) then
        obmult = cstmlt 
        obref  = 0.000
      endif 

      tx2 = txt
      call caps(tx2,2048)
      ki = index(tx2,'SITE:') + 5
c
c   check that line contains site info ..........................
c
      if( ki .lt. 6) goto 10
c  Reset time offset switch if a new site location is defined 
      ioffset = 0
c
      wellt  = tx2(ki:2048)
      kwblk = index(wellt,'  ') 
	wellt(kwblk:64) = '                                    '
c
      kco = index(tx2,'ZONE:') + 5 
	if( ott(1:nqtst).ne.qtest(1:nqtst) .and. kco.le.5 ) then
        kco = index(tx2,'Z:') - 2
        if( kco .le. -2 ) kco = index(tx2,'K:') - 2
        ipoint = 1
      else
        if( kco .gt. 5 ) kco = kco + 200
        ipoint = 0
      endif
c
c    if no location is provided, report defect and remove site from list.
c
      if( kco .lt. 1 ) then
        write(iout,'(2x,a22,1x,a4,a10,a40)')' No location for type:  ',
     .  ott,' at site, ',wellt
        goto 10
      else if( kco .gt. 200 ) then
c
c    If ott = a FLOW tag, find zones to be considered. Up to Mobd.
c
        do k = 1, mxfld
          iznt(k)  = 55000
	    ifltp(k) = 0
        enddo
        txt = tx2(kco-200:ki-6)
        call qread(rn,mobd,txt,ierr)
        do k = 1,mobd-ierr
          iznt(k) = ifrl( rn(k) )
        enddo
c
c  Test if a limiting flux is to be removed from discharge comparisons .......
        kflx = index(tx2,'FLUXCUT') 
        if( kflx.gt.0 ) then
          txt = tx2(kflx+8:2048)
          call qread(rn,1,txt,ierr)
          if( ierr.eq.0 )  fluxchop = rn(1)
        else
          fluxchop = 1.0e30
        endif
c
c  Test FLOW terms are limited to POSITIVE values
        if( index(tx2,'SUM-POSITIVE') .gt.0 ) IsumSIGN = 1
c
c  Test FLOW terms are limited to NEGATIVE values
        if( index(tx2,'SUM-NEGATIVE') .gt.0 ) IsumSIGN = -1
c
c  Test if the sum of the absolute flow rates is to be compared
        kabs = index(tx2,'ABSOL') + 1 
c
c    Identify packages that flow will be extracted from and store ids in
c    obfrc array.  Code by unit numbers as in BAS package ............
c
	  kt  = kco - 200 - 5 
        txt = tx2(1:kt)
	  do iqt = 1, mxfld
	    kp = iflfld(iqt)
          if( index(txt,flwtag(iqt)(1:kp)) .gt. 0 ) ifltp(iqt) = kabs
	  enddo
	  if(  ifltp(9) .gt.0 ) ifltp(6) = kabs
	  if(  ifltp(10).gt.0 ) ifltp(4) = kabs
	  if(  ifltp(11).gt.0 ) ifltp(2) = kabs
	  if(  ifltp(12).gt.0 ) ifltp(1) = kabs
        if(  ott(1:nqwtst)  .eq. qwtst(1:nqwtst)  .or. 
     +       ott(1:nlftst)  .eq. liftst(1:nlftst) .or. 
     +       ott(1:nMNWtst) .eq. MNWtst(1:nMNWtst) ) ifltp(2) = 1000
c      data flwtag/'STOR','WEL1','DRAI','RIVE','ET  ','CHD ',
c                     1      2     3       4     5       6
c     x            'GHB ','RECH','SPEC','STRE','MNW ','IBS '/
c                     7      8     1       4      2      1
      else
        txt = tx2(kco+4:2048)
        call qread(rn,3,txt,ierr)
        if( ierr .gt. 0 ) then
          write(iout,'(2x,a22,1x,a4,a10,a40)')' Insufficient location ',
     .    ott,' at site, ',wellt
          goto 10
        endif
c
c   extricate location information as either xyz or ijk or a mix of the two.
c
        xot = rn(1)
        if( tx2(kco:kco) .eq. 'I') then
          i = ifrl( rn(1) ) 
          xot = xc(i)
        endif
c
        kco = kco + 1
        yot = rn(2)
        if( tx2(kco:kco) .eq. 'J') then
          j = ifrl( rn(2) )
          yot = yc(j)
        endif
c
c   Rotate-translate XY for Lateral anisotropy estimation  
        if( rotrad.lt.1.0e9 ) then
          if( n.eq.0 ) then
            xwprod = xot
            ywprod = yot
          endif
          xotunr = xot
          yotunr = yot
          call spinobs(xot,yot,xwprod,ywprod,rotrad,aniso, xot,yot)
        endif
c
        kco = kco + 1
        zot = rn(3)
        if( tx2(kco:kco) .eq. 'K') then
          call ram3d(xot,yot,zot,i,j,k)
          k = ifrl( rn(3) )
          nd = 0
          call node(i,j,k,nd,ix,iy,iz)
          zot = zc(nd)
        endif
c
c   Shift observations to center of node for QW & lift cost observations
c
c        if( ott(1:nqwtst) .eq. qwtst(1:nqwtst) .or. 
c     +      ott(1:nlftst) .eq. liftst(1:nlftst)    ) then
c	 write(8,*)' Pre-center ',xot,yot,zot
c          call center(xot,yot,zot)
c	 write(8,*)' Pre-center ',xot,yot,zot
c        endif
      endif
c
c    read all time, observation, and weight data associated with each site.
c  the default weight values will be assigned in the absence of weight info.
c								 
	nt1  = n
  20  continue
      call ncread(io,txt,ierr)
      if( ierr .ne. 0 ) goto 11
      call caps(txt,2048)
c
c  Check for an additional line if wellbore storage effects are to be considered
c
	if( n .eq. nt1 ) then
        if( index(txt,'STOR').gt.0 ) then
	    ki = index(txt,':')
          tx2 = txt(ki+1:2048)
          call qread(rn,3,tx2,ierr)
          if( ierr .gt. 0 ) then
            write(iout,'(2x,a32,1x,a4,a10,a40)')
     +    ' Insufficient wellbore information  ',ott,' at site, ',wellt
	      beta = betaoff
            goto 20
          endif
	    rkxy   = rn(1)
	    screen = rn(2)
	    rw     = rn(3)
	    beta = screen * rkxy / (alog(screen/rw) * 2 * rw**2 )
	    ki = index(txt,'TAG:')+4
	    wellt(61:64) = txt(ki:ki+3)
          call ncread(io,txt,ierr)
          if( ierr .ne. 0 ) goto 11
          call caps(txt,2048)
        elseif( index(txt,'PUMP').gt.0 ) then
	    ki = index(txt,':')
          tx2 = txt(ki+1:2048)
          call qread(rn,2,tx2,ierr)
          if( ierr .gt. 0 ) then
            write(iout,'(2x,a32,1x,a4,a10,a40)')
     +    ' Insufficient wellbore information  ',ott,' at site, ',wellt
	      beta = betaoff
            goto 20
          endif
	    trans  = rn(1)
	    rw     = rn(2)
c   ram observation to center of node 
c          call center(xot,yot,zot)
c   compute ro by Peaceman .........
          ro  = 0.14 * ( dxm(i)**2 + dym(j)**2 )**0.5
	    if( ro .le. rw ) then
c      reject option if ro <= rw .........	      
	      beta = betaoff
            write(iout,'(2x,a32,1x,a4,a10,a40)')
     +    ' Rejecting PUMPing loss option at   ',ott,' at site, ',wellt
	      write(iout,*)   ' ro =',ro,' <=  rw =',rw 
            write(*,'(2x,a32,1x,a4,a10,a40)')
     +    ' Rejecting PUMPing loss option at   ',ott,' at site, ',wellt
	      write(*,*)   ' ro =',ro,' <=  rw =',rw 
	    else
	      beta = -2 * pi * trans / alog(ro/rw) 
c           dh = Q * alog(ro/rw) / (2*pi * tran )
c           dh = Q / beta 
	    endif
	    ki = index(txt,'TAG:')+4
	    wellt(61:64) = txt(ki:ki+3)
          call ncread(io,txt,ierr)
          if( ierr .ne. 0 ) goto 11
          call caps(txt,2048)
	  else
	    beta = betaoff 
	  endif
	endif
c
c    Check if residuals are to be res < 0, res = 0, or res > 0
c
      if( index(txt,'<').gt.0 ) then
	    ki = index(txt,'<')
	    txt(ki:ki) = ' '
        well(n+1)  = '<_'//wellt
        iwneg = 1
        iwpos = 0
	elseif( index(txt,'>').gt.0 ) then
	  ki = index(txt,'>')
	  txt(ki:ki) = ' '
        well(n+1)  = '>_'//wellt
        iwneg = 0
        iwpos = 1
      else
        well(n+1)  = wellt
        iwneg = 1
        iwpos = 1
	endif
c
c  Read observation and weights if present
c
c    convert dates to decimal days if present 
      call datecheck(txt,idok)
c   Check for errors in the usage of dates
	if( idok.ne.idatim .and. index(txt,'SITE:').eq.0 ) then
	  write(*,*) 'Error in date usage of observations on card: '
	  write(*,'(a78)') txt
	  write(*,*) 'This was observation number, ', n+1
c        stop ' '
	endif
c
c    Check if observation exists
c
      call qread(rn,2,txt,ierr)
      if( rn(3).gt.0.5 .or. ierr.gt.0 ) then
        if( n .eq. nt1 ) then
          write(iout,'(2x,a22,1x,a4,a10,a40)')' No observation for    ',
     .    ott,' at site, ',wellt
        endif
        backspace(io)
        goto 10
      endif
c
      call qread(rn,4,txt,ierr)
	if( ierr.eq.1 ) then
        call qread(rn,3,txt,ierr)
	  ierr = ierr + 1
	endif
c
      n = n + 1
      otype(n) = ott
c   Find unique pointer for weights
      ipwuq = iptext(n, otype )
c
      TIMo(n)  = (rn(1) - timref) * timscl
      obstmp(n) = (rn(2) - obref) * obmult
      if( ierr.eq.0 .and. rn(5).lt.0.5 ) then
        wgt(n)     = rn(3) * iwneg
        wgt(n+mop) = rn(4) * iwpos
        if( index(txt,'DEF').gt.0 ) then
          wgtneg(ipwuq) = rn(3)
          wgtpos(ipwuq) = rn(4)
        endif
      elseif( ierr.eq.1 .and. rn(4).lt.0.5 ) then
        wgt(n)     = rn(3) * iwneg
        wgt(n+mop) = rn(3) * iwpos
        if( index(txt,'DEF').gt.0 ) then
          wgtneg(ipwuq) = rn(3)
          wgtpos(ipwuq) = rn(3)
        endif
	else 			    
        wgt(n)     = wgtneg(ipwuq) * iwneg
        wgt(n+mop) = wgtpos(ipwuq) * iwpos
	endif 
c
      xo(n)    = xot
      yo(n)    = yot
      zo(n)    = zot
	wbs(n)   = beta    
	flxcut(n)= fluxchop    
      iQplusMIN(n) = IsumSIGN
c
c    Check for cross-linking of observations .... differences in WL or Q
c
	if( index(txt,'NO ').gt.0 ) then
	  kpotyp(n) = -1
	  wgt(n)     = 0.00000000
        wgt(n+mop) = wgt(n) 
	  obs(n) = obstmp(n) 
	elseif( index(txt,'DT').gt.0 ) then
	  if( n-1.eq.nt1 )then
	    kpotyp(n) = -1
	    wgt(n)    = 0.00000000
          wgt(n+mop) = wgt(n) 
	    obs(n) = obstmp(n) 
	  else
	    kpotyp(n) = n-1
	    obs(n) = obstmp(n) - obstmp(n-1)
 	  endif
	elseif( index(txt,'OFFSET').gt.0 .or. ioffset.gt.0 ) then
	  if( ioffset.eq.0 )then
	    kpotyp(n) = -1
	    wgt(n)    = 0.00000000
          wgt(n+mop) = wgt(n) 
	    obs(n) = obstmp(n) 
	    ioffset = n
	  else
	    kpotyp(n) = ioffset
	    obs(n) = obstmp(n) - obstmp(ioffset)
 	  endif
	elseif( index(txt,'DX').gt.0 ) then
	  ki = index(txt,':') + 1
	  dwell = txt(ki:2048)
	  kncmp = index(dwell,' ') - 1
	  ki    = index(dwell,',') - 1
	  if( ki.gt.0 .and. ki.lt.kncmp ) kncmp = ki
	  tx2 = dwell(kncmp+2:64) 
        call datecheck(tx2,idatim)
	  call qread(rn,1,tx2,ierr)
c  ....... Identify time, in addition to SITE, for cross-linking observations
	  if( ierr.gt.0 ) then
	    tpair = TIMo(n)
	  else
	    tpair = (rn(1) - timref) * timscl
	  endif	 
c
	  dtlst = 1.0e23
        do ip = 1 , n-1
	    if( dwell(1:kncmp) .eq. well(ip)(1:kncmp) )then
	      dt = abs( TIMo(ip) - tpair )
	      if( dt .lt. dtlst ) then
	        obs(n) = obstmp(n) - obstmp(ip)
  	        kpotyp(n) = ip
	        dtlst = dt 
	      endif
	    endif
	  enddo
	else
  	  kpotyp(n) = 0
	  obs(n) = obstmp(n)
	endif
c
      if( ipoint.eq.1 ) then
        call frcass(kzint,xot,yot,zot,n,total,zero,q3dthk)
        if( rotrad.lt.1.0e9 ) then
          xo(n) = xotunr
          yo(n) = yotunr
        endif
      else
        do k = 1,mobd
          kfrc(n,k)  = iznt(k) 
          obfrc(n,k) = ifltp(k) 
        enddo
      endif
c
c     check if coordinate lies within modeled area.
c
        if(total .lt. 0.0000) then
          write(iout,'(2x,a22,1x,a4,a10,a40)')' Not in modeled area   ',
     .    ott,' at site, ',wellt
          write(iout,'(1x,5h XYZ:,2f12.1,f12.2)')xot, yot, zot
          write(iout,*)'  Sum of failures =',total,'   Ipoint =',ipoint
          n= n - 1
        endif
      if( n .le. mop ) goto 20
c
c   terminate if more observations are provided than are dimensioned.
c
      write(iout,99) mop
  99  format(1x,'More than ',i4,' observations given.')
      stop 'ERROR IN NUMBER OF OBSERVATIONS!'
   11 nobs = n
      if( nobs .lt. 1 )  stop '   No observation data ........'
c
	write(iout,*) '      Flow rate identifier     = ',qtest,  qmlt 
	write(iout,*) '      Lift cost identifier     = ',liftst, cstmlt
	write(iout,*) '      Water quality identifier = ',qwtst,  qwmlt
	write(iout,*) '      MultiNode Well identifier = ',MNWtst, WLmlt
c
c   find how many different observation types exist,
c        the number of observations within each type,
c        the standard deviation of each type, and
c        the normalizing factor of types 2 - notype to type 1.
c
      call equaliz(notype, iwgtadj)
c
c   Modify observation output  ...... show non-FLOW terms first, then FLOW
c  
      txt = '    Observations are interpolated in time. '
	if(kobsbk.eq.1) 
     +  txt = '  Observations are NOT interpolated in time. '
      write(iout,'(a60)')  txt
      write(*,'(a60)')  txt
      write(*,'(26(3h<o>),10x,i5,26h observations will be used)')nobs
      write(iout,91) nobs
   91 format(/,26('<o>'),//,10x,i5,' observations will be used.',//,
     .  6x,'Type',5x,'Time',10x,'Observ',2x,'-Weight',2x,'+Weight',2x,
     + 'Well Descriptor',2x,' Differ. Sites & time', 
     +  18x,'X',8x,'Y',8x,'Z',2x,' I  J  K ',/,80('-'))
c
      do n = 1,nobs
	  if( otype(n)(1:nqtst) .ne. qtest(1:nqtst) .and. 
     +      obfrc(n,2)        .lt. 999                  )  then
          call ram3d(xo(n),yo(n),zo(n),i,j,k)
	    wellt = '                          '
	    if( kpotyp(n).gt.0 ) then 
	      mpt = kpotyp( n )
	      wellt = '->'//well( mpt )
	      write(wellt(13:22),'(1h:,g9.2)') TIMo(mpt)
	  	endif
          if( wbs(n).gt.0.00 )
     +      write(wellt(23:34),'(3h B=,f9.1)') wbs(n)
          write(iout,92) n,otype(n),TIMo(n),obs(n),wgt(n),wgt(n+mop),
     +    well(n),wellt,xo(n),yo(n),zo(n),i,j,k, flxcut(n)
   92     format(1x,i4,1x,a4,1x,g14.6,f10.2,1x,2g10.3,1x,a16,a34, 
     +       2f9.0,f8.2,3i4,g11.3)
        endif
      enddo 
c 
	write(iout,*) 
c
c     Echo Zone SUMMED or averaged terms 
c
      istop = 0
      do n = 1,nobs
	  if( otype(n)(1:nqtst) .eq. qtest(1:nqtst) .or. 
     +      obfrc(n,2)        .gt. 999                 )  then
	    if( well(n)(1:16).ne.well(n-1)(1:16) ) then
	      wellt = '                                                  '
	      ki = 1
            kzn = 0
            do k = 1,mobd
              if( kfrc(n,k) .lt.55000 ) then
                kzn = k
                iok = 0
                ijk = 0
                do while ( iok.eq.0 .and. ijk.le.ixyz )
                  ijk = ijk + 1
                  if( kfrc(n,k).eq.iobflx(ijk) ) iok = 1
                enddo
              endif
              if( obfrc(n,k).gt.0.5 ) then
	          wellt(ki:ki+4) = flwtag(k)//',' 
                ki = ki + 5 
              endif
            enddo
            if( ki.eq.1 ) istop = 1
	      ki = index(well(n),'  ')
	      txt= ' Site: '//well(n)(1:ki)//'will be read '//
     +            'from zones: '
	      ki = index(txt,'zones:')+6
	      dwell = '(/,1x,aXXX,8(i4,1h,))       '
	      write(dwell(8:10),'(i3.3)') ki
	      write(iout,dwell) txt, ( kfrc(n,k),k=1,kzn )
c
c   STOP if a package was not specified for the observation 
c
            if( istop.eq.1 .or. kzn.lt.1 ) then
              write(*,*) 
              write(*,*) '  ERROR in observation data  '
              if( istop.eq.1 ) 
     +        write(*,*) '  No MODFLOW packages were specified for  '
              if( kzn.lt.1 )
     +        write(*,*) '  No ZONES  were specified for  '
              write(*,dwell) txt, ( kfrc(n,k),k=1,kzn )
              write(*,*) 
              stop ' ' 
            endif
c
c   STOP if a flux zone is not defined in IOBFLX 
c
            if( iok.eq.0 ) then
              write(*,*) 
              write(*,*) '  ERROR in observation data  '
              write(*,*)
     +     '  The IOBFLX array did not contian the ZONES specified for:'
              write(*,dwell) txt, ( kfrc(n,kj),kj=1,kzn )
              write(*,*) 
              stop ' ' 
            endif
c
	      txt= ' The flow/cost/QW will be summed from packages: '
     +            //wellt
            frmt = '(a000)'
            write(frmt(3:5),'(i3.3)') itxend( txt )
            write(iout,frmt) txt
	      write(iout,'(4x,1hn,6x,4hTime,10x,a4,7x,7h-Weight,
     +                   7x,7h+Weight)') otype(n)
	    endif
	    wellt = '                          '
	    if( kpotyp(n).gt.0 ) then 
	      mpt = kpotyp( n )
	      wellt = '->'//well( mpt )
	      write(wellt(13:22),'(1h:,g9.2)') TIMo(mpt)
	  	endif
          write(iout,'(i5,4g14.6,a22,g11.3)') n, TIMo(n), obs(n),wgt(n),
     +                                  wgt(n+mop),wellt,flxcut(n)
        endif
      enddo 
c
      write(iout,'(/,26(3h<o>),/)')
c
c  Echo IOBFLX array and descriptors to <master optimization> file  
c
      write(iout,'(/,8(10h<FluxZone>),/)')
  103 format(/,4x,'Layer',i3,/,65('-'))
c
      do k=1,iz
        write(iout,103)k
        do  j = 1, iy
          ne = (k-1)*ixy + j*ix  
          nb = ne - ix + 1
          write(iout,'(I4,A1,500I5)') j,':',(iobflx(n),n=nb,ne)
        enddo
c        do  j=1,iy
c          nb=0
c          call node(1,j,k,nb,ix,iy,iz)
c          ne=nb+ix-1
c          do i=nb,ne,15
c            nbb=i
c            nee=i+14
c            if(nee.gt.ne) nee=ne
c            if(nbb.eq.nb) then
c              write(iout,'(I3,A1,15I5)') j,':',(iobflx(n),n=nbb,nee)
c            else
c              write(iout,'(4X,15I5)') (iobflx(n),n=nbb,nee)
c            endif
c  	     enddo
c        enddo
      enddo 
      write(iout,'(/,8(10h<FluxZone>),/)')
c
      return
      end
c
c.....................................................................
c
      subroutine center(xot,yot,zot)
      include 'optim.h'
      common /mod1/ dxm(lx),xc(lx),xe(lx1),dym(ly),yc(ly),ye(ly1)
      common /mod2/ dzm(lxyz),zc(lxyz)
c
c   ram observation to center of node 
      call ram3d(xot,yot,zot,i,j,k)
      xot = xc(i)
      yot = yc(j)
      nd = 0
      call node(i,j,k,nd,ix,iy,iz)
      zot = zc(nd)
c
      return
      end
c
c.....................................................................
c
      subroutine equaliz(notype, iwgtadj)
      include 'optim.h'
c
      common /comp1/ xo(mop),yo(mop),zo(mop),TIMo(mop),nobs,kobsbk
      common /comp2/ obs(mop),calc(mop3),calcl(mop),wgt(mop*2),res(mop)
      common /comp3/ well(mop),otype(mop),flxcut(mop), qtest, nqtst
      common /unit1/ iu5,iu6,iu7,iu8,iu9,kikoff,iures, iuparm
      dimension id(mop)
      dimension o(mtp1),o2(mtp1),nd(mtp1),rat(mtp1),otp(mtp1),wt(mtp1)
      character*4  otype,otp, qtest
      character*64 well
	zero = 1.0E-23
c
      do i=1,mtp1
        otp(i)='????'
        wt(i)=0.0
        o(i)=0.
        nd(i)=0.
        o2(i)=0.
	enddo
      notype=1
      call unique(nobs,notype,otype,id)
c
      do i = 1,nobs
        if(otp(id(i)).eq.'????') otp(id(i))=otype(i)
        if(id(i).gt.notype) notype=id(i)
      enddo 
      do i = 1, nobs
	  if( wgt(i) .gt. zero ) then
          k     = id(i)
          nd(k) = nd(k) + 1
          wt(k) = wt(k) + (wgt(i)+wgt(i+mop))*0.5
          o(k)  = o(k)  + obs(i)
          o2(k) = o2(k) + obs(i)**2
	  endif
      enddo 
c
c     find sd of observation types
c
      sum=0.0000000
      do k=1,notype
        n = nd(k)
        if(n.gt.1) then
          od2  = (n*o2(k)-o(k)**2)/((n-1)*n)
          o(k) = o(k)/n
          if( od2.lt.1.e-32 ) then  
		  o2(k) = 0.000
            rat(k)= 0.00
	    else
		  o2(k)  = od2
            rat(k) = (o2(1)/o2(k))**0.5
	    endif
          sum = sum + wt(k)
        else
          rat(k) = 0.000000000
          wt(k)  = 0.000000000000
          o2(k)  = 0.000000000000
        endif
      enddo
c
      write(iu8,110)
      write(*,110)
  110 format(/,27('<o>'),//,
     .1x,'Observation',4x,'Number of',5x,'Average',5x,'Standard',
     .6x,'Ratio of',5x,'Fraction'/4x,'Type',7x,'Observations',
     .15x,'Deviation',5x,'Variances ',/,80('-'))
c
      do i=1,notype
        frc = wt(i) / sum
        write(iu8,111)otp(i),nd(i),o(i),o2(i)**0.5,rat(i),frc
        write(*,111)otp(i),nd(i),o(i),o2(i)**0.5,rat(i),frc
      enddo
  111 format(4x,a4,5x,i9,2x,g11.5,2x,g11.5,2x,g10.4,2x,f6.4)
      do i=1,nobs
        if( rat(id(i)).gt.zero .and. iwgtadj.gt.0 ) then
          wgt(i)     = wgt(i)     * rat(id(i))
          wgt(i+mop) = wgt(i+mop) * rat(id(i))
        endif
      enddo
      return
      end
c
c.....................................................................
c
      subroutine parain(io,iout,wtag,rotrad,aniso)
      include 'optim.h'
c
      common /mod3/ ix,iy,iz,ixyz,ixy,iper, izpls
      common /mod4/ pname(nall),ixpnam(nall),iuo(nall),iuv(nall)
      common /par1/ parb(ma,mgb),par(ma),ptype(ma),ptag(ma),pinfo(ma)
     .             ,palast(ma)
      common /par1a/ npar,mxgb,cfi
      common /par2/ izone(mgb),igbact(ma,mgb),iglact(ma),ngbpa(ma),
     .              izcube(lxyz), igbsp(ma,msp)
      common /par3/ up(ma),down(ma),smax,step(ma),stfrc
      common /par6/ nzones,nlines,nga
      common /par7/ dermin,maxit,smin
      dimension rn(msp)  !, ixlksp(msp), ixlkzn(mgb)
c
      character*4  pname, ptype,ptag,pinfo,wtag(ma)
	character*8  sptest
      character*2048 txt,tx2
	rotrad = +1e11
      aniso = -1.00
      pi = 3.141592654
      zero =  1.e-16
c
      do i = 1,ma
        do j = 1,msp
          igbsp(i,j) = 0
        enddo
      enddo
c
c
c       ptype(m) is compared to pname(?) in the model files.
c
c
c   pnat settings:  constant   block operations only
c                   weighted   weight operations only
c
c       choices:      pnat  |  pwg  |  ptr  |  psc
c                  ---------+-------+-------+-------
c                   Parallel| Lower |  exp  |  scl
c                    Series | Upper |  mult |  non
c                           | None  |  add  |
c
c      Default PINFO value is PNEN
c
c   All additive parameters will be scaled 
c
      mxgb = 0
      m = 0
c
  10  m = m+1
      jcum = 0
      call ncread(io,txt,ierr)
      tx2 = txt
      call caps(tx2,2048)
c
c    grab individual label for parameter, if present.
c
      ki = index(tx2,'PARAM')
      if( ki .lt. 1 ) goto 99
        tx2 = txt(ki:2048)
        ki = index(tx2,':') + 1
        ptag(m) = tx2(ki:ki+3)
        call caps(txt,2048)
c
c    locate tag for parameter
c
        ki = index(txt,'TAG') + 4
        ptype(m) = txt(ki:ki+3)
c
c   sort out parameter modification type .........
c
        call shorten(txt,'TYPE',4,tx2)
        call conden(tx2,64)
        pinfo(m)(1:1) = tx2(1:1)
        do k = 2,4
          ki = index(tx2,',')
          tx2(ki:ki) = '?'
          pinfo(m)(k:k) = tx2(ki+1:ki+1)
	  enddo
        if( pinfo(m)(3:3).eq.'A' ) pinfo(m)(4:4) = 'S'
c
c   determine parameter status ................
c
c       Default for parameter status is active.  Alternative status calls are
c  modify, and inactive.  
c	status:Active 	- performs initial parameter modifications and adjusts
c                       parameter iteratively.
c	status:Modify 	- performs initial parameter modifications only.
c	status:Inactive - All parameter modifications are ignored.
c
        istatus = 1
        ki = index(txt,'STATUS')+7
        if(txt(ki:ki) .eq. 'M')  istatus = 0
        if(txt(ki:ki) .eq. 'I')  istatus = -1
c
c  read in an additonal card and get lower, initial, and upper parameter values
c  and matrix identifier if not a constant type modifier.
c
        call ncread(io,txt,ierr)
        call caps(txt,2048)
        call shorten(txt,'INI',3,tx2)
        call qread(rn,1,tx2,ierr)
        par(m) = rn(1)
        call shorten(txt,'UP',2,tx2)
        call qread(rn,1,tx2,ierr)
        up(m) = rn(1)
        call shorten(txt,'LOW',3,tx2)
        call qread(rn,1,tx2,ierr)
        down(m) = rn(1)
c
        iglact(m)=0
        ki = index(txt,'TAG') + 4
        if( ki .gt. 4 ) then
          call shorten(txt,'TAG',3,tx2)
          do i=1,nlines
            if(wtag(i) .eq. tx2(1:4) ) iglact(m) = i
          enddo
	    if( iglact(m).eq.0 ) then
            write(*,'(1x,a40,a4,a14,a4)')
     .      '  Requested non-existent weight matrix, ',tx2,
     .      ' on parameter  ',ptag(m)
            stop'  ----------  Bad parameter definition ------------- '
	    endif
        endif
c
        call limgin(m,par(m),up(m),down(m),istatus,smin,smax,pinfo(m))
c
c     determine in which zones and over what stress periods a parameter may
c  modify.
c
   50 continue
      call ncread(io,txt,ierr)
      call caps(txt,2048)
      ki = index(txt,'*(') - 1
      if( ki .le. -1 ) then
        backspace(io)
        goto 55
      endif
c
c     read global multiplier ..........
c
      tx2 = txt(1:ki)
      call qread(rn,1,tx2,ierr)
      rmult = rn(1)
c
c    find zones to be affected....................
c
      ke = index(txt,')') - 1
      tx2 = txt(ki+3:ke)
      call qread(rn,60,tx2,ierr)
      ia = 60 - ierr
      if( ia .lt. 1 ) ia = 1
c
      do i = 1,ia
        itt  = ifrl( rn(i) )
        xx = itt
        ibase = alog10( xx+zero ) 
        ibase = 10**ibase
        if( mod(itt,ibase) .ne. 0 ) ibase = 1
        if( ierr .ge. 60 ) then
          itt = 1
          ibase = 50000
        endif
        do k = 1,nzones
          it2 = izone(k) - itt
          if( it2.ge.0 .and. it2.lt.ibase ) then
            jcum = jcum + 1
            parb(m,jcum) = rmult
            igbact(m,jcum) = izone(k)
          endif
	  enddo
      enddo
c
      ngbpa(m) = jcum
      if(jcum .gt. mxgb) mxgb = jcum
c
c    extricate applicable stress periods.  key on '[' symbol............
c
      ki = index(txt,'[') + 1
      ke = index(txt,']') - 1
      tx2 = txt(ki:ke)
      call qread(rn,60,tx2,ierr)
      ia = 60 - ierr
c
	call conden( tx2, 2048 )
      if( ki.gt.0 .and. ke.gt.ki .and. ia.eq.0) then
	  ia = iper
        do  i = 1, ia
          rn(i) = i 
        enddo
	endif
c
	if( ki.gt.0 .or. ia.eq.iper ) then
        do  i = 1, ia
          isp  = ifrl( rn(i) )
          sptest = 'TO        '                !   Test if sp are defined by
	    if( isp.lt.10 ) then                 !   isp1 TO isp2 
	      write(sptest(3:3),'(i1)') isp      !
	      kcmp = 3                           !  e.g.:
	    else                                 ! [2 TO 7] would set igpsp(m,iksp)
	      write(sptest(3:4),'(i2)') isp      !  to 1 for SPs  2,3,4,5,6,7
	      kcmp = 4
	    endif
	    if( index(tx2,sptest(1:kcmp)) .gt. 0 ) then
	      iksp = isp
	      do while( igbsp(m,iksp).eq.0 .and. iksp.gt.0 ) 
	        igbsp(m,iksp) = 1
	        iksp = iksp - 1 
	      enddo
	    endif 
          if( ierr .ge. 60 ) isp = i
          igbsp(m,isp) = 1
        enddo
      endif 
c
c   Make corrections to master parameter list if observations are rotated 
c  about production well for analysis of lateral anisotropy of aquifer test  
c
      if( ptype(m)(1:4).eq.'SPIN' .or. ptype(m)(1:3).eq.'ROT' ) then
        ptype(m) = 'SPIN'
	  nga = nga + 1
	  pname(nga) = ptype(m)
        rotrad = parval(down(m),par(m),up(m),pinfo(m))*pi / 180.0
      endif
c
      if( ptype(m).eq.'KYKX' .and. iy.eq.1 ) then
	  nga = nga + 1
	  pname(nga) = ptype(m)
        aniso = parval(down(m),par(m),up(m),pinfo(m))
      endif
c
      goto 50
   55 continue
c
c    check status, if inactive, reset m to m-1.
c
      if( istatus .lt. 0 ) m = m-1
      if(m.le.ma) goto 10
c
c    halt program if more parameters are requested than dimensioned.
c
      write(iout,901)ma
 901  format(1x,'MORE THAN ',i2,' PARAMETERS GIVEN.')
      stop 'ERROR IN PARAMETERS!'
c
   99 npar = m-1
      write(*,*)'A maximum of',npar,' parameters will be estimated.'
c
c   Test parameter tags, zones, and stress periods  STOP MODOPTIM if not linked
c
      do  m=1,npar
c   Test zones 
	  if( ngbpa(m) .lt. 1 ) then
          write(*,*) 
          write(*,*) '  ERROR in parameter definition  '
          write(*,*) '  No zones were defined for the ', m,
     +               ' parameter ',ptag(m),' & type: ',ptype(m) 
          write(*,*) 
          write(iout,*) '  ERROR in parameter definition  '
          write(iout,*) '  No zones were defined for the ', m,
     +               ' parameter ',ptag(m),' & type: ',ptype(m) 
          stop '      MODOPTIM halted.  ' 
	  endif
c   Test Parameter tags 
        iok = 0
        do kk = 1, nga
	    if( pname(kk) .eq. ptype(m) ) iok = 1
	  enddo
	  if( iok .lt. 1 ) then
          write(*,*) 
          write(*,*)'     ERROR in parameter definition  '
          write(*,*)'  The ', m,'th parameter type ', ptype(m)
          write(*,*)'  does not match any parameter names specified in '
          write(*,*)'  the MODFLOW files built from the *.INP file:' 
          write(*,*) 
          write(*,'(1x,10(2x,a4,1h,))') ( pname(kk),kk=1,nga )
          write(*,*) 
          stop '        MODOPTIM halted.  ' 
	  endif
c   Test SP definition
        iok = 0
        do kk = 1, iper
	    if( igbsp(m,kk) .ne. 0 ) iok = 1
	  enddo
	  if( iok .lt. 1 ) then
          write(*,*) 
          write(*,*)'     ERROR in parameter definition  '
          write(*,*)'  NO stress periods were associated with '
          write(*,*)'  The ', m,'th parameter type ', ptype(m)
          write(*,*) 
          stop '        MODOPTIM halted.  ' 
	  endif
      enddo
c
c     describe parameters, ranges, and groups
c
      write(iout,200)
  200 format(/,26('<p>'),//,'Entry',6x,'PINFO',5x,'Tag',7x,'Type',
     . 7x,'Lower',4x,'Initial',4x,'Upper',5x,'Weight',/,42x,
     . 'Limit',5x,'Value',5x,'Limit',5x,'Matrix',/,4x,38('-='),/,
     . 9x,'Zone : Multiplier,    Zone : Multiplier,  ............',/,
     . 4x,76('~'),/,80('-'),/)
c
      do m = 1, npar
        palast(m) = 0.000000
        if( pinfo(m)(3:3).eq.'M') palast(m) = 1.00000
        if( pinfo(m)(4:4).eq.'S') palast(m) = (palast(m)-down(m))/up(m)
c                                                        
	  d = down(m)
        if(pinfo(m)(3:3).eq.'E') d = 10.00**d
        p = parval(down(m),par(m),up(m),pinfo(m))
        u = up(m)
        if(pinfo(m)(4:4).eq.'S') u = u + d
        if(pinfo(m)(3:3).eq.'E') u = 10.00**u
        write(iout,210)m,pinfo(m),ptag(m),ptype(m),d,p,u,iglact(m)
c
  210   format(/,i3,2x,3(6x,a4),5x,3g10.4,i6,/,4x,38('-='))
        write(iout,'(4(I7,A1,G10.4,a1))')(igbact(m,j),':',parb(m,j),
     +             ',',j=1,ngbpa(m))
        write(iout,'(1x,20h stress periods are:,20(i2,1h,))')
     +             (j,j=1,iper)
        write(iout,'(1x,20h   used(1) or not(0),20(i2,1h,))')
     +              (igbsp(m,j),j=1,iper)
        write(iout,'(4x,76(1h~))')
      enddo
c
c    Report all instances of multiple parameters modifying a aquifer property or stress
c
      link = 0 
      do mo = 1, npar-1
        ixlnk = 0 
        do mi = mo+1, npar
          iok = 0     
          if( ptype(mi) .eq. ptype(mo) ) then
c   test zones and SP
            do kk = 1, iper
	        if(igbsp(mi,kk).gt.0 .and. igbsp(mo,kk).gt.0) then
                do ia = 1, ngbpa(mo)
                  do ib = 1, ngbpa(mi)
                    if( igbact(mo,ia) .eq. igbact(mi,ib) ) iok = 1
                  enddo
                enddo
              endif
            enddo
          endif        ! end of ptype-outer = ptype-inner test
          if( iok.gt.0 ) then
            ixlnk = ixlnk + 1
	      izone(ixlnk) = mi
          endif
        enddo          ! end of inner X-link loop
c  Write header if cross-links exist between parameters 
        if( link.eq.0 .and. ixlnk.gt.0 ) then
          link = 1    
          write(iout,'(/,10(8h<X-link>),/)')
          write(iout,'(2x,5hEntry,2x,4h Tag,2h :,2x,
     +                 23hCross-linked parameters,/,2x,75(1h-))')
          write(*,'(/,1x,9(8h<X-link>),/)')
          write(*,'(2x,5hEntry,2x,4h Tag,2h :,2x,
     +                 23hCross-linked parameters,/,2x,75(1h-))')
        endif
c  Write X-link stats for parameter  
        if( ixlnk .gt. 0 ) then 
          write(iout,'(3x,i4,2x,a4,2h :,2x,24(a4,2h, ))') mo, ptag(mo),
     +              (ptag(izone(mii)),mii=1,ixlnk)
          write(*,'(3x,i4,2x,a4,2h :,2x,24(a4,2h, ))') mo, ptag(mo),
     +              (ptag(izone(mii)),mii=1,ixlnk)
        endif	 
      enddo            ! end of outer X-link loop
c 
      write(iout,'(/,26(3h<p>),/)')
c
c  If observations are spun, remove last pname from list
      if( rotrad.lt.1.e9 ) nga = nga - 1
      if(  aniso.gt.zero ) nga = nga - 1
c
      return
      end
c
c.....................................................................
c
      subroutine limgin(m,p,u,d,istat,sn,sx,pinfo)
      include 'optim.h'
      common /unit1/ iu5,iu6,iu7,iu8,iu9,kikoff,iures, iuparm
      common /par3/ up(ma),down(ma),smax,step(ma),stfrc
      common /choke1/ lab(ma)
      character*4 pinfo
      zero=1.e-23
c
      sp = 0
      if( pinfo(3:3) .eq. 'E' ) then
        if( p .lt. zero ) then
          m = m - 1 
	    return
	  endif
        p = alog10(p)
        if( istat.gt.0 .and. u.gt.zero .and. d.gt.zero) then
          u = alog10(u)
          d = alog10(d)
        endif
      endif
c
      if( istat .eq. 0 ) then
	  pinfo(4:4) = 'N'
        u = p
        d = p
        sp = sn*1.1
      endif
c
      if( d.gt.u .or. p.gt.u .or. p.lt.d ) then
        m = m-1
        return
      endif
c
      lab(m) = 99
      if( istat.gt.0 ) then
        a = u - d
        if( pinfo(4:4) .eq. 'S' ) then
          p = (p-d)/a
          u = a
          a = 1.00000000000
        endif
        sp=a*stfrc
        if(sp.gt.sx) sp=sx
        if(sp.lt.sn) then
          write(iu8,80)sp,m,sn
   80     format(1x,' The maximum step,',f9.5,', for parameter',i3,
     .    ' is less than the minimum change,',f9.5,' .')
          stop 'Screw-up in parameter step limits'
        endif
        lab(m)=0
      endif
      step(m)=sp
c
      return
      end
c
c.....................................................................
c
      subroutine spinobs(x0,y0,xw,yw,radians,aniso, xw1,yw1)
      include 'optim.h'
      common /mod1/ dxm(lx),xc(lx),xe(lx1),dym(ly),yc(ly),ye(ly1)
	zero = 1.e-24
c
      dx  = x0 - xw
      dy  = y0 - yw
      r   = (dx**2 + dy**2)**0.5
      theta = fang(dx,dy) - radians 
c
      if( aniso .gt. zero ) then
c   Rotation for 2-D, radially symmetric model
        Req = r * (cos(theta)**2 + sin(theta)**2/aniso)**0.5
c
        xw1 = Req + xe(1)
        yw1 = yc(1)
      else 
c   Rotation for quarter spot, 3-D model
        dx1 = +r * abs(cos(theta))
        dy1 = -r * abs(sin(theta))
c   Production is assumed to from cell (k,1,1)  and is defined here
        xw1 = dx1 + xe(1)
        yw1 = dy1 + ye(1)
      endif 
c
      return
      end
