c_________________________________________________________________________
c
c    Routine allows for designating flow term zones independently of parameter
c  zones.   Input is read in during observation entry ...........
c
      subroutine setiobflx(io,txt,nflxzn) 
      include 'optim.h'
      common /flow2/ iobflx(lxyz),iflxzn(mgb) 
      common /mod3/ ix,iy,iz,ixyz,ixy,iper, izpls
      common /par5/ work(lxyz),izwrk(lxyz),ptime(msp)
	character*4   adim(6) 
	character*2048 txt, tx2
	dimension rn(mrnv)
	data adim /':Z  ',':XY ',':XYZ',':K  ',':IJ ',':IJK'/ 
	data iflxzn/ mgb*0 /
	ntest = 6
c
c   Look for instructions on whether the array input is Z, XY, or XYZ
c
	max = ixyz 
      tx2 = txt
	call caps(tx2,2048) 
	do m = 1, ntest
	  if(index(tx2,adim(m)).gt.0) then
	    idim = mod(m,3) 
	    if( idim.eq.1 ) max = iz 
	    if( idim.eq.2 ) max = ixy 
        endif   
	enddo
c
	if( index(tx2,':GLO').gt.0 ) then
	  idim = -1
	  max = 1
	endif
c
      ki = index(txt,'BY:')
      iby = 0
      if( ki.gt.0 ) then
        tx2 = txt(ki+3:2048)
        call qread(rn,1,tx2,ierr)
        if( ierr .eq.0 ) iby = ifrl( rn(1) )
      endif
c
      call getmat(io,n,max,txt)
c
c    Report error if the number of points read is different
c
      if( n.ne.max ) then 
	  write(*,*)'  User specified',max,'  iobflx points to read'
	  write(*,*)'  but ',n,' points were read'
	  stop '  Error exists in FLUX ZONE input .....'
	else 
        call ncread(io,tx2,ierr)
        call caps(tx2,2048)
	  if( index(tx2,'<END>').eq.0 ) backspace(io)
	endif
c
c    Update IOBFLX array and return ....................
c
	if( idim.eq.-1 ) then
	  do n = 1, ixyz
	    if( iobflx(n).ne.0 ) iobflx(n) = ifrl( work(1) )
        enddo   
	elseif( idim.eq.1 ) then
	  do k = 1, iz 
	    do ij = 1, ixy
	      n = ixy*(k-1) + ij
	      if( iobflx(n).ne.0 ) iobflx(n) = ifrl( work(k) )
	    enddo
        enddo   
	elseif( idim.eq.2 ) then
	  do ij = 1, ixy
	    do k = 1, iz 
	      n = ixy*(k-1) + ij
	      if( iobflx(n).ne.0 ) iobflx(n) = ifrl(work(ij)) + iby*k       
	    enddo
        enddo   
	else 
	  do n = 1, ixyz
	    if( iobflx(n).ne.0 ) iobflx(n) = ifrl( work(n) )
        enddo   
	endif
c
c    catalogue zones not including zone 0
c
      nflxzn = 0
      do n = 1,ixyz
        if( iobflx(n).ne.0) then 
	    iflg = 1
          do m = 1,nflxzn
            if( abs(iobflx(n)).eq.iflxzn(m) ) iflg = 0
          enddo
	    if( iflg.eq.1 ) then
            nflxzn = nflxzn + 1
            iflxzn(nflxzn) = abs(iobflx(n))
	    endif
	  endif
	enddo
c
      if( nflxzn .gt. mgb ) then
        write(*,200) nflxzn,mgb
  200   format(1x,i6,' zones specified which is greater than ',i3)
        stop ' Too many flux zones !!!!!!'
	else
        write(*,'(/,4x,a64)')
     +'An independent zone array has been read for summing FLOW/COST/QW'
        write(*,'(1x,a57,a20)')
     +'The flow zone array (IOBFLX) is NOT = the parameter zone ',
     +'array (IZCUBE)     ' 
        write(*,201) nflxzn,mgb
  201   format(1x,i6,' zones specified out of a possible ',i3)
      endif
c
      return
	end
c ....................................................................
c
      subroutine getflw(buff,ipackg,delt,totim,Tinc)
      include 'optim.h'
      common /flow1/ qsback(mop), qsfwd(mop)
      common /flow2/ iobflx(lxyz),iflxzn(mgb) 
      common /flow3/ iQplusMIN(mop) 
      common /mod1/ dxm(lx),xc(lx),xe(lx1),dym(ly),yc(ly),ye(ly1)
      common /mod2a/obfrc(mop3,mobd),kfrc(mop3,mobd),kpotyp(mop)
      common /mod3/ ix,iy,iz,ixyz,ixy,iper, izpls
      common /comp1/ xo(mop),yo(mop),zo(mop),TIMo(mop),nobs,kobsbk
      common /comp2/ obs(mop),calc(mop3),calcl(mop),wgt(mop*2),res(mop)
      common /comp3/ well(mop),otype(mop),flxcut(mop), qtest, nqtst
      dimension buff(ixyz)
c
      character*4  otype, qtest 
      character*64 well
c
      zero  = 1.e-25
      tlast = totim - delt
	dtest = ( totim - tinc )**2
c
c      Zero buffers  before leaving  MODFLOW subroutine 
c
      if( ipackg .gt. 99 ) then
        do i = 1 , nobs
	    qsback(i) = 0.0000000
	    qsfwd(i)  = 0.0000000 
        enddo
	  return
      endif
c
c     Loop through all observations ..... testing for FLOW
c
      do i = 1 , nobs
        if( otype(i)(1:nqtst).eq.qtest(1:nqtst) ) then
c        test package next
	    dq  = 0.000000000
c	 if to > totim then store Q for interpolation 
          if(TIMo(i).gt. tlast) then
	      kpkg = nint(obfrc(i,ipackg))
            if( kpkg.ne.0 ) then
c      sum flows
              do n = 1,ixyz
                dq1 = 0.00000
                iyn = 0
                do j = 1, mobd
                  if( iobflx(n) .eq. kfrc(i,j) ) then
	              add = buff(n) 
                    if( kpkg.eq.101 ) add = abs(add) 
                    if( iQplusMIN(i).gt.0 .and. add.lt.0.0 ) add = 0.00
                    if( iQplusMIN(i).lt.0 .and. add.gt.0.0 ) add = 0.00
                    dq1  = dq1 + add 
                    iyn = 1
                  endif
                enddo
c   Flux limit can only be applied once per model node 
                if( flxcut(i).lt.1/zero .and. iyn.eq.1 ) then
	            ii = mod((n-1),ix)+1
                  jj = mod((n-1),ixy)/ix +1
			      ql = flxcut(i) * dxm(ii) * dym(jj)  
                  if( dq1.lt.ql ) then
                    dq1 = dq1 - ql  
                  else
                    dq1 = 0.00000  
                  endif
                endif
                dq = dq + dq1
              enddo     !  end of loop through all model nodes
            endif	    !  end of MODFLOW package test
c
c    store accumulated flow in appropriate locations
c           
            if(TIMo(i).gt.tlast .and. TIMo(i).le.totim) then
              if( dTEST.lt.zero ) then 
	          qsfwd(i) = qsfwd(i) + dq
	        else
	          qsfwd(i) = dq
	        endif
c
	        if( kobsbk .ne. 0 ) then
	          calc(i) = qsfwd(i)
	        else
                slp = (qsfwd(i) - qsback(i)) / delt
                calc(i) = slp * (TIMo(i)-tlast) + qsback(i)
	        endif
	      elseif( totim .lt. TIMo(i) ) then
              if( dTEST.lt.zero ) then 
	          qsback(i) = qsback(i) + dq
	        else
	          qsback(i) = dq
	        endif
              qsfwd(i)  = qsback(i)
	      else
	      endif
          endif		!  end of  to > totim  test
        endif
      enddo										   
c
      Tinc = Totim
c
      return
      end
c
c_________________________________________________________________________
c
      subroutine qwlift(delt,totim,well2,nwel2,mxwel2)
      include 'optim.h'
      common /flow1/ qsback(mop), qsfwd(mop)
      common /flow2/ iobflx(lxyz),iflxzn(mgb) 
      common /mod2a/obfrc(mop3,mobd),kfrc(mop3,mobd),kpotyp(mop)
      common /comp1/ xo(mop),yo(mop),zo(mop),TIMo(mop),nobs,kobsbk
      common /comp2/ obs(mop),calc(mop3),calcl(mop),wgt(mop*2),res(mop)
      common /comp3/ well(mop),otype(mop),flxcut(mop), qtest, nqtst
	common /gwmgt1/  qwtst, liftst, nqwtst, nlftst, MNWtst, nMNWtst 
      dimension well2(16,mxwel2)
c
      character*4  otype, qwtst, liftst, qtest, MNWtst 
      character*64 well
c
      zero  = 1.e-25
      tlast = totim - delt
	dtest = 1.000
c	dtest = ( totim - tinc )**2
c
c         3   = Actual flow rate used
c         4   = Water Quality attribute to be averaged by flow
c
c     Loop through all observations ..... testing for CONC, LIFT, and MNW water levels
c
      do i = 1 , nobs
	  itst = 0
        if( otype(i)(1:nqwtst).eq.qwtst(1:nqwtst)
     +       .and. obfrc(i,2).gt.999              ) itst = 2
        if( otype(i)(1:nlftst).eq.liftst(1:nlftst) 
     +       .and. obfrc(i,2).gt.999              ) itst = 3
        if( otype(i)(1:nMNWtst).eq.MNWtst(1:nMNWtst) 
     +       .and. obfrc(i,2).gt.999              ) itst = 4
c
        if( itst.gt.1 ) then
c        test package next
	    dq  = 0.000000000
	    dqc = 0.000000000
c	 if to > totim then store Q for interpolation 
          if(TIMo(i).gt. tlast) then
c      sum QW or lift costs
            do m2 = 1, nwel2
              n = ifrl( well2(1,m2) )
              do j = 1,mobd
                if( iobflx(n) .eq. kfrc(i,j) ) then
                  if( itst.eq.4  ) then
                    dq = well2(10,m2)         !!  Straight MNW water level 
                  else
                    add = well2(3,m2)         !!  Actual flow rate
                    if( itst.eq.2 .and. well2(4,m2).lt.0.0 ) add = 0.000
                    dqc = dqc + add 
                    val = well2(4,m2)         !!  QW concentration 
                    if( itst.eq.3 ) val = well2(10,m2) - well2(8,m2)  
c         8   = Elevation of reference head for computing lift costs
                    if( well2(8,m2) .gt. 1.0/zero ) val = 0.000
                    add = add * val
                    dq  = dq  + add
                  endif
                endif
              enddo
            enddo
            if( itst.eq.2 .and. dqc**2 .gt.zero ) dq = dq / dqc
          endif
c
c    store accumulated CONC or LIFT in appropriate locations
c           
          if(TIMo(i).gt.tlast .and. TIMo(i).le.totim) then
            if( dtest .lt. zero ) then 
	        qsfwd(i) = qsfwd(i) + dq
	      else
	        qsfwd(i) = dq
	      endif
c
	      if( kobsbk .ne. 0 ) then
	        calc(i) = qsfwd(i)
	      else
              slp = (qsfwd(i) - qsback(i)) / delt
              calc(i) = slp * ( TIMo(i)-tlast ) + qsback(i)
	      endif
	    elseif( totim .lt. TIMo(i) ) then
            if( dtest .lt. zero ) then 
	        qsback(i) = qsback(i) + dq
	      else
	        qsback(i) = dq
	      endif
            qsfwd(i)  = qsback(i)
	    else
	    endif
        endif
      enddo
c
	tinc  = totim
c
      return
      end
c
c_________________________________________________________________________
c
      subroutine pass(hold,hnew,delt,totim,qrate1,nwel,
     +                mxwell,well2,nwel2,mxwel2,istoff)
      include 'optim.h'
      common /comp1/ xo(mop),yo(mop),zo(mop),TIMo(mop),nobs,kobsbk
      common /comp2/ obs(mop),calc(mop3),calcl(mop),wgt(mop*2),res(mop)
      common /comp3/ well(mop),otype(mop),flxcut(mop), qtest, nqtst
      common /comp4/ wbs(mop), hw(mop), hwl(mop)
      common /mod1/ dxm(lx),xc(lx),xe(lx1),dym(ly),yc(ly),ye(ly1)
      common /mod2/ dzm(lxyz),zc(lxyz)
      common /mod2a/obfrc(mop3,mobd),kfrc(mop3,mobd),kpotyp(mop)
      common /mod3/ ix,iy,iz,ixyz,ixy,iper, izpls
      common /unit1/ iu5,iu6,iu7,iu8,iu9,kikoff,iures, iuparm
      common /flow1/ qsback(mop), qsfwd(mop)
	common /gwmgt1/  qwtst, liftst, nqwtst, nlftst, MNWtst, nMNWtst 
c
      dimension qrate1(4,mxwell), well2(16,mxwel2)
      dimension hnew(ixyz),hold(ixyz)
      double precision hnew
      character*4  otype, qtest, qwtst, liftst, MNWtst  
      character*64 well
      zero = 1.e-25
c
      tlast = totim - delt
c
      do i = 1 , nobs
        i2 = i + istoff
c
c   Don't allow comparisons to ZONE based observations 
c
       itst = 1
        if( otype(i)(1:nqwtst).eq.qwtst(1:nqwtst)
     +       .and. obfrc(i,2).gt.999              ) itst = 0
        if( otype(i)(1:nlftst).eq.liftst(1:nlftst) 
     +       .and. obfrc(i,2).gt.999              ) itst = 0
        if( otype(i)(1:nMNWtst).eq.MNWtst(1:nMNWtst) 
     +       .and. obfrc(i,2).gt.999              ) itst = 0
       if( otype(i)(1:nqtst) .eq. qtest(1:nqtst)  ) itst = 0
       if( itst.gt.0 ) then
c	  
c     Update all observations that need to account for wellbore storage
c
	  if( abs(wbs(i)) .gt. zero ) then
          o1= 0.000000000
          o2 = 0.000000000
          do j = 1, 8
            m = kfrc(i2,j)
            if( m.ge.1 .and. m.le.ixyz) then
              o1 = o1 + hold(m) * obfrc(i2,j)
              o2 = o2 + hnew(m) * obfrc(i2,j)
            endif
          enddo
  	    if( tlast .lt. zero ) then
		  hwl(i2) = o1
		else
		  hwl(i2) = hw(i2)
		endif
	    if( wbs(i) .gt. zero ) then
c  estimate lag in observation well   
	      hw(i2) = delt*wbs(i)*(o2+o1-hwl(i2)) + hwl(i2)
	 	  hw(i2) = hw(i2) / (1.00 + delt * wbs(i))
	    else
c   Estimate head drop from cell average to wellbore 
            q = 0.0000000000
            do jwel = 1, nwel
	        iq = ifrl( qrate1(3,jwel) )
	        jq = ifrl( qrate1(2,jwel) )
	        kq = ifrl( qrate1(1,jwel) )
              nq = (kq-1)*ixy + (jq-1)*ix + iq 
              if( nq .eq. kfrc(i,3) ) then
                q = q + qrate1(4,jwel)
              endif
            enddo
c       dh = Q * alog(ro/rw) / (2*pi * tran )
            beta = -wbs(i)
            dh = q / beta 
	      hw(i2) = o2 + dh 
   	    endif
	  endif
c 
c     Check to extract any non-FLOW observations 
c
        if(TIMo(i).gt.tlast .and. TIMo(i).le.totim) then
          if( otype(i)(1:nqtst).ne.qtest(1:nqtst) ) then
c      Check for MNW-WL, flow weighted QW or lift costs
c         1   = Well node locator  
c         8   = Elevation of reference head for computing lift costs
c        10   = Water level in wellbore
c        11   = QW averaged 
        if( otype(i)(1:nqwtst).eq.qwtst(1:nqwtst)  .or.
     +      otype(i)(1:nlftst).eq.liftst(1:nlftst) .or.
     +      otype(i)(1:nMNWtst).eq.MNWtst(1:nMNWtst)  ) then
              do n2 = 1, nwel2
                node =  ifrl(well2(1,n2))
                if( node .eq. kfrc(i,3) ) then
                  if( otype(i)(1:nMNWtst).eq.MNWtst(1:nMNWtst) ) then
                    o2 =  well2(10,n2)
                  elseif( otype(i)(1:nqwtst).eq.qwtst(1:nqwtst) ) then
                    o2 =  well2(11,n2)
                  else
                    href  = well2(8,n2)
                    hwell = well2(10,n2)
                    dd    = hwell - href
                    Qact  = well2(3,n2)
                    o2    = Qact * dd
                  endif
                  o1 = qsback(i)
                  if( tlast.lt.zero ) o1 = o2
                endif
              enddo 
c    	 Either preestimated wellbore storage or WL in prod/inject well
	      elseif( abs(wbs(i)) .gt. zero ) then
	 	    o1 = hwl(i2)
			o2 = hw(i2)
c      Interpolate to head IF all other tests fail
            else
              o1 = 0.000000000
              o2 = 0.000000000
              do j = 1, 8
                m = kfrc(i2,j)
                if( m.ge.1 .and. m.le.ixyz) then
                  o1 = o1 + hold(m) * obfrc(i2,j)
                  o2 = o2 + hnew(m) * obfrc(i2,j)
                endif
              enddo
		  endif
c                             
	      if( kobsbk .ne. 0 ) then
	        calc(i2) = o2
	      else
              slp = (o2-o1) / delt
              calc(i2) = slp * (TIMo(i)-tlast) + o1
	      endif
c
            if( abs( calc(i2) ) .gt. 5.E20 ) then
              calc(i2) = obs(i2)
              write(*,*)'i, O1,O2,delt',i,o1,o2,delt
              do j = 1, 8
                m = kfrc(i2,j)
              enddo
            endif
          endif
        endif
c
c    Store o1 estimates for t-inter of CONC and LIFT
c
        if( otype(i)(1:nqwtst).eq.qwtst(1:nqwtst)  .or.
     +      otype(i)(1:nlftst).eq.liftst(1:nlftst) .or.
     +      otype(i)(1:nMNWtst).eq.MNWtst(1:nMNWtst)  ) then
          do n2 = 1, nwel2
            node =  ifrl(well2(1,n2))
            if( node .eq. kfrc(i,3) ) then
              if( otype(i)(1:nMNWtst).eq.MNWtst(1:nMNWtst) ) then
                o1 =  well2(10,n2)
              elseif( otype(i)(1:nqwtst).eq.qwtst(1:nqwtst) ) then
                o1 =  well2(11,n2)
              else
                href  = well2(8,n2)
                hwell = well2(10,n2)
                dd    = hwell - href
                Qact  = well2(3,n2)
                o1    = Qact * dd
              endif
              qsback(i) = o1 
            endif
          enddo 
        endif		!  Are observations in the time of interest?
       endif	   !  Exclude ZONE type observations
	enddo
c
      continue
      return
      end
c
c_________________________________________________________________________
c
      subroutine pasdif 
      include 'optim.h'
      common /flow1/ qsback(mop), qsfwd(mop)
      common /comp1/ xo(mop),yo(mop),zo(mop),TIMo(mop),nobs,kobsbk
      common /comp2/ obs(mop),calc(mop3),calcl(mop),wgt(mop*2),res(mop)
      common /comp3/ well(mop),otype(mop),flxcut(mop), qtest, nqtst
      common /mod2a/obfrc(mop3,mobd),kfrc(mop3,mobd),kpotyp(mop)
c
      character*4  otype, qtest 
      character*64 well
c
      do i = 1 , nobs
        qsfwd(i) = calc(i) 
	enddo
c
c     Generate all calculated water level or flow differences .........
c
      do i = 1 , nobs
        if( kpotyp(i) .gt. 0 ) then
	    calc(i) = qsfwd(i) - qsfwd( kpotyp(i) )
        endif
c
	enddo
c
      return
      end
c ....................................................................
c
      subroutine getsub(sub,buff,delt,totim)
      include 'optim.h'
      common /comp1/ xo(mop),yo(mop),zo(mop),TIMo(mop),nobs,kobsbk
      common /comp2/ obs(mop),calc(mop3),calcl(mop),wgt(mop*2),res(mop)
      common /comp3/ well(mop),otype(mop),flxcut(mop), qtest, nqtst
      common /mod1/ dxm(lx),xc(lx),xe(lx1),dym(ly),yc(ly),ye(ly1)
      common /mod2a/obfrc(mop3,mobd),kfrc(mop3,mobd),kpotyp(mop)
      common /mod3/ ix,iy,iz,ixyz,ixy,iper, izpls
      common /rad1/ iradial
      common /flow1/ qsback(mop), qsfwd(mop)
      common /unit1/ iu5,iu6,iu7,iu8,iu9,kikoff,iures, iuparm
c
      COMMON /IBSCOM/ IBQ(200)
c
      dimension sub(ixyz), buff(ixyz)
      character*4  otype, sbtst
      character*64 well
      pi = 3.141592654
      zero = 1.e-25
	nsbtst = 3
	sbtst  = 'SUB '
c
      tlast = totim - delt
c
c    Accumulate subsidence arrays  
c
      if( iz.eq.1 .and. iy.eq.1 ) then
c   Accumulate subsidence arrays from Left to Right in 1D column 
	  buff(1) = sub(1) * dxm(1)
        do ij = 2, ixy
          buff(ij) = sub(ij)*dxm(ij) + buff(ij-1)
        enddo
      elseif( iz.eq.1  ) then
c   Accumulate subsidence arrays along columns in a 2D X-section or radial system 
        do i = 1, ix
          fact  = 1.0000
          if(iradial.gt.0) fact = 1.0 / (2*pi*xc(i))  
          buff(i) = sub(i) * dym(1) * fact 
          do j = 2, iy
            ij = (j-1)*ix + i     
            add      = sub(ij)*dym(j) * fact  
            buff(ij) = add + buff(ij-ix)
          enddo
        enddo
      else
c    Accumulate subsidence arrays from top to bottom in 3D model
        do ij = 1, ixy
          buff(ij) = sub(ij)
	    do k  = 2,iz
            m = ixy*(k-1) + ij
            if( ibq(k).le.0 ) then 
              buff(m) = sub(m-ixy)
            else
              buff(m) = sub(m) + buff(m-ixy)
            endif
          enddo
        enddo
      endif
c
      do i = 1 , nobs
c   Compare subsidence info ONLY 
        if( otype(i)(1:nsbtst) .eq. sbtst(1:nsbtst) ) then
c   Test if observation are in the time window 
c          if( TIMo(i).le.totim ) then
            o2 = 0.000000000
            do j = 1, 8
              m = kfrc(i,j)
              if( m.ge.1 .and. m.le.ixyz) then
                o2 = o2 + buff(m) * obfrc(i,j)
              endif
            enddo
c		endif
c
          if(TIMo(i).gt.tlast .and. TIMo(i).le.totim) then
            o1 = qsback(i)    
            slp = (o2-o1) / delt
            calc(i) = slp * (TIMo(i)-tlast) + o1
          else
            qsback(i) = o2    
          endif		!  Are observations in the time of interest?
        endif	   !  Compare only subsidence observations 
	enddo
c
      continue
      return
      end
c
