c-----------------------------------------------------------------------
c
      subroutine update
      include 'optim.h'
      common /mod1/ dxm(lx),xc(lx),xe(lx1),dym(ly),yc(ly),ye(ly1)
      common /mod2/ dzm(lxyz),zc(lxyz)
      common /mod2a/obfrc(mop3,mobd),kfrc(mop3,mobd),kpotyp(mop)
      common /mod3/ ix,iy,iz,ixyz,ixy,iper, izpls
      common /mod4/ pname(nall),ixpnam(nall),iuo(nall),iuv(nall)
      common /unit1/ iu5,iu6,iu7,iu8,iu9,kikoff,iures, iuparm
c
      common /par1/ parb(ma,mgb),par(ma),ptype(ma),ptag(ma),pinfo(ma)
     +             ,palast(ma)
      common /par1a/ npar,mxgb,cfi
      common /par2/ izone(mgb),igbact(ma,mgb),iglact(ma),ngbpa(ma),
     +              izcube(lxyz), igbsp(ma,msp)
      common /par3/ up(ma),down(ma),smax,step(ma),stfrc
      common /par4/ weight(mwgt),iwp(ma2)
      common /par5/ work(lxyz),izwrk(lxyz),ptime(msp)
      common /par6/ nzones,nlines,nga
      common /updat1/ ll(lxyz)
      common /comp1/ xo(mop),yo(mop),zo(mop),TIMo(mop),nobs,kobsbk
      common /comp3/ well(mop),otype(mop),flxcut(mop), qtest, nqtst
      common /comp4/ wbs(mop), hw(mop), hwl(mop)
c
      dimension perm1(mop), wbs0(mop)
      character*4 pname,ptype,ptag,pinfo, otype, qtest
      character*64 well
      data ipass1  /0 /
	zero = 1.0E-16
      ios = 0
      iuse = 0
c
      if( ipass1.eq.0 ) then
        do iob = 1,nobs
          wbs0(iob) = wbs(iob)
        enddo
      endif
c
c  all model input that will be varied is scanned first to locate what unit
c  it is in and determine, if it is a matrix, what row of paorig the original
c  input is stored on.
c
      nukit = 0
      do 10 no = 1,nga
        nukit = nukit + 1
        if( iuo(no) .ne. ios ) then
          ios  = iuo(no)
          iuse = ios - 30
          rewind(iuse)
          rewind(ios)
        endif
c
c    loop back until end of file has been read ..............
c
   30 continue
      iwskxy = 0
      call getpar(ios,iuse,pname(no),isp,ifld,nb,ne)
c
      if( ifld .lt. -99998 ) goto 10
      if( ifld .lt. 0 ) goto 35
c                               
c    After acquiring a layer or field of values, process the Aq properties node-by-node
c
      do n = nb, ne
        psum = 0.0000
        iseres = 0
        ichng = 0
c
c   Modelo divide of pointer allows for layers greater than IZ  and the identification 
c       of multiple hydraulic characteristics to be estimated by one parameter......
c
        iptzcb = mod( (ll(n)-1),ixyz+ixy*izpls ) + 1
c
c  Test for individual parameter modification 
        do m = 1, npar
          if( ptype(m) .eq. pname(no) ) then
c
c   test zones and SP
            do ia = 1, ngbpa(m)
              if( igbact(m,ia) .eq. abs(izcube(iptzcb)) ) then
                if( isp.gt.0 )then
                  IGBspTMP = igbsp(m,isp)
                else
                  IGBspTMP = 0
                endif   
                if( iper.eq.0 .or. IGBspTMP.gt.0 .or. isp.eq.0 )then
                  work(n) = work(n)*parb(m,ia)
c   Trip parameter change flag and set type of parameter change 
                  if( ichng .lt. 1 ) then
                    if( pinfo(m)(3:3).eq.'E') ichng = 1        ! exponential 
                    if( pinfo(m)(3:3).eq.'M') ichng = 2        ! multiplicative 
                    if( pinfo(m)(3:3).eq.'A') ichng = 3        ! additive 
                  endif
c   Sum parameter modifiers
                  bx  = par(m)
                  if( pinfo(m)(4:4) .eq. 'S' ) bx = bx*up(m) + down(m)  
                  if( pinfo(m)(1:1).eq.'S' .or. iseres.eq.1 ) then
                    if( bx**2 .lt. zero ) then
                      write(*,*)' Attempted to divide weight',m,' by',bx
                      stop '    bx is too close to zero. '              
                    else 
                      iseres = 1
                      bx = 1.0 / bx
                    endif
                  endif
                  if(iglact(m).ge.1) bx =bx*wgtpnt(iglact(m),iptzcb,isp)
                  if( pinfo(m)(2:2) .eq. 'Z' ) bx = 0.000000
                  psum = psum + bx
                endif
              endif
            enddo
          endif        ! end of ptype=pname test
        enddo
c
c    If sum of weights approximates series resistance, invert psum
        if( iseres .gt. 0 ) psum = 1.00 / psum
c
c  Proceed if a parameter can modify the Aq characteristics 
        if( ichng .gt. 0 ) then
c
c    Extract  info here to change Kxy for observation well storage
c    Test on pname(no) and by layer, if critera are met, trip switch 
c    and get change before putpar 
c
          do iob = 1, nobs
            if( pname(no).eq.well(iob)(61:64) ) then
              obmax = 0.0000	 
              do ka = 1, mobd 	 
                if ( obfrc(iob,ka).gt.obmax ) then
                  obmax = obfrc(iob,ka)	 
                  nwk = ka	 
                endif
              enddo
              if ( kfrc(iob,nwk).eq.iptzcb ) then
                iwskxy  = 1
                perm1(iob) = work( n ) 
              endif
            endif
          enddo
c
c   Modify property at node n accordingly 
          if    ( ichng .eq. 1 ) then
            work(n) = work(n) * 10**psum              ! exponential 
          elseif( ichng .eq. 2 ) then
            work(n) = work(n) * psum                  ! multiplicative 
          elseif( ichng .eq. 3 ) then
            work(n) = work(n) + psum                  ! additive 
          else
	    endif
c
        endif    ! end of parameter modification section ................
      enddo
c
c    write modified parameters to file ..................
c
   35 continue
c
c    Extract Kxy-change info here alter observation well storage effects
c
      if( iwskxy .ne. 0 ) then
        do iob = 1, nobs
          if( pname(no).eq.well(iob)(61:64) ) then
	      do n = nb, ne
              iptzcb = mod( (ll(n)-1),ixyz+ixy*izpls ) + 1
              if ( kfrc(iob,3).eq.iptzcb ) then
                wbs(iob) = wbs0(iob) * work(n) / perm1(iob)  
              endif
            enddo
          endif
        enddo
      endif
c
c    write updated parameters to files ...................
c
      call putpar(ios,iuse,ifld,nb,ne)
c
c   if parameter with transient nature continue until all sp have been
c  accounted.
c
      if( isp.gt.0 .and. isp.lt.iper ) goto 30
c
c   move data to operable unit prior to updating the next parameter.
c
   10 continue
c
      do i = 1, npar
        palast(m) = par(m)
      enddo  
c
      do i=1,nall
        if(iuv(i).gt.4) rewind(iuv(i))
      enddo
      rewind(iu5)
      rewind(iu6)
      ipass1 = 1
      return
c
   69 write(iu8,*)' Abnormal end of file while UPDATING parameters.'
      stop ' DISASTER STRIKES WHILE UPDATING PARAMETERS !!'
      end
c
c-----------------------------------------------------------------------
c
      subroutine getpar(ior,iow,tag,isp,ifld,nb,ne)
      include 'optim.h'
      common /mod3/ ix,iy,iz,ixyz,ixy,iper, izpls
c
      common /par5/ work(lxyz),izwrk(lxyz),ptime(msp)
      common /par6/ nzones,nlines,nga
      common /updat1/ ll(lxyz)
      dimension rn(mrnv)
c
      character*4 tag
      character*8   frmt
      character*2048 txt,tx2
      ifld = 0
      isp  = 0
c
c    Serves to read in all data for a particular parameter by layer or SP.
c
      ncnt = 0        
   10 read(ior,'(a)',end=11) txt
      frmt = '(a0000)'
      write(frmt(3:6),'(i4.4)') itxend( txt )
      write(iow,frmt) txt
      ki = index(txt,tag)
      ncnt = ncnt + 1
      if( ki .lt. 50) goto 10
c
      tx2 = txt(21:40)
      read(txt,'(54x,2i3)',err=20) kt,isp
      nboff= ixy*(kt-1)
      do j = 1,iy
        ne = ix*j
        nb = ne - ix + 1
        read(ior,tx2) (work(n), n=nb,ne)
        do n = nb,ne
          ll(n) = n + nboff
        enddo
      enddo
      nb = ne - ixy + 1
      goto 50
c
c   read from cell-by-cell list files ....................
c
   20 read(txt,'(i10,55x,i5,7x,i4)') ne,isp,ifld
        nb = 1
        do n = nb, ne
          read(ior,'(a)') txt
c
          call caps(txt,2048)
          koff = 0
          ki = index(txt,'KOFF:')
          if( ki.gt.0 ) then
            tx2 = txt(ki+5:2048)
            call qread(rn,1,tx2,ierr)
            if( rn(2).lt.0.5 .and. ierr.eq.0 ) koff=ifrl(rn(1))
          endif
          read(txt,'(3i10,5G10.4)') k,j,i,(rn(l),l=4,ifld)
c
          l = 0
          call node(i,j,k+koff,l,ix,iy,iz)
          ll(n) = l
          work(n) = rn(ifld)
        enddo
c
   50 return
   11 ifld = -99999
      return
      end
c
c-----------------------------------------------------------------------
c
      subroutine putpar(ior,iow,ifld,nb,ne)
      include 'optim.h'
      common /mod3/ ix,iy,iz,ixyz,ixy,iper, izpls
      common /par5/ work(lxyz),izwrk(lxyz),ptime(msp)
c
      character*8   frmt
      character*2048 txt, tx2
c
c    Write updated data to temp. model input files ........
c
      if( ifld .lt. 4 ) then
        backspace(iow)
        read(iow,'(20x,a20)') txt
        do j = nb,ne,ix
          nbb = j
          nee = nbb+ix-1
          write(iow,txt) (work(n),n=nbb,nee)
        enddo
      else
        call bakped( ne, ior )
        ke = ifld*10
        kb = ke - 9
        do n = nb,ne
          read(ior,'(a)') txt
          write(tx2,'(g10.4)') work(n)
          txt(kb:ke) = tx2
          frmt = '(a0000)'
          write(frmt(3:6),'(i4.4)') itxend( txt )
          write(iow,frmt) txt
        enddo
      endif
c
      return
      end
c
c-----------------------------------------------------------------------
c
C
C UNIQUE:	assigns an integer value to a 4 character text string based on
C      its order of occurrence in an array.  e.g. a column vector with 6
C      values:
C 			index       text     UNIQUE integer
C 			  1         STOR           1
C  			  2         PERM           2
C 			  3         STOR           1
C  			  4         PERM           2
C 			  5         VCON           3
C  			  6         STOR           1
C
      subroutine unique(nga,nout,torig,id)
      include 'optim.h'
      dimension text(mop),torig(mop),id(mop)
      character*4 text,torig
c
      n=0
      m=nga
      do i=1,nga
        text(i) = torig(i)
      enddo
c
      do i=1,nga-1
        if(text(i)(1:1).ne.'?') then
          n = n+1
          id(i) = n
          do j = i+1, nga
            if(text(i).eq.text(j)) then
              text(j)(1:1)='?'
              id(j) = n
              m = m-1
            endif
          enddo
        endif
      enddo
c
      if(text(nga)(1:1).ne.'?') id(nga) = m
      nout = id(nga)
c
      return
      end
c
c-----------------------------------------------------------------------
c
      function wgtpnt(m,n,isp)
      include 'optim.h'
      common /mod3/ ix,iy,iz,ixyz,ixy,iper, izpls
      common /par4/ weight(mwgt),iwp(ma2)
c
      nb = iwp(m*2-1) - 1
      l = iwp(m*2)
      if( l .lt. 4 ) then
        call node(i,j,k,n,ix,iy,iz)
        if( l .eq. 1) then
          jpt = i
        elseif( l .eq. 2) then
          jpt = j
        else
          jpt = k
        endif
      elseif( l .eq. 4) then
        jpt = mod((n-1),ixy) + 1
      elseif( l .eq. 5) then
        call node(i,j,k,n,ix,iy,iz)
        jpt = (k-1)*ix + i
      elseif( l .eq. 6) then
        jpt = (n-1)/ix + 1
      elseif( l .eq. 8) then
        jpt = isp
      else
        jpt = n
      endif
      wgtpnt = weight(nb+jpt)
      return
      end
c
