c-----------------------------------------------------------------------
c
      integer function itxend( txt )
	character*2048 txt
	k = 2048
	do while( txt(k:k).eq.' ' .and. k.gt.1 ) 
	  k = k - 1
      enddo
      itxend = k
c 
      return
      end
c
c-----------------------------------------------------------------------
c
      integer function ifrl( r )
	ip = abs(r) + 0.5
	if( r .lt. 0.000 )  ip = -ip
	ifrl = ip
      return
      end
c
c-----------------------------------------------------------------------
c
      function parval(d,pe,u,pinfo)
	character*4 pinfo
c
	p = pe
      if(pinfo(4:4).eq.'S') p = p*u + d
      if(pinfo(3:3).eq.'E') p = 10.00**p
      parval = p
c
      return
      end
c
c-----------------------------------------------------------------------
c
c   NCREAD: reads lines of input and ignores lines that begin with a "#" sign.
c          All information after a ! is wiped from the input card. 
      subroutine ncread(io,txt,ierr)
      character*1024  afile
      character*2048  txt,tx2
	data ioflip,ioalt /69,69/
	maxalp = 2048
c
      ierr = 0
    5 read(io,'(a)',end=10)  txt
      if( txt(1:1) .eq. '#' )  goto 5
      call tab2space(txt)     !!   Replace all spaces with tabs
c
	ki = index(txt,'!')
	if( ki.gt.0 ) then
	  txt(ki:maxalp) = '                                             '
	endif
c
      tx2 = txt
      call caps(tx2,200)
c
c    Test for switching control to an auxillary input file
c
      ki = index(txt,':')
      if( index(tx2,'REDIRECT').gt.0 .and. ki.gt.0 ) then
	  afile = txt(ki+1:maxalp) 
	  ki = index(afile,'  ') - 1
        iohold = io 
        io = ioflip
        ioflip = iohold 
        open(io,file=afile(1:ki),status='OLD',err=20)
        goto 5   
	endif
c
c    Test for returning io control from auxillary input to master input file
c
      if( index(tx2,'RETURN')  .gt.0 .and.
     +    index(tx2,'CONTROL') .gt.0      ) goto 10 
c
      ki = index(tx2,'<END>')
      if( ki .gt. 0 ) then
	  ierr = 1
	  txt(ki+5:maxalp) = '                                           '
	endif
c
      if( index(tx2,'<STOP>') .gt. 0 ) ierr = 2
      return
c
c    Report error in opening auxillary input file and stop MODOPTIM
c
   20 write(*,*)
      write(*,*) '  ERROR opening auxillary input file  '
      write(*,*)
      write(*,'(2x,10h The file:,2x,a40,16h does not exist.)')  afile
      write(*,*) 
      stop ' ' 
c
   10 txt(1:3) = 'EOF'
      if( io .eq. ioalt ) then 
        close(io)
        iohold = io 
        io = ioflip
        ioflip = iohold 
        goto 5   
	else
        ierr = -1
	endif
c
      return
      end
c
c-----------------------------------------------------------------------
C
C SQMAT:	multiplies 2 square matrices.
c
      subroutine sqmat(a,b,ipo)
      include 'optim.h'
      dimension b(ma,ma),a(ma,ma),x(ma,ma)
      do ir=1,ipo
        do ic=1,ipo
          sum=0.000000000000000000
          do ism=1,ipo
            sum=sum+a(ir,ism)*b(ism,ic)
          enddo  
          x(ir,ic)=sum 
        enddo
      enddo
      do ir=1,ipo
        do ic=1,ipo
          b(ir,ic)=x(ir,ic)
        enddo
      enddo
c   
      return
      end
c
c-----------------------------------------------------------------------
c
      subroutine shorten(txt,test,n,tx2)
      character*2048 txt,tx2,test
	maxalp = 2048
c
      tx2 = '???????'
      ki = index(txt,test(1:n))
      if(ki.gt.0) then
        tx2 = txt(ki:maxalp)
        kc = index(tx2,':')+1
        tx2 = tx2(kc:maxalp)
        kc = index(tx2,':')+1
        if( kc .gt. 1 ) tx2 = tx2(1:kc-1)
      endif
      return
      end
c
c-----------------------------------------------------------------------
c
      subroutine conden(txt,nin)
      character*2048 txt
	maxalp = 2048
c
      n = nin
      if( n.ge.64 ) n = 64
      do  i=1,maxalp-n
        txt(n+i:n+i)=' '
      enddo
c
      l=0
      do 10 k=1,n*2
      l=l+1
      if(txt(l:l).eq.' ')then
      do m=l,n
        txt(m:m)=txt(m+1:m+1)
      enddo
      l=l-1
      endif
   10 continue
      return
      end
c
c-----------------------------------------------------------------------
c
      subroutine reform(f,n)
      character*64 f
      if(n.gt.64) n=64
      write(*,*)'  N IN REFORM=',n
      f=','//f(2:n)
      do 10 i=1,n
         if(f(i:i).eq.'X' .or. f(i:i).eq.'x') then
         do l=1,5
         j=i-l
             if(f(j:j).eq.',') then
             jb=j+1
             je=j+l-1
             f= f(1:j)//'A'//f(jb:je)//f(i+1:n)
             goto 10
             endif
         enddo
         endif
   10 continue
      f='('//f(2:n)
      return
      end
c
c-----------------------------------------------------------------------
c
      subroutine gauss (q,x,n)
      include 'optim.h'
      real a(ma,ma1),x(ma),q(ma,ma)
      zero=1.e-10
      nm=n-1
      np=n+1
      do i=1,n
        a(i,np)=x(i)
        do j=1,n
          a(i,j)=q(i,j)
        enddo 
      enddo 
c
      do i=1,nm
        ip=i+1
        do k=ip,n
          if(abs(a(k,i)) .gt. zero) then 
            dv=a(k,i)/a(i,i)
            do j=ip,np
              if(abs(dv) .lt. zero) go to 200
              a(k,j)=a(k,j) - a(i,j)*dv
            enddo
	    endif
        enddo
      enddo
c
      if(abs(a(n,n)) .lt. zero) go to 202
      x(n)=a(n,np)/a(n,n)
      do i=nm,1,-1
       ln=i+1
       dum=a(i,np)
       do j=ln,n
         dum=dum-x(j)*a(i,j)
       enddo
       x(i)=dum/a(i,i)
      enddo
      ad=0.
      go to 130
 200  write(*,1)
      write(*,300) i, a(i,i)
 300  format(//,40x,i5,e20.6)
      go to 130
 202  write(*,1)
      write(*,300) n, a(n,n)
      ad=2.
 130  return
 1    format(//,8x,'BAD INVERSE, ZERO ON DIAGONAL')
      end
c
c-----------------------------------------------------------------------
c
      subroutine getmat(io,m,max,txt)
      include 'optim.h'
      common /par5/ work(lxyz),izwrk(lxyz),ptime(msp)
      dimension rn(mrnv)
      character*2048   txt
	maxalp = 2048
      mxrd = mrnv-2
c
c   test for FREE read statement 
c
      call ncread(io,txt,ierr)
	call caps(txt,maxalp)
	if( index(txt,'FREE') .gt.0 ) then 
c   Read numbers directly as free format
        read(io,*,err=99) (work(i),i=1,max)  
        m = max  
	else
        backspace(io)
c
c   Use robust card reader 
c
        m = 0
        do while( m.lt.max ) 
          call ncread(io,txt,ierrc)
          call qread(rn,mxrd,txt,ierr)
          n = mxrd - ierr
          if( n.lt.1 ) return
          do i = m+1,m+n
            work(i) = rn(i-m)
          enddo
          m = m + n
          if( ierrc.ne.0 .or. rn(mxrd+1).gt.0.5 ) return
        enddo 
      endif 
c
c   test for <end> statement 
c
      call ncread(io,txt,ierr)
	if(ierr.eq.0) backspace(io)
c
      return
c   Error in free format read 
   99	m = 0
      return     
      end
c
c-----------------------------------------------------------------------
c
      subroutine bakped(n,io)
c
      do i=1,n
        backspace(io)
	enddo
c
      return
      end
c
c-----------------------------------------------------------------------
c
      subroutine order2(t,iv,nc,nr)
      include 'optim.h'
      dimension t(ma,ma),iv(ma),tt(ma,ma)
      do 5 i=1,nr
      do 5 j=1,nc
    5 tt(i,j)=t(i,j)
      do 10 i=1,nr
      m=iv(i)
      do 10 j=1,nc
      n=iv(j)
   10 t(i,j)=tt(m,n)
      return
      end
c-----------------------------------------------------------------------
c
      subroutine ordgb2(t,iv,nr,nc)
      include 'optim.h'
      dimension t(ma,mgb),iv(ma),tt(ma,mgb)
      do 5 i=1,nr
      do 5 j=1,nc
    5 tt(i,j)=t(i,j)
      do 10 i=1,nr
      m=iv(i)
      do 10 j=1,nc
   10 t(i,j)=tt(m,j)
      return
      end
c-----------------------------------------------------------------------
c
      subroutine ordnb2(t,iv,nr,nc)
      include 'optim.h'
      dimension t(mop,ma),iv(ma),tt(mop,ma)
      do 5 i=1,nr
      do 5 j=1,nc
    5 tt(i,j)=t(i,j)
      do 10 j=1,nc
      m = iv(j)
      do 10 i=1,nr
   10 t(i,j)= tt(i,m)
      return
      end
c-----------------------------------------------------------------------
c
      subroutine ordei2(im,iv,nr,nc)
      include 'optim.h'
      dimension im(ma,mgb),iv(ma),it(ma,mgb)
      do 5 i=1,nr
      do 5 j=1,nc
    5 it(i,j)=im(i,j)
      do 10 i=1,nr
      m=iv(i)
      do 10 j=1,nc
   10 im(i,j)=it(m,j)
      return
      end
c-----------------------------------------------------------------------
c
      subroutine ordii2(im,iv,nr,nc)
      include 'optim.h'
      dimension im(ma,msp),iv(ma),it(ma,msp)
      do 5 i=1,nr
      do 5 j=1,nc
    5 it(i,j)=im(i,j)
      do 10 i=1,nr
      m=iv(i)
      do 10 j=1,nc
   10 im(i,j)=it(m,j)
      return
      end
c-----------------------------------------------------------------------
c
      subroutine order1(o,iv,nc)
      include 'optim.h'
      dimension o(ma),TIMo(ma),iv(ma)
      do 15 i=1,nc
   15 TIMo(i)=o(i)
      do 20 i=1,nc
      m=iv(i)
   20 o(i)=TIMo(m)
      return
      end
c-----------------------------------------------------------------------
c
      subroutine ordei1(k,iv,nc)
      include 'optim.h'
      dimension k(ma),kk(ma),iv(ma)
      do 15 i=1,nc
   15 kk(i)=k(i)
      do 20 i=1,nc
      m=iv(i)
   20 k(i)=kk(m)
      return
      end
c-----------------------------------------------------------------------
c
      subroutine ordea1(o,iv,nc)
      include 'optim.h'
      dimension o(ma),TIMo(ma),iv(ma)
      character*4 o,TIMo
      do 15 i=1,nc
   15 TIMo(i)=o(i)
      do 20 i=1,nc
      m=iv(i)
   20 o(i)=TIMo(m)
      return
      end
c
c-----------------------------------------------------------------------
c
      subroutine qread(r,ni,ain,ierr)
      include 'optim.h'
      dimension r(mrnv)                                                        
      character*1   tab                                                      
      character*16  form                                                      
      character*2048 atxt, ain  
      maxalp = 2048                                                
      tab = char(9)                         !!     sets  tab delimiter
c                                                                             
c   r(ni+1) records the number of non-numeric entries that were attempted to be read as a number                                                                              
c   r(ni+2) records the last column that was read from the card
c                                                                             
      r(ni+1) = -1.0000
      atxt = ain                                                              
      do i = 1, maxalp
        if( atxt(i:i).eq.tab ) atxt(i:i) = ' '
        if( atxt(i:i).eq.',' ) atxt(i:i) = ' '
        if( atxt(i:i).eq.':' ) atxt(i:i) = ' '
        if( atxt(i:i).eq.'=' ) atxt(i:i) = ' '
      enddo
      n = 1                                                                   
      i = 0                                                                   
   11 r(ni+1) = r(ni+1) + 1
   10 i = i+1                                                                 
      if( i.ge.maxalp ) goto 15                                                   
      if( atxt(i:i).eq.' ' ) then                        
        atxt(i:i) = '?'                                                       
        goto 10                                                               
      endif                                                                   
c                                                                             
      ki = index(atxt,' ')-1                                                  
      nd = ki - i + 1                                                         
      form ='(F??.0)              '                                         
      write(form(3:4),'(i2.2)') nd
      READ (atxt(I:KI),FORM,ERR=13,IOSTAT=ISTAT) R(N)
   13 CONTINUE
      i = ki
      IF (ISTAT.GT.0) GOTO 11  ! PART OF BUG FIX -- ERB
      n = n+1
      if( n.le.ni .and. i.lt.maxalp) goto 10
c                                                                             
  15  n  = n-1                                                                
      ierr = ni - n   
	r(ni+2) = i                                                        
      return                                                                  
      end                                                                     
c
c-----------------------------------------------------------------------
c
      subroutine tab2space(txt)
      character*1   tab                                                      
      character*2048 txt 
      maxalp = 2048                                                
      tab = char(9)                         !!     sets  tab delimiter
c                                                                             
      do i = 1, maxalp
        if( txt(i:i).eq.tab ) txt(i:i) = ' '
      enddo
c                                                                             
      return                                                                  
      end                                                                     
c
c-----------------------------------------------------------------------
c
      subroutine inout(xr,yr,npt,xt,yt,itest)
      include 'optim.h'
      dimension   xr(ln1),yr(ln1),x(ln2),y(ln2),ycc(lcn)
c
c inout:	determines if a point, <xt,yt> lies within an arbitrary closed
c      curve defined by a number, npt, of line segments.
c
c 	the curve is shown to fall within a box defined by the extreme
c      x and y values.  the test fails automatically if the point lies
c      beyond this box.  if the point falls within the box, one proceeds
c      around the curve starting with the smallest x value in the curve.
c      each time the x value of the curve is equal to xt the corresponding
c      y value is saved.  these y values are then sorted from highest to
c      lowest.  the test succeeds if yt falls between any oddly and evenly
c      indexed value (e.g.: 1st and 2nd, 3rd and 4th, ....).
c
c               .------------------1------------.
c               |                  * <xt,yt>    |           passes
c               |                               `----.
c               `------------------2-----.           |
c                          <xt,yt> *     |           |      fails
c                        .---------3-----'           |
c                        |         * <xt,yt>         |      passes
c                        `---------4-----------------'
c
      itest=0
      ixm=1
      iym=1
      ixx=1
      iyx=1
      do i=1,npt
        x(i)=xr(i)
        y(i)=yr(i)
        x(npt+i)=x(i)
        y(npt+i)=y(i)
        if(x(i).gt.x(ixx)) ixx=i
        if(x(i).lt.x(ixm)) ixm=i
        if(y(i).gt.y(iyx)) iyx=i
        if(y(i).lt.y(iym)) iym=i
      enddo
c
      if(xt.lt.x(ixm) .or. yt.lt.y(iym)) goto 99
      if(yt.gt.y(iyx) .or. xt.gt.x(ixx)) goto 99
c
      ipass=1
      iz=0
      do j=ixm,ixm+npt
        if(x(j).lt.xt)then
          if(ipass.eq.0) then
            iz=iz+1
            dx=x(j-1)-x(j)
            dy=y(j-1)-y(j)
            a=dy/dx
            ycc(iz)=a*(xt-x(j-1))+y(j-1)
            ipass=1
          endif
        else
          if(ipass.eq.1) then
            iz=iz+1
            dx=x(j)-x(j-1)
            dy=y(j)-y(j-1)
            a=dy/dx
            ycc(iz)=a*(xt-x(j))+y(j)
            ipass=0
          endif
        endif
      enddo
c
      do i=1,iz
        do j=1,iz-i
          if(ycc(j+1).gt.ycc(j)) then
            d=ycc(j)
            ycc(j)=ycc(j+1)
            ycc(j+1)=d
          endif
	  enddo
	enddo
c
      do i=2,iz,2
        if(ycc(i-1).gt.yt .and. ycc(i).lt.yt) then
          itest=1
          goto 99
        endif
      enddo 
c
  99  return
      end
c
c-----------------------------------------------------------------------
c
      integer function iptext(n, text )
      include 'optim.h'
      character*4 text(mop),tcond(mop), test
c
      nuniq = 0
	test = text(n)  
      do i = 1, n
        tcond(i) = '????'
      enddo
c
      do i = 1, n
	  match = 0
        iuc = 0
        do while( iuc.lt.nuniq )  
          iuc = iuc + 1
          if( text(i).eq.tcond(iuc) ) then
            iuc = nuniq
            match = 1
          endif
        enddo
c
        if( match.eq.0 ) then
          nuniq = nuniq + 1
          tcond(nuniq) = text(i)
        endif
      enddo
c
      iuc = 0
      do while( iuc.lt.nuniq )  
        iuc = iuc + 1
        if( tcond(iuc).eq.test ) then
          iptext = iuc
          iuc = nuniq
        endif
      enddo
c
      return
      end
