c.....................................................................
c
      subroutine slpwgt(io,iu8,wtag)
      include 'optim.h'
      common /mod1/ dxm(lx),xc(lx),xe(lx1),dym(ly),yc(ly),ye(ly1)
      common /mod2/ dzm(lxyz),zc(lxyz)
      common /mod3/ ix,iy,iz,ixyz,ixy,iper, izpls
      common /par4/ weight(mwgt),iwp(ma2)
      common /par5/ work(lxyz),izwrk(lxyz),ptime(msp)
      common /par6/ nzones,nlines,nga
      dimension isq(3)
c
      character*1 tab
      character*3 wxyz(8)
      character*4 wtag(ma)
      character*2048 txt,tx2
	data wxyz/'X  ','Y  ','Z  ','XY ','XZ ','YZ ','XYZ','SP '/
	tab = char(9)
c
c      each weight matrix is identified by an alphanumeric tag.  only
c  a capitalized version of the first 4 letters is retained for parameter
c  identification. a tag is mandatory.
c
c      matricies can be 1, 2, or 3-d as denoted by the type flag. the
c  following types are recognized:
c                x, y, z, xy, xz, yz, or xyz.
c    sequence of letters specifies x, y, or z for iso-line input.
c
c  if matrix is defined by an iso-line, specify input as polarized or absolute.
c
c     choices:   input   |        result
c              ----------+-------------------------------------------
c               polarize |  weight matrix has a + and - side.
c               absolute |  weight matrix values are + distances from line.
c               direct   |  read in matrix directly.
c
c    matricies can be normalized by dividing matrix values by the standard
c  deviation of those values.
c
c   a typical heading line might be:
c
c  tag:kxy    normalize:yes    type:xy     input:polarize
c
c    default values are:
c                        normalize:yes
c                        type:xyz
c                        input:direct
c
      iwp(1) = 1 !iwp is pointer for weights, 1st value starts, 2nd is size
      m = -1
   10 m = m + 2
      call ncread(io,txt,ierr)
      call caps(txt,2048)
      ki = index(txt,'WEIGHT:') + 7
      if( ki .lt. 8) goto 70
        i = (m+1)/2
        wtag(i) = txt(ki:ki+3)
c
c    identify matrix type
c
        ki = index(txt,'TYPE:')+5
        tx2 = txt(ki:ki+3)
        kx = index(tx2,'X')
        ky = index(tx2,'Y')
        kz = index(tx2,'Z')
        npt = 1
        if( kx .gt. 0 ) then
          isq(kx) = 1
          npt = npt * ix
        endif
        if( ky .gt. 0 ) then
          isq(ky) = 2
          npt = npt * iy
        endif
        if( kz .gt. 0 ) then
          isq(kz) = 3
          npt = npt * iz
        endif
c
        do kw = 1,8
          if( tx2(1:3) .eq. wxyz(kw) ) iwp(m+1) = kw
	  enddo
	  if( iwp(m+1).eq.8 ) npt = iper
c
c    check if matrix is to not be normalized
c
      normal = 1
      ki = index(txt,'NORM')
      tx2 = txt(ki:2048)
      ki = index(tx2,':')+1
      if( tx2(ki:ki).eq.'N' .or. tx2(ki:ki).eq.'0' ) normal = 0
c
c     will matrix be read directly or as an iso-line?   if it is read as
c   an iso-line,  1 value only is needed for 1d weights.  for 2-d or 3-d
c   matricies, need at least 2 sets of <x,y> or <x,y,z,> pairs.  iso-line
c   entry is terminated with the <end> flag.
c
      ki = index(txt,'INPUT') + 6
      if( ki.gt.6 .and. txt(ki:ki).eq.'P') then
        input = 1
	  npt = ixyz+1
      else if( ki.gt.6 .and. txt(ki:ki).eq.'A') then
        input = 2
	  npt = ixyz+1
      else
        input = -1
      endif
c
c   read values
c
      call  getmat(io,n,npt,txt)
c
      if( input.gt.0 .and. iwp(m+1).ne.8 )then
	  if( iwp(m+1).lt.4 .or. iwp(m+1).gt.6 ) then
	    write(*,*)'    ---------  ERROR in input ---'
	    write(*,*)'     ISO-LINES are only applied to 2-D matricies. '
	    write(*,*)
	    write(*,*)'   MODOPTIM halted while decoding: '
	    write(*,'(1x,a78)') txt
	    stop ' '
	  endif
c
c    ISO-FILL is only applied to 2-D matricies 
c
	  npt = n 
        call isofil(npt,iwp(m), ipfin ,isq)
	  npt = ipfin
	  iwp(m+2) = ipfin + 1
	  if( input.eq.2 )then
          do n = 1,npt
            weight(n-1+iwp(m)) = abs(weight(n-1+iwp(m)))
	    enddo
	  endif
      elseif( input.gt.0 .and. iwp(m+1).eq.8 )then
c
c Read in SP weights as time, weight pairs and interpolate to midpoint of periods
c
	  npt = n 
        call spwfil( npt,iwp(m), ipfin )
	  npt = ipfin
	  iwp(m+2) = ipfin + 1
	  if( input.eq.2 )then
          do n = 1,npt
            weight(n-1+iwp(m)) = abs(weight(n-1+iwp(m)))
	    enddo
	  endif
      else
c
c   Read in matrix directly  ..........
c
        do n = 1,npt
          weight(n-1+iwp(m)) = work(n)
	  enddo
        iwp(m+2) = iwp(m) + npt
      endif
c
c    calculate sd of values in matrix, no weighting.
c
      s  = 0.0000000000000
      s2 = 0.0000000000000
      nb = iwp(m)
      ne = iwp(m+2)-1
      do n = nb,ne
        s = s  + weight(n)
        s2 = s2 + weight(n)**2
      enddo
	sd = 1.000
      if( npt.gt.1 ) sd = ((npt*s2-s**2) / (npt*(npt-1)) )**0.5
      avg = s / npt
c
c    normalize matrix if requested ..................
c
      if( normal .gt. 0 ) then
        do n=nb,ne
          weight(n) = weight(n)/sd
        enddo
      endif
c
      i = (m+1)/2
      write(iu8,101)i,sd,avg
  101 format(/,27('<w>'),/,4x,'Weight matrix,',i3,'  original SD=',
     . f8.1,' and  AVG=',f9.1)
      write(iu8,*)'  Matrix tag is: ',wtag(i),'  & type is:',
     +            wxyz(iwp(m+1))
	if (iwp(m+1).eq.8 ) then
        write(iu8,'(2x,5h  SP ,8x,4hTIME,10x,8h  WEIGHT)')
        write(iu8,'(2x,i5,2g15.6)') (n,ptime(n-nb+2), weight(n),n=nb,ne)
      else  
	  do nbb = nb, ne, ix
	    nee = nbb + ix - 1
          if( nee.gt.ne ) nee = ne
          write(iu8,'(400(a1,g13.6))') (tab,weight(n),n=nbb,nee)
	  enddo
	endif
c
      goto 10
  900 stop 'ERROR IN LINE SEGMENT ENTRY'
   70 nlines = m-1
      backspace(io)
  103 format(/,4x,'Layer',i3,/,80('-'))
      write(iu8,'(/,27(3h<w>),/)')
      return
      end
c
c......................................................................
c
      subroutine spwfil(npts, jpb, jpf)
      include 'optim.h'
      common /mod3/ ix,iy,iz,ixyz,ixy,iper, izpls
      common /par4/ weight(mwgt),iwp(ma2)
      common /par5/ work(lxyz),izwrk(lxyz),ptime(msp)
	dimension x(ln1),y(ln1)
c
      jpf = jpb - 1
c
      do i= 2,npts,2
        x(i/2) = work(i-1)
        y(i/2) = work(i)
	enddo
      npt = npts/2 + 1
c
      do k = 1, iper
        jpf = jpf + 1
c   interpolate time at end of stress period with x and assign y
        tint = ptime(k+1) 
        weight(jpf) = xyarc(npt,x,y,tint)
      enddo
c
      return
      end
c
c......................................................................
c
      function xyarc(np,x,y,xint)
      include 'optim.h'
	dimension x(ln1),y(ln1)
	zero = 1.e-25
c
      xyarc = 0.000000000
c
      do j = 2, np
	  if( xint.gt.x(j-1) .and. xint.le.x(j) ) then
	    dxs = x(j) - x(j-1)
	    dys = y(j) - y(j-1)
	    dx  = xint - x(j-1)
	    frc = 1.0
	    if(dxs**2.gt.zero) frc = dx / dxs
	    xyarc = y(j-1) + dys * frc
	  endif
	enddo
c
      return
      end
c
c......................................................................
c
      subroutine isofil(npts, jpb, jpf, isq)
      include 'optim.h'
      common /mod1/ dxm(lx),xc(lx),xe(lx1),dym(ly),yc(ly),ye(ly1)
      common /mod2/ dzm(lxyz),zc(lxyz)
      common /mod3/ ix,iy,iz,ixyz,ixy,iper, izpls
      common /par4/ weight(mwgt),iwp(ma2)
      common /par5/ work(lxyz),izwrk(lxyz),ptime(msp)
	dimension isq(3), pl(3)
c
      kkk = 1
      jjj = 1
      iii = 1
      if( isq(1).eq.1 .or. isq(2).eq.1 .or. isq(3).eq.1 ) iii = ix
      if( isq(2).eq.2 .or. isq(2).eq.2 .or. isq(3).eq.2 ) jjj = iy
      if( isq(3).eq.3 .or. isq(2).eq.3 .or. isq(3).eq.3 ) kkk = iz
	i1 = isq(1)
	i2 = isq(2)
c
      jpf = jpb - 1
c
c   loop through model arrays 
c
      do k = 1, kkk
        do j = 1, jjj
          do i = 1, iii
            nn = 0
            call node(i,j,k,nn,iii,jjj,kkk)
            pl(1) = xc(i)
            pl(2) = yc(j)
            pl(3) = zc(nn)
c
            jpf = jpf + 1
            rmin   = 1.e25
	      ptback = rmin
            do n = 4, npts, 2
	        xm1 = work(n-3)
	        ym1 = work(n-2)
	        x   = work(n-1)
	        y   = work(n  )
	        xp1 = work(n+1)
	        yp1 = work(n+2)
c
c compute dx, dy components of segment and vector to estimation point
c
	        dxb = xm1 - x
	        dyb = ym1 - y   
	        dxf = xp1 - x
	        dyf = yp1 - y   
c
              dxa = pl(i1) - xm1
              dya = pl(i2) - ym1
              vqa =( dxa**2 + dya**2 )**0.5
c
c  compute angle between vectors  and bisectors  
c  Use of angles swung ccw from back vector to forward vector - keeps polarity consistent
c
	        half = v2rad(dxb,dyb,dxf,dyf) / 2
		    biang=  fang(dxb,dyb) + half
		    dxbi = cos(biang)
		    dybi = sin(biang)   
              bit  = y * dxbi - x * dybi 
c               
c    Estimate perpendicular distance between segment and point 
c  
	        angp = v2rad(dxb,dyb,dxa,dya)  
              r  = vqa * sin(angp)
c
c    Test if estimation point falls in the zone of influence
c  
              irsw=1
              ptest = pl(i2)*dxbi - pl(i1)*dybi 
	        ptfwd = ptest - bit
	        if( n .eq. npts ) ptfwd = -1.00
              if(ptfwd.gt.0.00 .or. ptback.lt.0.00 ) irsw=0
              if(irsw.eq.1 .and. r.le.abs(rmin)) then
                rmin = r
              endif
              ptback = ptfwd
            enddo
            weight(jpf) = rmin
          enddo
        enddo
      enddo
c
      return
      end
c......................................................................
c  
	function v2rad(dx1,dy1,dx2,dy2)  
      zero=1.e-8                                                              
      pi=3.14159265                                                           
c
c  Report all angles as swung through a counterclockwise arc from vector 1 to 2
c
	ang1 = fang(dx1,dy1)
	ang2 = fang(dx2,dy2)
	if( ang2 .lt. ang1 ) ang2 = ang2 + 2*pi
	v2rad = ang2 - ang1
c
      return
      end
c
c ................................................                            
c                                                                             
      function fang(dx,dy)                                                    
      zero=1.e-8                                                              
      pi=3.14159265                                                           
      if(abs(dx) .gt. zero) then                                              
        rat=dy/dx                                                             
        fang=atan(rat)                                                        
      else                                                                    
        fang=pi/2                                                             
        if(dy.lt.0.0) fang=-fang                                              
      endif                                                                   
      if( dx .lt.-zero) fang = fang - pi                                      
	if( fang .lt. -zero)  fang = fang + 2*pi  
      return                                                                  
      end                                                                     
c
