c.....................................................................
c
      subroutine zones( io, iom )
      include 'optim.h'
      common /mod1/ dxm(lx),xc(lx),xe(lx1),dym(ly),yc(ly),ye(ly1)
      common /mod2/ dzm(lxyz),zc(lxyz)
      common /mod3/ ix,iy,iz,ixyz,ixy,iper, izpls
      common /par2/ izone(mgb),igbact(ma,mgb),iglact(ma),ngbpa(ma),
     +              izcube(lxyz) , igbsp(ma,msp)
      common /par5/ work(lxyz),izwrk(lxyz),ptime(msp)
      common /par6/ nzones,nlines,nga
      common /unit1/ iu5,iu6,iu7,iu8,iu9,kikoff,iures, iuparm
      dimension lcon(80), rn(mrnv)
      character*2048 txt,tx2
	zero = 1.e-25
c
c     enter zoneation information through ibound array and pull from model
c  input file.  zones can be delineated:
c                      - directly through full 3-d matrix or
c                      - polygons to define area inside or outside of zone
c  first txt flags data entry type.  if the fragment "direct" is detected,
c  full matrix is read.  otherwise assume polygon entry.
c
c     for polygon entry, first asks for global value to fill matrix. a null
c  response is assumed to mean 0.  thereafter enter data as follows:
c
c    model outline  layer:-1,2,3,4    zone:1   by:10
c      x1    y1
c      x2    y2
c      .     .
c   <end>
c
c  for each polygon.
c
c   - layer: specifies layers where polygon will define zone.
c       negative value for layer serves to flag specified head in ibound.
c   - zone: provides tag to be used in ibound and izcube.
c       positive zone ids apply id to inside of polygon while negative zone
c       ids apply id to outside of polygon.
c   - by: defines incrementation of zone # by layer
c         i.e.   id = [ abs(layer) * by  +  abs(zone) ] * layer / abs(layer)
c
c     if the # of points defining a polygon is less than 3, it is assumed
c   a polygon that encompasses the entire model was intended.
c
	ixyzp = ixyz + ixy*izpls
c
      call ncread(io,txt,ierr)
      call caps(txt,2048)
      if( index(txt,'DIRECT') .gt. 0) then
	  ki = index(txt,'BY:')
	  iby = 0
	  if( ki.gt.0 ) then
	    tx2 = txt(ki+3:2048)
          call qread(rn,1,tx2,ierr)
	    if( ierr .eq.0 ) iby = ifrl( rn(1) )
	  endif
c
        call  getmat(io,n,ixyzp,txt)
        if( n.eq.1 ) then
	    ipole = ifrl(  work(1) )
          do i = 1, ixyzp
            izcube(i) = ipole
 	    enddo
        else if( n.eq.ixyzp ) then
          do i = 1, ixyzp
            izcube(i) = ifrl( work(i) ) 
	    enddo
        else if( n.eq.iz+izpls ) then
          do k = 1, iz+izpls 
	      ipole = ifrl( work(k) )
            do i=1+(k-1)*ixy,k*ixy
              izcube(i) = ipole
	      enddo
	    enddo
        else if( n.eq.ixy ) then
          do k = 1, iz+izpls
            do i = 1, ixy
	        n = (k-1)*ixy + i
              ipole =  k*iby + abs( work(i) ) + 0.5
              if( work(i) .lt. 0 ) ipole = -ipole
              if( work(i)**2 .lt. zero ) ipole = 0
              izcube(n) = ipole
	      enddo
	    enddo
        else
           stop'  Error in zonation data '
        endif
      else
c
c    fill izcube matrix with global value.
c
        iglobe = 0
        if( index(txt,'GLOB') .gt. 0) then
          call qread(rn,1,txt,ierr)
          if( ierr .eq. 0 ) iglobe = ifrl( rn(1) )
        else
          backspace( io )
	  endif
        do n=1,ixyzp
          izcube(n) = iglobe
	  enddo
c
c   read polygons and modify izcube accordingly.
c
   20   continue
        call ncread(io,txt,ierr)
        if( ierr .ne. 0 ) goto 35
        call caps(txt,2048)
c
        call shorten(txt,'ZONE',4,tx2)
        if( tx2(1:1) .ne. '?' ) then
          call qread(rn,1,tx2,ierr)
          if(ierr.eq.0) then
            izn = ifrl( rn(1) )
	    endif
        else
          backspace( io )
          goto 35
        endif
c
        iby = 0
        call shorten(txt,'BY',2,tx2)
        if( tx2(1:1) .ne. '?' ) then
          call qread(rn,1,tx2,ierr)
          if(ierr.eq.0) iby = ifrl( rn(1) )
        endif
c
        nlay = iz
        call shorten(txt,'LAY',3,tx2)
        if( tx2(1:1) .ne. '?' ) then
          call qread(rn,iz,tx2,ierr)
          if(ierr .lt. iz) nlay = iz - ierr
          do k = 1,nlay
            lcon(k) = k
            if(ierr .lt. iz) lcon(k) = ifrl( rn(k) )
          enddo 
	  else
	    stop ' A layer was not specified for a polygon entry '
        endif
        call polyin(io,izn,nlay,lcon,iby)
        goto 20
   35   continue
      endif
c
c  Write preliminary zonation info to MODFLOW ibound arrays
c
      do k=1,iz
        write(iom,'(2I10,A20,I10)')iu5,1,'(500I5)',+7
        do  j=1,iy
          nb=0
          call node(1,j,k,nb,ix,iy,iz)
          ne = nb + ix - 1
          write(iom,'(500I5)') (izcube(n),n=nb,ne)
        enddo
      enddo 
c
      return
      end
c
c.....................................................................
c
      subroutine zoneout(ioo)
      include 'optim.h'
      common /mod1/ dxm(lx),xc(lx),xe(lx1),dym(ly),yc(ly),ye(ly1)
      common /mod2/ dzm(lxyz),zc(lxyz)
      common /mod3/ ix,iy,iz,ixyz,ixy,iper, izpls
      common /par2/ izone(mgb),igbact(ma,mgb),iglact(ma),ngbpa(ma),
     +              izcube(lxyz) , igbsp(ma,msp)
      common /par5/ work(lxyz),izwrk(lxyz),ptime(msp)
      common /par6/ nzones,nlines,nga
      common /flow2/ iobflx(lxyz),iflxzn(mgb) 
      common /unit1/ iu5,iu6,iu7,iu8,iu9,kikoff,iures, iuparm
c
c    catalogue zones not including zone 0
c
      if( izpls.lt.0 ) izpls = 0
      nzones = 0
        do n = 1, ixyz + ixy*izpls
        if( izcube(n).ne.0) then 
	    iflg = 1
          do m = 1,nzones
            if( abs(izcube(n)).eq.izone(m) ) iflg = 0
          enddo
	    if( iflg.eq.1 ) then
            nzones = nzones + 1
            izone(nzones) = abs(izcube(n))
	    endif
	  endif
	enddo
c
      if( nzones .gt. mgb ) then
        write(ioo,200) nzones,mgb
  200   format(1x,i3,'zones specified which is greater than ',i3)
        stop ' Too many zones !!!!!!'
      endif
c
c   provide abbreviated list of zones with description in optimization output.
c
      write(ioo,100)
 100  format(/,26('<z>'),/)
      do 110 m=1,nzones
 110  write(ioo,'(3x,i5,i10,10x)')m,izone(m)
      write(ioo,100)
      write(ioo,102)
  102 format(1x,30('.'),' Zone Assignments ',31('.'))
  103 format(/,4x,'Layer',i3,/,80('-'))
c
      do k = 1, iz+izpls
        write(ioo,103)k
        do  j = 1, iy
          ne = (k-1)*ixy + j*ix  
          nb = ne - ix + 1
          write(ioo,'(I4,A1,500I5)') j,':',(izcube(n),n=nb,ne)
        enddo
      enddo 
      write(ioo,100)
c
c    Set IOBFLX array = to entire IZCUBE array .......
c
      do n = 1, ixyz + ixy*izpls
        iobflx(n) = izcube(n)
      enddo
c
      return
      end
c
c.....................................................................
c
      subroutine polyin(io,izn,nlay,lay,iby)
      include 'optim.h'
      common /mod1/ dxm(lx),xc(lx),xe(lx1),dym(ly),yc(ly),ye(ly1)
      common /mod3/ ix,iy,iz,ixyz,ixy,iper, izpls
      common /par2/ izone(mgb),igbact(ma,mgb),iglact(ma),ngbpa(ma),
     .              izcube(lxyz) , igbsp(ma,msp)
      common /par5/ work(lxyz),izwrk(lxyz),ptime(msp)
      dimension lay(80),x(ln1),y(ln1)
	character*2048 txt
c
      call  getmat(io,n,ixyz,txt)
      if( mod(n,2) .ne. 0 ) then
        stop'Error in polygon input. Odd number of X,Y values read.'
      endif
      do i= 2,n,2
        x(i/2) = work(i-1)
        y(i/2) = work(i)
	enddo
      n = n/2 + 1
      x(n) = x(1)
      y(n) = y(1)
c
c   check if the interior or exterior of the polygon is to be defined.
c
      iplus = 0
      if( izn .lt. 0 ) iplus = 1
      izn = abs(izn)
c
c   apply zoneation info to izcube ............
c
      do j=1,iy
        do i=1,ix
          inoc = 1
          if( n.gt.3 ) call inout(x,y,n,xc(i),yc(j),inoc)
          inoc = mod(inoc+iplus,2)
          if(inoc.eq.1) then
            do k=1,nlay
              l = 0
              kk = abs(lay(k))
              call node(i,j,kk,l,ix,iy,iz)
              nd = (kk-1)*ixy + (j-1)*ix + i
              izcube(nd) = ( kk * iby + izn ) * lay(k) / kk
            enddo         
	    endif
        enddo         
      enddo         
c
      return
      end
c
