      subroutine rch2al(isum,lenx,lcirch,lcrech,lcrlsd,lcrch0,nrchop,
     +                lcrcnd,ncol,nrow,in,iout,irchcb,rchigh,iorchcond)
c
c-----version 1.00  may1999  rch1al
c     ******************************************************************
c     allocate array storage for recharge
c     ******************************************************************
c
c        specifications:
c     ------------------------------------------------------------------
	dimension rn(120)
      character*256 txt, tx2 
      iorchcond = 0
c     ------------------------------------------------------------------
c
c1------identify package.
      write(iout,1)
    1 format(1h0,'RCH2 -- RECHARGE PACKAGE, VERSION 1, 05/12/99')
c
c2------read nrchop and irchcb.
      read(in,'(a)') txt
      read(txt,'(2i10)')nrchop,irchcb
      rchigh = 100.0
c
      tx2 = txt
	call caps(tx2,256)
	ki = index(txt,'COND-OUT:')
	if( ki.gt.0 ) then
        tx2 = txt(ki+9:256)
        iorchcond = 123
        open(iorchcond, file=tx2 )
	endif
c
	call caps(txt,256)
	ki = index(txt,'HIGH:')
	if( ki.gt.0 ) then
        tx2 = txt(ki+5:256)
	  call qread(rn,1,tx2,ierr)
	  if(ierr.eq.0) rchigh = rn(1)
	endif
c
c3------check to see that option is legal.
      if(nrchop.lt.1 .or. nrchop.gt.3) then
c3a-----if illegal print a message and abort simulation
        write(iout,8)
    8   format(1x,'ILLEGAL OPTION CODE. SIMULATION ABORTING')
        stop
	endif
c
c4------if option is legal print option code.
  200 irk=isum
      if(nrchop.eq.1) write(iout,201)
  201 format(1x,'OPTION 1 -- RECHARGE TO TOP LAYER')
      if(nrchop.eq.2) write(iout,202)
  202 format(1x,'OPTION 2 -- RECHARGE TO ONE SPECIFIED NODE IN EACH',
     1        ' VERTICAL COLUMN')
      if(nrchop.eq.3) write(iout,203)
  203 format(1x,'OPTION 3 -- RECHARGE TO HIGHEST ACTIVE NODE IN EACH',
     1        ' VERTICAL COLUMN')
c
c5------if cell-by-cell flow  terms to be saved then print unit #
      if(irchcb.gt.0) write(iout,204) irchcb
  204 format(1x,'CELL-BY-CELL FLOW TERMS WILL BE RECORDED ON UNIT',i3)
c
c6------allocate space for the Land surface array  .
      lcrlsd = isum
      isum   = isum + ncol*nrow
c6------allocate space for working recharge array(rech).
      lcrech = isum
      isum   = isum + ncol*nrow
c6------allocate space for original recharge array(rech).
      lcrch0 = isum
      isum   = isum + ncol*nrow
c6------allocate space for conductance array (Needed only for output)
      lcrcnd = isum
      isum   = isum + ncol*nrow
c
      lcirch = isum
      if( nrchop.eq.2 .or. nrchop.eq.3 ) then
        isum = isum+ncol*nrow
	endif
C
c
c8------calculate and print amount of space used by recharge.
      irk = isum-irk
      write(iout,4)irk
    4 format(1x,i7,' ELEMENTS OF X ARRAY USED FOR RECHARGE')
      isum1 = isum-1
      write(iout,5)isum1,lenx
    5 format(1x,i7,' ELEMENTS OF X ARRAY USED OUT OF',i8)
      if(isum1.gt.lenx)write(iout,6)
    6 format(1x,'   ***X ARRAY MUST BE MADE LARGER***')
c
c9------return
      return
      end
c
c.....................................................................
c
      subroutine rch2rp(nrchop,irch,rech,rech0,rlsd,delr,delc,
     +            nrow,ncol,in,iout,kper)
c
c-----version 1.00  may1999  rch1rp
c     ******************************************************************
c     read recharge rates
c     ******************************************************************
c
c        specifications:
c     ------------------------------------------------------------------
      CHARACTER*24 ANAME(3)
      dimension irch(ncol,nrow),rech(ncol,nrow),rech0(ncol,nrow),
     +  rlsd(ncol,nrow), delr(ncol),delc(nrow)
C
      DATA ANAME(1) /'    RECHARGE LAYER INDEX'/
      DATA ANAME(2) /'                RECHARGE'/
      DATA ANAME(3) /'      LAND SURFACE DATUM'/
c     ------------------------------------------------------------------
c
c   IF this is the first SP, set default land surface elevations 
      if( kper.eq.1 ) then
        do ir = 1,nrow
          do ic = 1,ncol
            rlsd(ic,ir) = 1.0e25
          enddo
        enddo
      endif
c1------read flags showing whether data is to be reused.
      read(in,'(3i10)')inrech ,inirch, inlsd
c
c2------test inrech to see where rech is coming from.
      if(inrech.lt.0) then 
c2a-----if inrech<0 then reuse recharge array from last stress period
        write(iout,3)
    3   format(1h0,'REUSING RECH FROM LAST STRESS PERIOD')
      else 
c3------if inrech=>0 then call u2drel to read recharge rate.
        call u2drel(rech,aname(2),nrow,ncol,0,in,iout)
c4------multiply recharge rate by cell area to get volumetric rate.
        do ir = 1,nrow
          do ic = 1,ncol
            rech(ic,ir)  = rech(ic,ir)*delr(ic)*delc(ir)
            rech0(ic,ir) = rech(ic,ir)
          enddo
        enddo
      endif 
c
c5------if nrchop=2 then a layer indicator array is needed.
      if(nrchop.eq.2 ) then 
        if( inirch.lt.0 ) then 
c6------if inirch<0 then reuse layer indicator array.
          write(iout,2)
    2     format(1h0,'REUSING IRCH FROM LAST STRESS PERIOD')
        else 
c7------if inirch=>0 call u2dint to read layer ind array(irch)
          call u2dint(irch,aname(1),nrow,ncol,0,in,iout)
        endif
      endif
c
      if( inlsd.lt.0 ) then 
        write(iout,'(35hREUSING LSD FROM LAST STRESS PERIOD)')
      elseif( inlsd.eq.0) then 
        write(iout,4)
    4   format(46hLand Surface is NOT used to constrain recharge) 
      else 
        call u2drel(rlsd,aname(3),nrow,ncol,0,in,iout)
      endif 
c
c8------return
      return
      end
c
c.....................................................................
c
      subroutine rch2fm(nrchop,irch,rech,rech0,rlsd,rcond,rhs,hcof,
     +                  ibound, hnew,cr,cc,cv,ncol,nrow,nodes,rchigh)
c
c-----version 1.00  may1999  rch2fm
c     ******************************************************************
c     add recharge to rhs
c     ******************************************************************
c
c        specifications:
c     ------------------------------------------------------------------
      dimension irch(ncol*nrow),rech(ncol*nrow), rech0(ncol*nrow),
     +  rlsd(ncol*nrow), rhs(nodes),ibound(nodes), hcof(nodes), 
     +  rcond(nodes)
	dimension cr(nodes),cc(nodes),cv(nodes)
	dimension hnew(nodes)
      double precision hnew
	zero = 1.0e-20
c     ------------------------------------------------------------------
c
      do ixy = 1, nrow*ncol
c1a-----if cell is external there is no recharge into it.
        if( nrchop.eq.1 ) then
          nl = ixy
        elseif( nrchop.eq.2 ) then
          nl = ixy + (abs(irch(ixy))-1)* nrow*ncol
        else 
          nl = 0
	    nnl= ixy
          do while( nl.eq.0 .and. nnl.lt.nodes)
c5a-----if cell is constant head move on to next horizontal location.
            if( ibound(nnl).lt.0 ) nl = -nodes
c5b-----if cell is inactive move down to next cell.
            if( ibound(nnl).gt.0 ) nl = nnl
	      nnl = nnl + nrow*ncol
          enddo  
        endif
c
c   Qactual must be less than or equal to Q desired.
c
        qdes = rech0(ixy)
        qact = rech(ixy)
        cond = rchigh*condmx(nl,cr,cc,cv,ibound,ncol,nrow,nodes)
        rcond(ixy) = cond
c
c  if cell is active and unspecified  --- simulate recharge 
        if( nl.gt.0 ) ibd = ibound(nl)
        if( ibd.gt.0 )then 
          hlsd = rlsd(ixy) 
          hsim = hnew(nl)  
          if(hlsd.lt.1/zero) qact = ( hlsd - hsim ) * cond  
c  Recharge will be simulated as a specified rate or GHB
          iqslv = 0 
          if( hsim .gt. hlsd ) iqslv = 1 
          if( qdes .gt. qact ) iqslv = 1 
c  Test that recharge does not exceed maximum
          if( qact .gt. qdes ) then
            qact = qdes
            iqslv = 0 
          endif
c   Modify HCOF and RHS arrays
	    if( iqslv.ne.0 ) then 
            hcof(nl) = hcof(nl) - cond
            rhs(nl)  = rhs(nl)  - cond * hlsd
          else
c  Specify Q and solve for head;  add Q to RHS accumulator.
            rhs(nl) = rhs(nl) - qact
          endif
          rech(ixy) = qact 
        endif
      enddo
c
c4------return
      return
      end
c
c.....................................................................
c
      function condmx(n,cr,cc,cv,ibound,ncol,nrow,nodes)
c
c        specifications:
c     ------------------------------------------------------------------
      dimension ibound(nodes)
	dimension cr(nodes),cc(nodes),cv(nodes)
c     ------------------------------------------------------------------
c
c  Check for ibound being active
      condmx = 0.00000 
      if (ibound(n).le.0) return 
      nlay = nodes / (nrow*ncol) 
c
c  Set ijk pointers 
      kz = (n-1) / (nrow*ncol) + 1
      jy = mod((n-1),nrow*ncol)/ncol + 1 
      ix = mod((n-1),ncol) + 1  
c
c6a----add conductance from the left face
      if( ix.gt.1 )then
        if( ibound(n-1).ne.0 ) then 
          condmx = condmx + cr(n-1)
        endif
	endif
c6b----add conductance from the right face
      if( ix.lt.ncol ) then 
        if( ibound(n+1).ne.0 ) then 
          condmx = condmx + cr(n)
        endif
	endif
c6c----add conductance from the back face.
      if( jy.gt.1 ) then 
        if( ibound(n-ncol).ne.0 ) then 
          condmx = condmx + cc(n-ncol)
        endif
	endif
c6d----add conductance from the front face.
      if( jy.lt.nrow ) then 
        if( ibound(n+ncol).ne.0 ) then 
          condmx = condmx + cc(n)
        endif
	endif
c6f----add conductance from the lower face.
      if( kz.lt.nlay ) then 
        if( ibound(n+ncol*nrow).ne.0 ) then 
          condmx = condmx + cv(n)
        endif
	endif
c
      return
      end
c
c.....................................................................
c
      subroutine rch2bd(nrchop,irch,rech,rlsd,rcond,ibound,
     +                  nrow,ncol,nlay,delt,vbvl,vbnm,msum,kstp,kper,
     +                  irchcb,icbcfl,buff,iout,iorchcond)
c
c-----version 1.00  may1999  rch2bd
c     ******************************************************************
c     calculate volumetric budget for recharge
c     ******************************************************************
c
c        specifications:
c     ------------------------------------------------------------------
      DOUBLE PRECISION RATIN,RATOUT,QQ
      common /rch2CF/ condfile 
      character*256 condfile  
      CHARACTER*16 VBNM(MSUM),TEXT
      dimension irch(ncol,nrow),rech(ncol,nrow),rlsd(ncol,nrow),
     +    rcond(ncol,nrow),ibound(ncol,nrow,nlay),buff(ncol,nrow,nlay),
     2          vbvl(4,msum) 
      data text /'        RECHARGE'/
c     ------------------------------------------------------------------
      zero = 1e-30
c
c1------clear the rate accumulators.
      ratin  = 0.
      ratout = 0.
c
c2------if cell-by-cell flow terms will be saved then clear the buffer.
      do il = 1,nlay
        do ir = 1,nrow
          do ic = 1,ncol
            buff(ic,ir,il)=0.
          enddo
        enddo
      enddo
c
      IBD=0
      IF(IRCHCB.GT.0) IBD=ICBCFL
c
c3------if nrchop=1 rech goes into layer 1. process each horizontal
c3------cell location.
      if(nrchop.eq.1) then
c
c     ---recharge is applied to top layer
        do ir = 1,nrow
          do ic = 1,ncol
c3a-----if cell is external then do not do budget for it.
            if(ibound(ic,ir,1).gt.0) then 
              q = rech(ic,ir)
              qq = q
c3b-----if cell-by-cell flow terms will be saved then add rech to buff
              buff(ic,ir,1)=q
c3c-----if rech positive add it to ratin else add it to ratout.
              if(q .gt. 0.000) then
                ratin = ratin  + qq
              else
                ratout= ratout - qq
              endif
            endif
          enddo  
        enddo  
c
c4------if nrchop=2 rech is in layer shown in indicator array(irch).
c4------process horizontal cell locations one at a time.
      elseif( nrchop .eq. 2 ) then
        do ir = 1,nrow
          do ic = 1,ncol
c4a-----get layer index from indicator array(irch).
            il=irch(ic,ir)
c4b-----if cell is external do not calculate budget for it.
            if(ibound(ic,ir,il).gt.0) then
              q=rech(ic,ir)
              qq = q
c4c-----if c-b-c flow terms will be saved then add recharge to buffer.
              buff(ic,ir,il) = q
c4d-----if recharge is positive add to ratin else add it to ratout.
              if(q .gt. 0.000) then
                ratin = ratin  + qq
              else
                ratout= ratout - qq
              endif
            endif
          enddo  
        enddo  
c
c5------if option=3 recharge is into highest internal cell. it will not
c5------pass through a constant head cell. process horizontal cell
c5------locations one at a time.
      else 
        do ir = 1,nrow
          do ic = 1,ncol
	      il = 0
	       k = 0   
c5a-----if cell is constant head move on to next horizontal location.
c5b-----if cell is inactive move down to next cell.
            do while( il.eq.0 .and. k.lt.nlay)
	        k = k + 1
              if( ibound(ic,ir,k).lt.0 ) il = -nlay
              if( ibound(ic,ir,k).gt.0 ) il = k
            enddo  
            if( il.gt.0 ) then
              q  = rech(ic,ir)
              qq = q
              buff(ic,ir,il) = q
c5d-----if rech is positive add it to ratin else add it to ratout.
              if( q .gt. 0.00 ) then
                ratin = ratin  + qq
              else 
                ratout= ratout - qq
              endif
            endif  
          enddo  
        enddo  
      endif  
c
c  Dump conductance and outlet head if iorchcond  > 0 
      if( iorchcond.gt.0 .and. ibd.gt.0 ) then
c   Count nodes 
	  ncnt = 0
        do il = 1,nlay
          do ir = 1,nrow
            do ic = 1,ncol
              if(ibound(ic,ir,il) .gt. 0 .and. 
     +           buff(ic,ir,il)   .lt. -zero) then 
                ncnt = ncnt + 1
              endif
            enddo  
          enddo  
        enddo  
c   Write to file 
        write(iorchcond,'(i10,30x,3hSP:,i8,3x,3hTS,i8)') ncnt,Kper,Kstp
        do il = 1,nlay
          do ir = 1,nrow
            do ic = 1,ncol
              if(ibound(ic,ir,il) .gt. 0 .and. 
     +           buff(ic,ir,il)   .lt. -zero) then 
                 write(iorchcond,'(3i10,2e10.4,20x,g13.5)') il,ir,ic,
     +             rlsd(ic,ir), rcond(ic,ir), buff(ic,ir,il) 
              endif
            enddo  
          enddo  
        enddo  
      endif 
c
c6------if c-b-c flow terms to be saved call ubudsv to write them.
      IF(IBD.EQ.1) CALL UBUDSV(KSTP,KPER,TEXT,IRCHCB,BUFF,NCOL,NROW,
     1                          NLAY,IOUT)
      IF(IBD.EQ.2) CALL UBDSV3(KSTP,KPER,TEXT,IRCHCB,BUFF,IRCH,NRCHOP,
     1                   NCOL,NROW,NLAY,IOUT,DELT,PERTIM,TOTIM,IBOUND)
c
c7------move total recharge rate into vbvl for printing by bas1ot.
      vbvl(4,msum)=ratout
      vbvl(3,msum)=ratin
c
c8------add recharge for time step to recharge accumulator in vbvl.
      vbvl(2,msum)=vbvl(2,msum)+ratout*delt
      vbvl(1,msum)=vbvl(1,msum)+ratin*delt
c
c9------move budget term labels to vbnm for print by module bas_ot.
      vbnm(msum) = text  
c
c10-----increment budget term counter.
      msum=msum+1
c
c11-----return
      return
      end
