c...........................................................................
c
      subroutine sgr1al(isum,lenx,lcsgr1,mxSGR1,nsgr1, in,iout,isgr2cb)
c
c----- SGR1 by K.J. Halford  10/12/2000
c     ******************************************************************
c     allocate array storage for specified gradient package
c     ******************************************************************
c
c        specifications:
c     ------------------------------------------------------------------
	dimension rn(25)
	character*256 txt 
c
c1------identify package and initialize nwell2
      write(iout,1)in
    1 format(/,1h0,'SGR1 -- Specified Gradient PACKAGE, VERSION 1,',
     +' 10/12/2000 INPUT READ FROM',i3)
      nsgr1=0
c
c2------read max number of wells and
c2------unit or flag for cell-by-cell flow terms.
      call ncread(in,txt,ierr)
	call caps(txt,256) 
c
      call qread(rn,2,txt,ierr)
      mxsgr1 = ifrl( rn(1) ) 
	isgr2cb = 0
      if(ierr.eq.0) isgr2cb = ifrl( rn(2) )
c
      write(iout,3) mxsgr1 
    3 format(1h ,'MAXIMUM OF',i5,' Specified Gradients')
      if(isgr2cb.gt.0) write(iout,9) isgr2cb
    9 format(1x, 'CELL-BY-CELL FLOWS WILL BE RECORDED ON UNIT', i3)
      if(isgr2cb.lt.0) write(iout,8)
    8 format(1x,'CELL-BY-CELL FLOWS WILL BE PRINTED WHEN ICBCFL NOT 0')
c
c3------set lcSGR1 equal to location of Spec. Grad list in x array.
      lcsgr1 = isum
c
c4------add amount of space used by Spec. Grad list to isum.
      isp  = 4 * mxsgr1
      isum = isum+isp
c
c5------print number of spaces in x array used by Spec. Grad package.
      write(iout,4) isp
    4 format(1x,i6,' ELEMENTS IN X ARRAY ARE USED FOR SGR1')
      isum1 = isum-1
      write(iout,5) isum1,lenx
    5 format(1x,i6,' ELEMENTS OF X ARRAY USED OUT OF',i8)
c
c6------if there isn'T ENOUGH SPACE IN THE X ARRAY THEN PRINT
c6------a warning message.
      if( isum1.gt.lenx ) write(iout,6)
    6 format(1x,'   ***X ARRAY MUST BE DIMENSIONED LARGER***')
c7------return
      return
      end
c
c...........................................................................
c
      subroutine SGR1rp(nsgr1,mxsgr1,SPgrd1,ibound,delr,delc,
     +  nodes,nrow,ncol,in,iout)
c
c----- SGR1 by K.J. Halford         10/12/2000
c     ******************************************************************
c     read new Specified gradients
c     ******************************************************************
c
c        specifications:
c     ------------------------------------------------------------------
      dimension SPgrd1(4,mxSGR1), ibound(nodes)
	dimension delr(ncol), delc(nrow) 
	dimension rn(25)
	character*256 txt
c 
c------------------------------------------------------------------
c     The 4 rows of the specified gradient array store:
c      Row #  = Description
c------------------------------------------------------------------
c         1   = Well node locator  
c         2   = Specified Gradient - X  
c         3   = Specified Gradient - Y  
c         4   = Simulated flow 
c------------------------------------------------------------------
c
c1------read itmp(number of wells or flag saying reuse Spec. Grad. data)
      call ncread(in,txt,ierr)
	call caps(txt,256) 
      call qread(rn,1,txt,ierr)
      itmp  = rn(1)  
	iprint = index(txt,'NO') 
c
      if( itmp.lt.0 ) then
c        if itmp less than zero reuse data. print message and return.
        write(iout,6)
    6   format(1h0,'REUSING SGR1  FROM LAST STRESS PERIOD')
        return													          
	endif
c  If itmp > 0,  Test if wells are to replace old ones or be added.  
c
      if( index(txt,'ADD').eq.0 ) nsgr1 = 0
c
c   return if there are no wells to read ........
      if( itmp .eq. 0 ) return
c
      nlay = nodes / ncol / nrow   
c
c   Read additional SP gradient info
      nv = 5
      nstart = nsgr1
      do m = 1, itmp 
        call ncread(in,txt,ierr)
        call caps(txt,256)
        if( index(txt,'XY').gt.0 ) then
          nv = 5
        elseif( index(txt,'X').gt.0 ) then
          nv = 4
          isxy = 5
        elseif( index(txt,'Y').gt.0 ) then
          nv = 4
          isxy = 4
        else  
        endif
c   Attempt read with QREAD first    
        call qread(rn,nv,txt,ierr)
        if( ierr.eq.0 .and. rn(nv+1).lt.0.5 ) then
          k2 = ifrl( rn(1) )
          j2 = ifrl( rn(2) )
          i2 = ifrl( rn(3) )
          if( nv.lt.5  ) then
            rn(5)    = rn(4)
            rn(isxy) = 0.0000000000000
          endif
          sgx2 = rn(4)  
          sgy2 = rn(5)  
        else
c  Use fixed form reader if errors were detected 
          read (txt(1:50),'(3i10,2f10.0)') k2, j2, i2, sgx2, sgy2
        endif
        if( k2 .gt. nlay ) k2 = nlay
        if( j2 .gt. nrow ) j2 = nrow
        if( i2 .gt. ncol ) i2 = ncol
c  IF CUBE is detected, interpolate and check over volume
        if( index(txt,'CUBE').gt.0 .and.nsgr1.gt.0 ) then
          n = SPgrd1(1,nsgr1)
          k1 = (n-1)/(ncol*nrow) + 1
          j1 = mod((n-1),ncol*nrow)/ncol + 1
          i1 = mod((n-1),ncol) + 1
          sgx1 = sgxlast
          sgy1 = sgylast
	    nsgr1 = nsgr1 - 1
        else
          k1 = k2
          j1 = j2
          i1 = i2
          sgx1 = sgx2
          sgy1 = sgy2
        endif
c    Identify XY coordinates of I1, J1  - I2, J2
        X1 = sumDX(i1, delr, ncol )
	  if( i1.ne.i2 ) then
          X2 = sumDX(i2, delr, ncol )
          DX = X2 - X1
          DsgYDX = (sgy2 - sgy1) / DX
        else
          DsgYDX = 0.00000
        endif
c
        Y1 = sumDY(j1, delc, nrow )
        if( j1.ne.j2 ) then
          Y2 = sumDY(j2, delc, nrow )
          DY = Y2 - Y1
          DsgXDY = (sgx2 - sgx1) / DY
        else
          DsgXDY = 0.00000
        endif
c    Process and find Specified gradient cells
        do i = i1, i2
          Xc = sumDX(i, delr, ncol )
          sgy = sgy1 + (Xc-X1)*DsgYDX
          do j = j1, j2
            Yc = sumDY(j, delc, nrow )
            sgx = sgx1 + (Yc-Y1)*DsgXDY
            do k = k1, k2
c  Test for if Specified gradient is on the edge of active grid .
              node = (k-1)*ncol*nrow + (j-1)*ncol + i
              iegX = iedgeX(node, ibound, nodes, ncol)
              iegY = iedgeY(node, ibound, nodes, ncol,nrow)
              if( iegX.gt.0 .or. iegY.gt.0 ) then
                nsgr1 = nsgr1 + 1
                SPgrd1(1,nsgr1) = node
                SPgrd1(2,nsgr1) = sgx * iegX  
                SPgrd1(3,nsgr1) = sgy * iegY 
              endif
            enddo   !   End of layer scan
          enddo   !   End of row scan
        enddo   !   End of column scan
        sgxlast = sgx2
        sgylast = sgy2
      enddo    !   end of Spec. Gradient entry loop
c
c  nwell2>mxSGR1.  print message. stop.
c
      if( nSGR1 .gt. mxSGR1) then 
        write(iout,99) nsgr1, mxSGR1
   99   format(1h0,'nSGR1(',i5,') IS GREATER THAN mxSGR1(',i5,')')
        stop
      endif
c
c   Echo input to iout file 
c
      if (iprint.eq.0) then 
        write (iout,'(1h0,10x,i4,19h Specified Gradient)') nsgr1
        write(iout,'(3x,4h No.,3x,3hLay,3x,3hRow,3x,3hCol,4x,
     +       9hSP Grad-X,4x,9hSP Grad-Y )')
        do m = 1, nsgr1  
	    n = SPgrd1(1,m)
          k = (n-1)/(ncol*nrow) + 1
          j = mod((n-1),ncol*nrow)/ncol + 1
          i = mod((n-1),ncol) + 1
c
          write (iout,'(1x,4i6,2(1x,g13.5))') 
     +      m, k,j,i, (SPgrd1(ii,m), ii = 2,3)
        enddo
      else
        write (iout,*) 'WELLS WILL NOT BE PRINTED'
	endif
c
      return
      end
c
c...........................................................................
c
      subroutine SGR1fm(nsgr1,mxsgr1,SPgrd1,ibound,delr,delc,cr,cc,
     +             rhs, ncol, nrow, nodes )
c
c----- SGR1 by K.J. Halford for use with MODOPTIM
c
c     ******************************************************************
c     add specified gradient flow to source term
c     ******************************************************************
c 
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      dimension SPgrd1(4,mxSGR1), ibound(nodes)  
	dimension delr(ncol), delc(nrow),cr(nodes),cc(nodes)
      dimension rhs(nodes)
	zero = 1.0E-20
c
c                 CR( i, j, k)    ------>   CR  i + 1/2      !! along X
c                 CC( i, j, k)    ------>   CC  j + 1/2	   !! along Y
c 
c1------if number of wells <= 0 then return.
      if(nsgr1.le.0) return
c
c2------process each specified gradient in the list.
c
      do m = 1, nsgr1
        n = ifrl( SPgrd1(1,m) )
c-----if the cell is inactive or specified then bypass processing.
        if( ibound(n).ne.0 ) then
          CX = CX2Cel(delr,cr,ncol,nodes,n)
          grdX = SPgrd1(2,m)
          QX  = CX * grdX
c
          CY = CY2Cel(delc,cc,ncol,nrow,nodes,n)
          grdY = SPgrd1(3,m)
          QY  = CY * grdY
c
          Qnet = QX + QY
          SPgrd1(4,m) = Qnet
c  Specify Q and solve for head;  add Q to RHS accumulator.
          rhs(n) = rhs(n) - Qnet
        endif
      enddo	 
c
      return
      end
c
c...........................................................................
c
      function CX2Cel(delr,cr,ncol,nodes,n)
c
c----- SGR1 by K.J. Halford  
c 
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
	dimension delr(ncol), cr(nodes)
c
      ix   = mod((n-1),ncol)+1 
      dx   = delr(ix)
	if( ix .lt. ncol ) then 
	  dxp = delr(ix+1)
        CX2CP = cr(n) * (dx+dxp) / 2
      endif
c
	if( ix .gt. 1  ) then
	  dxm = delr(ix-1)
        CX2CM  = cr(n-1) * (dx+dxm) / 2
      endif
c
      CX2Cel = CX2CP
      if( CX2CM.gt.CX2Cel ) CX2Cel = CX2CM 
c
      return
      end
c
c...........................................................................
c
      function CY2Cel(delc,cc,ncol,nrow,nodes,n)
c
c----- SGR1 by K.J. Halford  
c 
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
	dimension  delc(nrow), cc(nodes)
c
      iy   = mod((n-1),ncol*nrow)/ncol + 1
      dy   = delc(iy)
 	if( iy .lt. nrow ) then
	  dyp = delc(iy+1)
        CY2CP  = cc(n) * (dy+dyp) / 2
      endif
c
	if( iy .gt. 1 ) then
	  dym = delc(iy-1)
        CY2CM  = cc(n-ncol) * (dy+dym) / 2
      endif
c
      CY2Cel = CY2CP
      if( CY2CM.gt.CY2Cel ) CY2Cel = CY2CM 
c
      return
      end
c
c...........................................................................
c
      subroutine SGR1bd(nsgr1,mxSGR1,vbnm,vbvl,msum,delt,SPgrd1,ibound,
     +                  ncol,nrow,nodes,kstp,kper,isgr2cb,
     +                  icbcfl,buff,iout )
c
c----- SGR1 by K.J. Halford                 10/12/2000
c     ******************************************************************
c     calculate volumetric budget for specified gradient cells
c     ******************************************************************
c
c        specifications:
c     ------------------------------------------------------------------
      dimension vbvl(4,msum),SPgrd1(4,mxSGR1),ibound(nodes),buff(nodes)
      character*16 text,vbnm(msum)
c			----+----1----+-
      text = ' SPECIFIED GRAD.'
      zero = 1.E-25 
c     ------------------------------------------------------------------
c
c  clear ratin and ratout accumulators.
      ratin=0.
      ratout=0.
      ibd=0
c  clear the buffer.
      do n = 1, nodes
        buff(n)=0.000000000
      enddo 
c -----print the header for individual rates if requested(isgr2cb<0).
      if( isgr2cb.lt.0 .and. icbcfl.ne.0 ) then
        write(iout,'(/,1x,a16,9h PERIOD =,i5,8h  STEP =,i5)')
     +              text, kper,kstp
        write(iout,900)
      endif	 
  900 format(1x,6h Entry,5h  LAY,5h  ROW,5h  COL,8x,1hQ) 
  
c
c2------if there are no wells do not accumulate flow
      if(nsgr1.gt.0) then 
c
        do m = 1, nsgr1
          n = ifrl( SPgrd1(1,m) )
c
c    Report all wells with production less than the desired rate......
          if(ibound(n).ne.0) then 
 	      il = (n-1)/(ncol*nrow) + 1
	      ir = mod((n-1),ncol*nrow)/ncol + 1
            ic = mod((n-1),ncol) + 1
            q = SPgrd1(4,m)
c
c -----print the individual rates if requested(iwl2cb<0).
            if( isgr2cb.lt.0 .and. icbcfl.ne.0 ) then
              write(iout,'(1x,i6,3i5,6(1x,g13.5))')
     +         m,il,ir,ic, q 
            endif
c
            buff(n) = buff(n) + q
            if( q.ge.0.000 ) then
c -----pumping rate is positive(recharge). add it to ratin.
              ratin = ratin + q
            else 
c -----pumping rate is negative(discharge). add it to ratout.
              ratout = ratout - q
            endif
          endif
        enddo
c
        nlay = nodes / ncol / nrow   
c6------if cell-by-cell flows will be saved call ubudsv to record them
        if( isgr2cb.gt.0 .and. icbcfl.ne.0 ) then
          ioc = abs(isgr2cb) 
          call ubudsv(kstp,kper,text,ioc, buff,ncol,nrow,nlay,iout)
        endif 
      endif 
c
c7------move rates into vbvl for printing by module bas1ot.
      vbvl(3,msum)=ratin
      vbvl(4,msum)=ratout
c
c8------move rates times time step length into vbvl accumulators.
      vbvl(1,msum) = vbvl(1,msum) + ratin*delt
      vbvl(2,msum) = vbvl(2,msum) + ratout*delt
c
c9------move budget term labels into vbnm for printing.
      vbnm(msum) = text 
c
c10-----increment budget term counter(msum).
      msum = msum + 1
c
c11-----return
      return
      end
c
c-----------------------------------------------------------------------------
c
      integer function iedgeX(n, ibound, nodes, ncol )
      dimension ibound(nodes)
c
c     ******************************************************************
c    Does the node have an external face in the X direction (on a column face) 
c     ******************************************************************
c 
      iedgeX = 0
      if( ibound(n) .lt. 1 ) return
c 
	i = mod((n-1),ncol) + 1
	if( i.eq.1 .or. i.eq.ncol ) then
        iedgeX = 1
        return
	endif
c
      if( ibound(n-1).eq.0 .or. ibound(n+1).eq.0 ) iedgeX = 1
c
      return
      end
c
c-----------------------------------------------------------------------------
c
      integer function iedgeY(n, ibound, nodes, ncol,nrow)
      dimension ibound(nodes)
c
c     ******************************************************************
c    Does the node have an external face in the Y direction (on a row face) 
c     ******************************************************************
c 
      iedgeY = 0
      if( ibound(n) .lt. 1 ) return
c
      j = mod((n-1),ncol*nrow)/ncol + 1
      if( j.eq.1 .or. j.eq.nrow ) then
        iedgeY = 1
        return
      endif
c
      if( ibound(n-ncol).eq.0 .or. ibound(n+ncol).eq.0 ) iedgeY = 1
c
      return
      end
c
c-----------------------------------------------------------------------------
c
      function sumDX(ij, delr, ncol )
	dimension delr(ncol) 
c
c     ******************************************************************
c    Sum from node 1 center to point ij along a row (X)
c     ******************************************************************
c 
      sumDX = 0.00000000000
	do i = 2,ij
        sumDX = sumDX + delr(i-1) + delr(i)  
      enddo
c
      sumDX = sumDX * 0.5
c
      return
      end
c
c-----------------------------------------------------------------------------
c
      function sumDY(ij, delc, nrow )
	dimension  delc(nrow) 
c
c     ******************************************************************
c    Sum from node 1 center to point ij along a row (X)
c     ******************************************************************
c 
      sumDY = 0.00000000000
	do j = nrow-1,ij,-1
        sumDY = sumDY + delc(j+1) + delc(j)  
      enddo
c
      sumDY = sumDY * 0.5
c
      return
      end
c
