c                                                                       
      subroutine Trb1al(isum, lenx, lctrb1, mxtrb1, nturb1,
     +          lcretb,lcHKtb, mxreyn, nodes, itrbcb, in, iout)
C                                                                       
C-----VERSION 1.000 04-15-99
C
C     ******************************************************************
C     ALLOCATE ARRAY STORAGE FOR turbulent flow package
C     ******************************************************************
C                                                                       
C     SPECIFICATIONS:                                                   
C     ------------------------------------------------------------------
c     need to store index, cc0, cr0, cv0, ReqX, ReqY, ReqZ  per cell  
C     ------------------------------------------------------------------
C                                                                       
c     ------------------------------------------------------------------
	dimension rn(120)
	character*256 txt
c
c1------identify package and initialize nwell2
      write(iout,1) in
    1 format(/,1h0,'Trb1 -- Turbulent Flow Package, Version 1, 4/15/99',
     +' INPUT READ FROM',i3)
      nturb1=0
c
c2------read max number of tubulent nodes and
c2------unit or flag for printing reynolds numbers and permeability change.
c2------read maximum number of pairs in look-up table or default to 200
c 
      call ncread(in,txt,ierr)
c
      call qread(rn,3,txt,ierr)
      mxtrb1 = nodes
      if(ierr.le.2) mxtrb1 = ifrl( rn(1) ) 
	itrbcb = 0
      if(ierr.le.1) itrbcb = ifrl( rn(2) )
	mxreyn = 101
      if(ierr.eq.0) mxreyn = ifrl( rn(3) )
c
      write(iout,3) mxtrb1 
    3 format(1h ,'MAXIMUM OF',i6,' turbulent flow nodes')
      if(itrbcb.lt.0) write(iout,4)
    4 format(1x,'Turbulent flow changes will be printed when ',
     +           'ICBCFL is NOT 0')
      write(iout,5) mxreyn  
    5 format(1h ,'Maximum of',i4,' Reynolds # - relative K pairs')
c
c3------set lctrb1 equal to location of well list in x array.
      lctrb1 = isum
c
c4------add amount of space used by turb list to isum.
      isp  = 8 * mxtrb1
      isum = isum+isp
c  set aside 2 single precision arrays for the tubulent look-up table
	lcretb = isum 
      isp    = mxreyn
      isum   = isum + isp
	lcHKtb = isum 
      isp    = mxreyn
      isum   = isum + isp
c
      isp    = isum - lctrb1
c
c5------print number of spaces in x array used by well package.
      write(iout,6) isp
    6 format(1x,i7,' ELEMENTS IN X ARRAY ARE USED FOR TRB1')
      isum1 = isum - 1
      write(iout,7) isum1,lenx
    7 format(1x,i7,' ELEMENTS OF X ARRAY USED OUT OF',i8)
c
c6------if there isn'T ENOUGH SPACE IN THE X ARRAY THEN PRINT
c6------a warning message.
      if( isum1.gt.lenx ) write(iout,8)
    8 format(1x,'   ***X ARRAY MUST BE DIMENSIONED LARGER***')
c7------return
      return
      end
c
c...........................................................................
c
      subroutine Trb1rp(nturb1,mxtrb1,turb1,nretab,mxreyn,reytab,hktab,
     +          ibound,delr,delc,cr,cc,cv,nodes,nrow,ncol,in,iout)
c
c----- Trb1 by K.J. Halford   VERSION 1.000 04-15-99
c     ******************************************************************
c     read turbulent flow cells and specs
c     ******************************************************************
c
c        specifications:
c     ------------------------------------------------------------------
      dimension turb1(8,mxTrb1), ibound(nodes)
	dimension reytab(mxreyn), hktab(mxreyn)
	dimension delr(ncol),delc(nrow),cr(nodes),cc(nodes),cv(nodes)
	dimension rn(120)
	character*256 txt 
	data lookset, rhovis /0, 1.000/
	pi =  3.14159 
	zero = 1.e-25
      nxy = nrow * ncol
	nlay= nodes / nxy 
c 
c------------------------------------------------------------------
c     The 8 rows of the turb1 array store:
c      Row #  = Description
c------------------------------------------------------------------
c   1 = Well node locator  
c   2 = Laminar flow conductance along a row (X) cc0
c   3 = Laminar flow conductance along a column (Y) cr0
c   4 = Laminar flow conductance between layers (Z) cv0
c   5 = Shape factor for converting Q to Reynold's # along a row (X)
c   6 = Shape factor for converting Q to Reynold's # along a column (Y)
c   7 = Shape factor for converting Q to Reynold's # between layers (Z)
c   8 = work space
c     
c                 CR( i, j, k)    ------>   CR  i + 1/2
c                 CC( i, j, k)    ------>   CC  j + 1/2
c                 CV( i, j, k)    ------>   CV  k + 1/2
c------------------------------------------------------------------
c
c
c1------Compute or read reynold's number - relativity permeability pairs
c
      if( lookset.eq.0 ) then
	  lookset = 1
        call ncread(in,txt,ierr)
        call caps(txt,256) 
        ka = index(txt,'COMPUTE') 
        kb = index(txt,'ROUGH') 
c
	  if( ka.gt.0 .or. kb.gt.0 ) then
c   Compute look-up table with parameters
          nretab = mxreyn
          call qread(rn,2,txt,ierr)
          rough = 0.000
          if( ierr.le.1 ) rough  = rn(1) 
          reymax = 1.e7
          if( ierr.eq.0 ) reymax = rn(2) 
          call HKfill(reymax,reytab,hktab,rough,nretab,mxreyn)
        else
c   Read pairs directly
          nretab = 0
          do while( nretab.lt.mxreyn .and. ierr.eq.0 )
            call ncread(in,txt,ierr)
            call qread(rn,2,txt,ierr)
            if( ierr.eq.0 .and. rn(3).lt.0.5) then
              nretab = nretab + 1
	        reytab(nretab) = rn(1)
              hktab(nretab)  = rn(2)
            endif
	    enddo
        endif
c
c   Echo look-up table to iout file 
c
        txt =' The relative permeability look-up table contains'// 
     +     ' XXXXX values. '
	  ki = index(txt,'XXX')
        write(txt(ki:ki+4),'(i5)') nretab 
        write(iout,'(1h0,2x,a76)') txt
	  write(iout,
     +  '(/5x,6hEntry ,34h Reynold_#   Relative_Permeability)')
        write(iout,'(5x,i6,2x,f12.1,7x,f8.5)') 
     +            (i, reytab(i), hktab(i), i=1,nretab)
        write (iout,'(/, 70(1h-), /)')
c
c Read nodes that might experience turbulent flow and define shape factors
c
c    2 modes of input are available 
c
c  DIRECT entry of K, J, I, ReX,  ReY,  ReZ      (default)
c
c  RADIAL entry of K, J, I, SlotX, SlotY, SlotZ, porosity, Cell height (DELZ)
c
c   requires a one-shot entry of Rho, Vis  and model orientation (XY or XZ)
c
c          rho * v * slot       rho * Q * slot
c     Re = --------------  =  ------------------
c               Vis           Vis * A * porosity
c
c    Define input mode, fluid propeties and geometry 
c
        call ncread(in,txt,ierr)
        call caps(txt,256) 
c
c  Test how shape factors will be specified 
c
        if( index(txt,'RADIAL').gt.0 ) then
          irador = 8
          if( index(txt,'XY').gt.0 )  irador = -8
          call qread(rn,2,txt,ierr)
          if( ierr.eq.0 ) then
            rhovis = rn(1) / rn(2)	  
          else
            write(iout,*)'  Fluid properties were not defined in TRB1'
            stop '  Fluid properties were not defined in TRB1'
          endif
        else
          irador = 6
        endif
        nrd = abs( irador )
	endif
c1------read itmp(number of turb nodes or flag saying reuse turb data)
c
      call ncread(in,txt,ierr)
	call caps(txt,256) 
      call qread(rn,1,txt,ierr)
      itmp  = ifrl( rn(1) ) 
c
      if( itmp.lt.0 ) then
c        if itmp less than zero reuse data. print message and return.
        write(iout,6)
    6   format(1h0,'REUSING Turb nodes FROM LAST STRESS PERIOD')
        return													          
	else
c
c  If itmp > 0,  Test if wells are to replace old ones or be added.  
c
        if( index(txt,'ADD')   .eq.0   .and. 
     +      index(txt,'UPDATE').eq.0  )      nturb1 = 0
c
c   return if there are no wells to read ........
        if( itmp .eq. 0 ) return
        nchg = 0
c
c   Read additional turbulent node info
        do m = 1, itmp 
c   Read additional well info
          call ncread(in,txt,ierr)
          call caps(txt,256)
          call qread(rn,nrd,txt,ierr)
c
c    Stop if error encountered in reading data
          if( ierr.gt.0 .or. rn(nrd+1).gt.0.5 ) then
	      write(*,*)'  Error reading entry:', m
	      stop' Error in reading turbulent cell data'
          endif
c
          if( index(txt,'CUBE').gt.0 ) then
            k2 = ifrl( rn(1) )
            j2 = ifrl( rn(2) )
            i2 = ifrl( rn(3) )
            if( k2 .gt. nlay ) k2 = nlay
            if( j2 .gt. nrow ) j2 = nrow
            if( i2 .gt. ncol ) i2 = ncol
          else 
            k1 = ifrl( rn(1) )
            j1 = ifrl( rn(2) )
            i1 = ifrl( rn(3) )
            k2 = k1
            j2 = j1
            i2 = i1
          endif
c
          do k = k1, k2
            do j = j1, j2
              do i = i1, i2
                node = (k-1)*nxy + (j-1)*ncol + i
c Test if turbulent node is in active grid ......
                iok = 1
                if(i.gt.ncol .or. j.gt.nrow .or. node.gt.nodes) iok = 0
                if( iok .gt. 0 ) iok = ibound(node)
                if( iok .gt. 0 ) then
c Set pointer -- multiple locations are not allowed
                  ipt = 0
                  do mm = 1, nturb1
                    ndprev = ifrl( turb1(1,mm) )  
                    if( node .eq. ndprev ) ipt = mm 	 
                  enddo
                  if( ipt.eq.0 ) then
	              nturb1 = nturb1 + 1
	              ipt    = nturb1
                    turb1(1,ipt) = node 
                  endif
c Assign data now that the pointer is set 
                  if( irador.eq.6 ) then     ! Direct entry of shape factors
                    turb1(5,ipt) = rn(4)   
                    turb1(6,ipt) = rn(5)    
                    turb1(7,ipt) = rn(6)    
                  else
	              poro = rn(7) 
	              delz = rn(8) 
	              radx = 0.000
                    do mad = 1, i
                      radx = radx + delr(mad)
                    enddo 
	              radyz = radx - delr(i)*0.5  
                    b = delz
                    if( irador.lt.0 )  b = delc(j) 
                    AreaX  = 2 * pi * radx * b * poro
                    AreaYZ = 2 * pi * radyz * delr(i) * poro
                    turb1(5,ipt) = rhovis * rn(4) / AreaX   
                    turb1(6,ipt) = rhovis * rn(5) / AreaYZ      
                    turb1(7,ipt) = rhovis * rn(6) / AreaYZ          
c
                    nchg = nchg + 1
                    turb1(8,nchg) = ipt
                  endif   !   End of Shape factor assignment
	          endif   !   End of IBOUND check  
              enddo   !   End of column scan
            enddo   !   End of row scan
          enddo   !   End of layer scan
        enddo   !   End of nturb1 loop
c
c  nturb1 > mxTrb1.  print message. stop.
        if( nturb1 .gt. mxtrb1) then 
          write(iout,99) nturb1, mxtrb1
   99     format(1h0,'nturb1(',i6,') IS GREATER THAN mxTrb1(',i6,')')
          stop
        endif
c
c  define node and laminar conductances for all nodes 
c This is external to input loop to reset values potentially changed by VAR1
c
        do ipt = 1, nturb1
          node = ifrl( turb1(1,ipt) )
          turb1(2,ipt) = cr(node) 
          turb1(3,ipt) = cc(node) 
          turb1(4,ipt) = cv(node) 
        enddo
c
c   Echo input to iout file 
c
        write (iout,'(1h0,10x,i4,6h TURB1)') nturb1
        write(iout,101)
  101   format(3x, 4h No., 3x, 3hLay, 3x, 3hRow, 3x, 3hCol, 4x, 
     +   7h CR0-X , 7x, 7h CR0-Y , 7x, 7h CR0-Z , 7x, 
     +   7hShape-X, 7x, 7hShape-Y, 7x, 7hShape-Z )
c
c        do nn = 1, nchg
c	    m = ifrl( turb1(8,nn) )
        do m = 1, nturb1
          n = turb1(1,m)
          k = (n-1)/nxy + 1
          j = mod((n-1),nxy)/ncol + 1
          i = mod((n-1),ncol) + 1
c
          write (iout,'(1x, 4i6, 6(2x, g12.4))' )
     +           m, k,j,i, (turb1(ii,m), ii = 2,7)
        enddo
      endif
c
      return
      end
c
c...........................................................................
c
      function reyeql(rough)
c
c   ******************************************************************
c  find reynolds number where tubulent and laminar friction factors are =
c   ******************************************************************
c
      root = 1000.0**0.5
c
      do i = 1, 10
	  root = -16*alog10(rough+1.255/4/root)
      enddo 
	reyeql = root**2
c
      return
      end
c
c...........................................................................
c
      subroutine HKfill(reymax,reytab,hktab,rough,nretab,mxreyn)
c
c     ******************************************************************
c    Define relative permeability as a function of Reynolds number
c     ******************************************************************
c 
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
	dimension reytab(mxreyn), hktab(mxreyn)
c
      reymin    = reyeql(rough)
      reytab(1) = reymin
      hktab(1)  = 1.000000
c
	relgmn = alog10(reymin)
      dre = alog10(reymax/reymin) / (nretab - 1)
c
      do i = 2, nretab
	  Re = relgmn + dre*(i-1)
        Re = 10**Re
	  reytab(i) = Re
c   
c    Compute friction factor for Laminar flow
c   
	  flam = 16 / Re 
c   
c    Compute friction factor for Turbulent flow
c   
        fturb = flam
        do jj = 1, 10
	    fturb = -4*alog10(rough + 1.255/(Re*fturb**0.5) ) 
	    fturb = 1 /fturb**2
        enddo 
c   
c    Define relative permability function 
c   
        hktab(i) = ( flam / fturb )**0.5  
      enddo
c
      return
      end
c
c...........................................................................
c
      subroutine Trb1fm(nturb1,mxtrb1,turb1,nretab, mxreyn,reytab,
     +       hktab, ibound, cr,cc,cv,hnew, nodes,nrow,ncol, iout)
c
c----- Trb1 by K.J. Halford   VERSION 1.000 04-15-99
c     ******************************************************************
c     adjust conductance terms to correct for turbulence 
c     ******************************************************************
c 
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      dimension turb1(8,mxTrb1), ibound(nodes)
	dimension reytab(mxreyn), hktab(mxreyn)
	dimension cr(nodes),cc(nodes),cv(nodes)
	dimension hnew(nodes)
      double precision hnew
	zero = 1.0E-25
c  Dummy entry to use iout in list of formal arguments 
	nxy = iout
      nxy = nrow * ncol
	nlay= nodes / nxy 
	idum = iout
c
c                 CR( i, j, k)    ------>   CR  i + 1/2
c                 CC( i, j, k)    ------>   CC  j + 1/2
c                 CV( i, j, k)    ------>   CV  k + 1/2
c 
c1------if number of turbulent cells <= 0 then return.
      if(nturb1.le.0) return
c
c   Update conductances for each tubulent flow node
c
      do m = 1, nturb1 
        n = ifrl( turb1(1,m) )
        k = (n-1)/nxy + 1
        j = mod((n-1),nxy)/ncol + 1
        i = mod((n-1),ncol) + 1
c-----if the cell is inactive then bypass processing.
        if( ibound(n).ne.0 ) then
	    if(i.lt.ncol .and. ibound(n+1).ne.0  ) then
            Re = cr(n) * abs(hnew(n+1)-hnew(n)) * turb1(5,m)
            HK = HKrel(Re,reytab,hktab,nretab,mxreyn)
            cr(n)= turb1(2,m) * HK
          endif
c
	    if(j.lt.nrow .and. ibound(n+ncol).ne.0 ) then
            Re = cc(n) * abs(hnew(n+ncol)-hnew(n)) * turb1(6,m)
            HK = HKrel(Re,reytab,hktab,nretab,mxreyn)
            cc(n)= turb1(3,m) * HK
          endif
c
	    if(k.lt.nlay .and. ibound(n+nxy).ne.0 ) then
            Re = cv(n) * abs(hnew(n+nxy)-hnew(n)) * turb1(7,m)
            HK = HKrel(Re,reytab,hktab,nretab,mxreyn)
            cv(n)= turb1(4,m) * HK
          endif
        endif
      enddo
c
      return
      end
c
c...........................................................................
c
      function HKrel(reyn,reytab,hktab,nretab,mxreyn)
c
c     ******************************************************************
c    Look-up relative permeability as a function of Reynolds number
c     ******************************************************************
c 
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
	dimension reytab(mxreyn), hktab(mxreyn)
c
      if(reyn .lt. reytab(1) ) then
	  hkrel = 1.0000
	else
	  n = 1 
	  do while( reyn.gt.reytab(n) .and. n.lt.nretab )
	    n = n + 1
        enddo
        HKrel = yinterp(reyn,reytab(n-1),reytab(n),HKtab(n-1),HKtab(n))
      endif
c
      return
      end
c
c...........................................................................
c
      function yinterp(xinp, x1,x2, y1,y2)
c
      zero = 1.e-30
c
c     ******************************************************************
c        interpolate a value
c     ******************************************************************
c
       
      if( xinp .le. x1 )then
	  yinterp = y1
      elseif( xinp .ge. x2 )then
	  yinterp = y2
	else
	  dx = x2 - x1
	  dy = y2 - y1
	  if( abs(dx).lt.zero )then
          yinterp = y1 + dy*0.5
	  else
	    slp = dy / dx
          yinterp = y1 + ( xinp - x1 ) * slp
        endif 
      endif
c
      return
      end
c
c...........................................................................
c
      subroutine Trb1BD(itrbcb,nturb1,mxtrb1,turb1,nretab,mxreyn,
     + reytab,hktab, ibound, cr,cc,cv,hnew,icbcfl,nodes,nrow,ncol,iout)
c
c----- Trb1 by K.J. Halford   VERSION 1.000 04-15-99
c     ******************************************************************
c   Print the reynolds # & Relative permeability of the Turbulent cells 
c     ******************************************************************
c 
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      dimension turb1(8,mxTrb1), ibound(nodes)
      dimension reytab(mxreyn), hktab(mxreyn)
      dimension cr(nodes),cc(nodes),cv(nodes)
      dimension hnew(nodes)
      double precision hnew
      zero = 1.0E-25
c   Dummy entry to use iout in list of formal arguments 
      nxy = iout
      nxy = nrow * ncol
      nlay= nodes / nxy 
      idum = iout
c
c                 CR( i, j, k)    ------>   CR  i + 1/2
c                 CC( i, j, k)    ------>   CC  j + 1/2
c                 CV( i, j, k)    ------>   CV  k + 1/2
c 
c1------if number of turbulent cells <= 0 then return.
      if(nturb1.le.0 ) return
c
      if( itrbcb.ge.0 .or. icbcfl.eq.0 ) return
c
c   write tubulent flow header 
c
      write (iout,'(/,1h0,10x,i4,6h TURB1)') nturb1
      write(iout,101)
  101 format(4x,4h No., 3x, 3hLay,2x,3hRow,2x,3hCol,
     + 7x,4hRe-X,2x,4hHK-X, 7x,4hRe-Y,2x,4hHK-Y, 7x,4hRe-Z,2x,4hHK-Z)
c
c   Update conductances for each tubulent flow node
c
      do m = 1, nturb1 
        n = ifrl( turb1(1,m) )
        k = (n-1)/nxy + 1
        j = mod((n-1),nxy)/ncol + 1
        i = mod((n-1),ncol) + 1
c-----if the cell is inactive then bypass processing.
        if( ibound(n).ne.0 ) then
	    if(i.lt.ncol .and. ibound(n+1).ne.0  ) then
            Rex = cr(n) * abs(hnew(n+1)-hnew(n)) * turb1(5,m)
            HKx = HKrel(Rex,reytab,hktab,nretab,mxreyn)
          endif
c
	    if(j.lt.nrow .and. ibound(n+ncol).ne.0 ) then
            Rey = cc(n) * abs(hnew(n+ncol)-hnew(n)) * turb1(6,m)
            HKy = HKrel(Rey,reytab,hktab,nretab,mxreyn)
          endif
c
	    if(k.lt.nlay .and. ibound(n+nxy).ne.0 ) then
            Rez = cv(n) * abs(hnew(n+nxy)-hnew(n)) * turb1(7,m)
            HKz = HKrel(Rez,reytab,hktab,nretab,mxreyn)
          endif
          write (iout,'(1x,i7,3i5, 3x, 3(f10.0,f6.3,1x))')
     +            m, k,j,i, Rex,HKx, Rey,HKy, Rez,HKz  
        endif
      enddo
c
      return
      end
c
c...........................................................................
c
      subroutine Trb1PS(nturb1,mxtrb1,turb1, cr,cc,cv, nodes, iout)
c
c----- Trb1 by K.J. Halford   VERSION 1.000 04-15-99
c     ******************************************************************
c    RESET conductance terms after SP 
c     ******************************************************************
c 
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      dimension turb1(8,mxTrb1)
	dimension cr(nodes),cc(nodes),cv(nodes)
c  Dummy entry to use iout in list of formal arguments 
	idum = iout
c
c1------if number of turbulent cells <= 0 then return.
      if(nturb1.le.0) return
c
c   Update conductances for each tubulent flow node
c
      write(iout,*)  ' TURB1 ------- ', nturb1 
      do m = 1, nturb1 
        n = ifrl( turb1(1,m) )
	  write(iout,'(1x,6h RESET,i5,i6,3(2x,g10.3,2h >,g10.3))') 
     +  m,n, cr(n),turb1(2,m), cc(n),turb1(3,m), cv(n),turb1(4,m)
        cr(n)= turb1(2,m)
        cc(n)= turb1(3,m)
        cv(n)= turb1(4,m) 
      enddo
c
      return
      end
c
