      SUBROUTINE var1AL(ISUM,LENX,MXvar,IN,IOUT)
C                                                                       
C-----VERSION 1.000 12-14-96
C
C     ******************************************************************
C     ALLOCATE ARRAY STORAGE FOR time dependent changes in conductance
c     and storage ............
C     ******************************************************************
C                                                                       
C     SPECIFICATIONS:                                                   
C     ------------------------------------------------------------------
C     ------------------------------------------------------------------
C                                                                       
C1------IDENTIFY PACKAGE AND INITIALIZE # OF BCF Cells........
      WRITE(IOUT,1)                                                     
    1 FORMAT(1H0,'var1 -- var PACKAGE, VERSION 1, 12/14/96')              
      Nvars=0                                                          
C                                                                       
C2------READ AND PRINT MXBND AND IvarCB (MAX # OF BOUNDS AND UNIT       
C2------FOR CELL-BY-CELL FLOW TERMS FOR var)                            
      READ(IN,'(i10)') MXvar
      WRITE(IOUT,3) MXvar
    3 FORMAT(1H ,'MAXIMUM OF',I6,' BCF properties can be updated.')      
c
      ISP = 0                                                     
      ISUM = ISUM+ISP                                                     
C                                                                       
C5------PRINT AMOUNT OF SPACE USED BY THE var PACKAGE                   
      WRITE(IOUT,4) ISP                                                 
    4 FORMAT(1X,I5,' ELEMENTS IN X ARRAY ARE USED FOR time-dependent',            
     1      ' BCF updates.') 
      ISUM1 = ISUM-1                                                      
      WRITE(IOUT,5) ISUM1,LENX                                          
    5 FORMAT(1X,I6,' ELEMENTS OF X ARRAY USED OUT OF',I7)               
      IF(ISUM1.GT.LENX) WRITE(IOUT,6)                                   
    6 FORMAT(1X,'   ***X ARRAY MUST BE DIMENSIONED LARGER***')          
C                                                                       
C6------RETURN                                                          
      RETURN                                                            
      END                                                               
c...............................................................................
c
      SUBROUTINE var1RP(mxvar,IBOUND,SC1,HY,CR,CC,CV,
     +           BOT,TOP,SC2,SCE,SCV,ioIBS,ISS,NCOL,NROW,NLAY,in,iout)
C
C-----VERSION 1.000 12-14-96
C
C     ******************************************************************
C     READ AND MODIFY BLOCK-CENTERED FLOW PACKAGE  DATA BY STRESS PERIOD
C     ******************************************************************
C
c     Explain intent of package and mechanics of operation  
c
c    The following arrays can be modified:    
c                 CR( i, j, k)    ------>   CR  i + 1/2
c                 CC( i, j, k)    ------>   CC  j + 1/2
c                 CV( i, j, k)    ------>   CV  k + 1/2
c      HY, BOT, TOP, SC1, SC2  are block centered values
c
c    Specify quantity to vary using the following keys ......
c      data  keys/'X-??','Y-??','Z-??','XY-?','YZ-?','XZ-?','XYZ-',
c	+           'HY??','BOT?','SC1?','SC2?','TOP?'/
c
c    Default assumption is to modify value by multiplication, unless the 
c   identifier 'REPLACE'  is on the line...............
c
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      DIMENSION SC1(NCOL,NROW,NLAY),HY(NCOL,NROW,NLAY),
     +   CR(NCOL,NROW,NLAY),CC(NCOL,NROW,NLAY),CV(NCOL,NROW,NLAY),
     +   BOT(NCOL,NROW,NLAY),TOP(NCOL,NROW,NLAY),
     +   SCE(NCOL,NROW,NLAY),SCV(NCOL,NROW,NLAY),
     +   SC2(NCOL,NROW,NLAY),IBOUND(NCOL,NROW,NLAY)
	dimension    nvkey(14), Kdex(200)
	character*4   keys(14) 
	character*10  action
	character*128 txt
      COMMON /FLWCOM/LAYCON(200)
      COMMON /IBSCOM/ IBQ(200)
C     ------------------------------------------------------------------
      data nvkey/2,2,2,3,3,3,4,2,3,3,3,3,3,3/
      data keys/'X-??','Y-??','Z-??','XY-?','XZ-?','YZ-?','XYZ-',
     +          'HY??','BOT?','SC1?','SC2?','TOP?','SCV?','SCE?'/ 
      ibdum = ibound(1,1,1) 
C                                                                       
C1------READ ITMP(# OF HEAD updates OR FLAG TO REUSE DATA.)      
      READ(IN,'(i10)') ITMP
C                                                                       
C2------TEST ITMP                                                       
      IF(ITMP.lt.0) then                                           
C                                                                       
C2A-----IF ITMP<0 THEN REUSE DATA FROM LAST STRESS PERIOD               
        WRITE(IOUT,7)                                                     
    7   FORMAT(1H0,'REUSING BCF-updates FROM LAST STRESS',      
     1      ' PERIOD')                                                  
      else 
C                                                                       
C3------IF ITMP=>0 THEN IT IS THE # OF HYDRAULIC PROPERTIES           
        Nvars = ITMP                                                       
C                                                                       
C4------IF MAX NUMBER OF BCF values IS EXCEEDED THEN STOP                   
        if( nvars .gt. mxvar ) then
          WRITE(IOUT,99) Nvars,MXvar                                       
   99     FORMAT(1H0,'NBOUND(',I4,') IS GREATER THAN MXvar(',I4,')')        
C                                                                       
C4A-----ABNORMAL STOP                                                   
          STOP'  Abnormal Stop!!!!!!!'
        endif
C                                                                       
C5------PRINT # OF BCF Nodes altered THIS STRESS PERIOD               
        WRITE(IOUT,1) nvars
    1   FORMAT(1H0,//1X,I6,' TIME-DEPENDENT BCF NODES') 
C                                                                       
C6------IF THERE ARE NO HYDRAULIC PROPERTIES THEN RETURN.                
        IF(nvars.EQ.0) return                                         
C                                                                       
C7------READ, modify, & echo BCF info to main output file 
        WRITE(IOUT,3)                                                     
    3   FORMAT(1H0,1X,'LAYER',5X,'ROW',5X                                
     1,'COL      OLD VAL      NEW       BOUND NO.'/1X,15X,60('-'))      
        DO II = 1, nvars   
          READ (IN,'(a128)') txt
   	    call caps( txt, 128 )
	    ireplc = index(txt,'REPLACE') 
          if( index(txt,'CUBE') .gt. 0 ) then
            READ (txt,'(3I10,F10.0)') K2,I2,J2
            if( k2 .gt. nlay ) k2 = nlay
            if( i2 .gt. nrow ) i2 = nrow
            if( j2 .gt. ncol ) j2 = ncol
          else 
            READ (txt,'(3I10,F10.0)') K1,I1,J1,rmodfy
            READ (txt,'(3I10,F10.0)') K2,I2,J2
	      icho = 0
   	      action = txt(41:50)
	      do nop = 1, 14
	        if( index(action,keys(nop)(1:nvkey(nop))).gt.0 ) then
	          icho = nop
	        endif
	      enddo
            if( ii .lt. nvars ) then
              READ (IN,'(a128)') txt
              if( index(txt,'CUBE') .gt. 0 ) k2 = k1 - 1
              backspace( in )
            endif
          endif
c
          do k = k1, k2
            do i = i1, i2
              do j = j1, j2
                if(     icho.eq.1 ) then
	            varold = cr(j,i,k)  
                  varnew =  vnew(varold, rmodfy, ireplc ) 
	            cr(j,i,k) =  varnew
	          elseif( icho.eq.2 ) then
	            varold = cc(j,i,k)  
                  varnew =  vnew(varold, rmodfy, ireplc ) 
	            cc(j,i,k) = varnew
	          elseif( icho.eq.3 ) then
	            varold = cv(j,i,k)  
                  varnew =  vnew(varold, rmodfy, ireplc ) 
	            cv(j,i,k) = varnew
	          elseif( icho.eq.4 ) then
	            varold = cr(j,i,k)  
                  varnew =  vnew(varold, rmodfy, ireplc ) 
	            cr(j,i,k) = varnew
  	            action(10:10) = 'X'
                  WRITE (IOUT,'(1x,I4,I9,I8,G13.4,G14.4,I8,a10)') 
     +               K,I,J,varold,varnew,II,action                     
	            varold = cc(j,i,k)  
                  varnew =  vnew(varold, rmodfy, ireplc ) 
	            cc(j,i,k) = varnew
  	            action(10:10) = 'Y'
	          elseif( icho.eq.5 ) then
	            varold = cr(j,i,k)  
                  varnew =  vnew(varold, rmodfy, ireplc ) 
	            cr(j,i,k) = varnew
  	            action(10:10) = 'X'
                  WRITE (IOUT,'(1x,I4,I9,I8,G13.4,G14.4,I8,a10)') 
     +               K,I,J,varold,varnew,II,action                     
	            varold = cv(j,i,k)  
                  varnew =  vnew(varold, rmodfy, ireplc ) 
	            cv(j,i,k) = varnew
  	            action(10:10) = 'Z'
	          elseif( icho.eq.6 ) then
	            varold = cc(j,i,k)  
                  varnew =  vnew(varold, rmodfy, ireplc ) 
	            cc(j,i,k) = varnew
  	            action(10:10) = 'Y'
                  WRITE (IOUT,'(1x,I4,I9,I8,G13.4,G14.4,I8,a10)') 
     +                 K,I,J,varold,varnew,II,action                     
	            varold = cv(j,i,k)  
                  varnew =  vnew(varold, rmodfy, ireplc ) 
	            cv(j,i,k) = varnew
  	            action(10:10) = 'Z'
	          elseif( icho.eq.7 ) then
	            varold = cr(j,i,k)  
                  varnew =  vnew(varold, rmodfy, ireplc ) 
	            cr(j,i,k) = varnew
  	            action(10:10) = 'X'
                  WRITE (IOUT,'(1x,I4,I9,I8,G13.4,G14.4,I8,a10)') 
     +                 K,I,J,varold,varnew,II,action                     
	            varold = cc(j,i,k)  
                  varnew =  vnew(varold, rmodfy, ireplc ) 
	            cc(j,i,k) = varnew
  	            action(10:10) = 'Y'
                  WRITE (IOUT,'(1x,I4,I9,I8,G13.4,G14.4,I8,a10)') 
     +                 K,I,J,varold,varnew,II,action                     
	            varold = cv(j,i,k)  
                  varnew =  vnew(varold, rmodfy, ireplc ) 
	            cv(j,i,k) = varnew
  	            action(10:10) = 'Z'
	          elseif( icho.eq.8 ) then
	            kk = Kspecial(k,icho)
	            varold = hy(j,i,kk)  
                  varnew =  vnew(varold, rmodfy, ireplc ) 
	            hy(j,i,kk) = varnew
	          elseif( icho.eq.9 ) then
	            kk = Kspecial(k,icho)
	            varold = bot(j,i,kk)  
                  varnew =  vnew(varold, rmodfy, ireplc ) 
	            bot(j,i,kk) = varnew
	          elseif( icho.eq.10 .and. iss.eq.0 ) then
	            kk = Kspecial(k,icho)
	            varold = sc1(j,i,kk)  
                  varnew =  vnew(varold, rmodfy, ireplc ) 
	            sc1(j,i,kk) = varnew
	          elseif( icho.eq.11 .and. iss.eq.0 ) then
	            kk = Kspecial(k,icho)
	            varold = sc2(j,i,kk)  
                  varnew =  vnew(varold, rmodfy, ireplc ) 
	            sc2(j,i,kk) = varnew
	          elseif( icho.eq.12) then
	            kk = Kspecial(k,icho)
	            varold = top(j,i,kk)  
                  varnew =  vnew(varold, rmodfy, ireplc ) 
	            top(j,i,kk) = varnew
	          elseif( icho.eq.13 .and. iss.eq.0 .and. ioIBS.gt.0 ) then
	            kk = Kspecial(k,icho)
	            varold = scV(j,i,kk)  
                  varnew =  vnew(varold, rmodfy, ireplc ) 
	            scV(j,i,kk) = varnew
	          elseif( icho.eq.14 .and. iss.eq.0 .and. ioIBS.gt.0 ) then
	            kk = Kspecial(k,icho)
	            varold = scE(j,i,kk)  
                  varnew =  vnew(varold, rmodfy, ireplc ) 
	            scE(j,i,kk) = varnew
	          else
	          endif
                WRITE (IOUT,'(1x,I4,I9,I8,G13.4,G14.4,I8,a10)') 
     +                 K,I,J,varold,varnew,II,action                     
              enddo   !   End of column scan
            enddo   !   End of row scan
          enddo   !   End of layer scan
        enddo   !   End of nvars loop
      endif
c
C8------RETURN                                                          
      RETURN                 
	end                                           
c .......................................................................
c
      function vnew(vold,rmod,irep)
c
      vnew = vold * rmod 
      if( irep.gt.0 ) vnew = rmod 
      return
	end
c .......................................................................
c
      subroutine caps(a1,n)
      character*1 lc(26), uc(26)
      character*2048  a1
      data lc /'a','b','c','d','e','f','g','h','i','j','k','l','m','n',
     .         'o','p','q','r','s','t','u','v','w','x','y','z'/
      data uc /'A','B','C','D','E','F','G','H','I','J','K','L','M','N',
     .         'O','P','Q','R','S','T','U','V','W','X','Y','Z'/
	do i=1,n
        j = 0
        do while( j.lt.26 )
          j = j + 1
          if( a1(i:i).eq.lc(j) ) then 
            a1(i:i) = uc(j)
	      j = 26
          endif
        enddo
      enddo
c
      return
      end
c .......................................................................
c
      integer function Kspecial(k,icho)
      COMMON /FLWCOM/LAYCON(200)
      COMMON /IBSCOM/ IBQ(200)
c
      Kspecial = 0
      if( icho.eq.8 .or. icho.eq.9 ) then         !!! HY OR BOTTOM 
        do i =1,k
          IF(LAYCON(i).eq.1 .or. LAYCON(i).eq.3) Kspecial = Kspecial + 1
        enddo
      elseif( icho.eq.11 .or. icho.eq.12 ) then    !!  SC2 or TOP
C6B-----IF LAYER IS CONF/UNCONF MULTIPLY SECONDARY STORAGE COEFFICIENT
        do i =1,k
          IF(LAYCON(i).eq.3 .or. LAYCON(i).eq.2) Kspecial = Kspecial + 1
        enddo
	elseif( icho.eq.13 .or. icho.eq.14 ) then  !!  IBS layering
        do i =1,k
          IF( IBQ(i).gt.0 ) Kspecial = Kspecial + 1
        enddo
	else
	  Kspecial = k
	endif
c
      return
      end
